TAB_NORMAL = 0;
TAB_MOVING = 1;

TAB_STATE_AUTO_SLIDE = 1;
TAB_STATE_FOLLOW_FINGER = 2;
TAB_STATE_STOPING = 3;
TAB_STATE_STOP = 4;

ListGroupControl =
{
	Properties = {
		Margin = 12;
		BkGround = "";
		HorzScroll = true;
		Speed = 2;
		YOffset = 0;
	};

	m_object;
	m_state = TAB_NORMAL;
	m_slide_state = TAB_STATE_STOP;

	m_DownX = 0;
	m_DownY = 0;
	m_OldScrollX = 0;
	m_OldScrollY = 0;

	m_ScrollLimitX = 0;
	m_ScrollLimitY = 0;

	m_DesireScrollPos = 0;
	m_OldScrollPos = 0;
	m_fVelocity = 0;
	m_fMaxSpeed = 10000;
	m_fDeltaTime = 0;
	m_fMaxTime = 0;

	m_fMargin = 0;
	m_fPageSize = 0;

	m_fBeginTime = 0;
	m_fFirstMove = false;
}

function ListGroupControl:CalcLayout()
	local size = self.m_object:GetChildCount();

	self.m_fChildTotalSize = 0;
	self.m_fTotalSize = 0;
	self.m_DesireScrollPos = 0;

	local left = -self.m_object:GetClientWidth() * 0.5;
	local top = self.m_object:GetClientHeight() * 0.5;

	self.m_fMargin = self.Properties.Margin;

	self.m_fPageSize = self.m_fPageSize + self.m_fMargin * 2;

	local i = 0;

	self.m_ScrollLimitX = 0;
	self.m_ScrollLimitY = 0;

	local scroll = 0;
	local scale = 1.0;

	if self.Properties.HorzScroll == true then
		scale = self.m_object:GetWidth() / self.m_object:GetClientWidth();
	else
		scale = self.m_object:GetHeight() / self.m_object:GetClientHeight();
	end

	while i < size do
		local ctrl = self.m_object:GetControl(i);

		if ctrl:IsVisible() == true then
			self.m_ScrollLimitX = self.m_ScrollLimitX + self.m_fMargin * scale;
			self.m_ScrollLimitY = self.m_ScrollLimitY + self.m_fMargin * scale;

			scroll = scroll + self.m_fMargin;
			if self.Properties.HorzScroll == true then
				ctrl:SetClientPos( scroll + ctrl:GetClientWidth() * 0.5 + left, self.Properties.YOffset );
				scroll = scroll + ctrl:GetClientWidth() + self.m_fMargin;
			else
				ctrl:SetClientPos( 0.0, top - (scroll + ctrl:GetClientHeight() * 0.5) );
				scroll = scroll + ctrl:GetClientHeight() + self.m_fMargin;
			end

			self.m_ScrollLimitX = self.m_ScrollLimitX + ctrl:GetWidth() + self.m_fMargin * scale;
			self.m_ScrollLimitY = self.m_ScrollLimitY + ctrl:GetHeight() + self.m_fMargin * scale;
		end

		i = i + 1;
	end

	self.m_ScrollLimitX = self.m_ScrollLimitX - self.m_object:GetWidth();
	self.m_ScrollLimitY = self.m_ScrollLimitY - self.m_object:GetHeight();

	if self.m_ScrollLimitX < 0 then
		self.m_ScrollLimitX = 0;
	end

	if self.m_ScrollLimitY < 0 then
		self.m_ScrollLimitY = 0;
	end

	if self.Properties.HorzScroll == true then
		self.m_object:SetScrollLimit( self.m_ScrollLimitX, 0 );
	else
		self.m_object:SetScrollLimit( 0, self.m_ScrollLimitY );
	end

	self.m_object:UpdateTransform();
end

function ListGroupControl:AddTabItem( item )
	self.m_object:AddControl( item );
end

function ListGroupControl:RemoveTabItem( item )
	self.m_object:RemoveControl(item);
end

function ListGroupControl:Init( object )
	self.m_object = object;
end

function ListGroupControl:EventActive( object, dump0, dump1 )
	self:CalcLayout();

	return 1;
end

function ListGroupControl:EventTouchBegin( id, x, y )
	self.m_state = TAB_MOVING;

	self.m_DownX = x;
	self.m_DownY = y;

	self.m_OldScrollX = self.m_object:GetScrollPosX();
	self.m_OldScrollY = self.m_object:GetScrollPosY();

	if self.Properties.HorzScroll == true then
		self.m_DesireScrollPos = self.m_OldScrollX;
	else
		self.m_DesireScrollPos = self.m_OldScrollY;
	end

	self.m_fBeginTime = sGlobal:Clock();
	self.m_slide_state = TAB_STATE_FOLLOW_FINGER;

	self.m_fFirstMove = true;

	return 1;
end

function ListGroupControl:EventTouchMove( id, x, y )
	if self.m_fFirstMove == true then
		self.m_fFirstMove = false;
		self.m_object:SetCapture();
	end

	local offset;
	if self.m_state == TAB_MOVING then
		if self.Properties.HorzScroll == true then
			offset = x - self.m_DownX;
			self.m_DesireScrollPos = self.m_OldScrollX + offset;

			local exceed = 0;
			if self.m_DesireScrollPos < -self.m_ScrollLimitX then
				exceed = -self.m_ScrollLimitX - self.m_DesireScrollPos;
				exceed = math.pow( exceed, 0.8 );
				self.m_DesireScrollPos = -self.m_ScrollLimitX - exceed;
			elseif self.m_DesireScrollPos > 0 then
				exceed = self.m_DesireScrollPos;
				exceed = math.pow( exceed, 0.8 );
				self.m_DesireScrollPos = exceed;
			end
		else
			offset = y - self.m_DownY;

			self.m_DesireScrollPos = self.m_OldScrollY + offset;

			local exceed = 0;

			if self.m_DesireScrollPos > self.m_ScrollLimitY then
				exceed = self.m_DesireScrollPos - self.m_ScrollLimitY;
				exceed = math.pow( exceed, 0.8 );
				self.m_DesireScrollPos = self.m_ScrollLimitY + exceed;
			elseif self.m_DesireScrollPos < 0 then
				exceed = -self.m_DesireScrollPos;
				exceed = math.pow( exceed, 0.8 );
				self.m_DesireScrollPos = -exceed;
			end
		end
	end

	return 1;
end

function ListGroupControl:EventTouchEnd( id, x, y )
	self.m_object:ReleaseCapture();
	self.m_state = TAB_NORMAL;

	if self.Properties.HorzScroll == true then
		local offset = x - self.m_DownX;

		self.m_DesireScrollPos = self.m_OldScrollX + offset;
		if self.m_DesireScrollPos < -self.m_ScrollLimitX then
			self.m_DesireScrollPos = -self.m_ScrollLimitX;
		elseif self.m_DesireScrollPos > 0 then
			self.m_DesireScrollPos = 0;
		end

		--self.m_slide_state = TAB_STATE_STOPING;

		local duration = sGlobal:Clock() - self.m_fBeginTime;

		if duration < 0.02 then
			duration = 0.02;
		end

		--if duration < 0.5 then
		self.m_slide_state = TAB_STATE_AUTO_SLIDE;
		self.m_fVelocity = offset / duration * self.Properties.Speed;

		if self.m_fVelocity < -5000 then
			self.m_fVelocity = -5000;
		elseif self.m_fVelocity > 5000 then
			self.m_fVelocity = 5000;
		end

		--if duration > 0.5 then
		--	self.m_fVelocity = 0;
		--end
	else
		offset = y - self.m_DownY;

		--sGlobal:Print( "offset is "..offset );

		self.m_DesireScrollPos = self.m_OldScrollY + offset;
		if self.m_DesireScrollPos > self.m_ScrollLimitY then
			self.m_DesireScrollPos = self.m_ScrollLimitY;
		elseif self.m_DesireScrollPos < 0 then
			self.m_DesireScrollPos = 0;
		end

		local duration = sGlobal:Clock() - self.m_fBeginTime;

		if duration < 0.02 then
			duration = 0.02;
		end
		
		--if duration < 0.5 then
		self.m_slide_state = TAB_STATE_AUTO_SLIDE;
		self.m_fVelocity = offset / duration * self.Properties.Speed;

		if self.m_fVelocity < -2000 then
			self.m_fVelocity = -2000;
		elseif self.m_fVelocity > 2000 then
			self.m_fVelocity = 2000;
		end
	end

	return 1;
end

function ListGroupControl:Update( fElapsedTime )
	local xPos = self.m_object:GetScrollPosX();
	local yPos = self.m_object:GetScrollPosY();
	
	--sGlobal:Print( "xPos : "..xPos );

	if fElapsedTime > 0.033 then
		fElapsedTime = 0.033;
	end

	if self.Properties.HorzScroll == true then
		if self.m_slide_state == TAB_STATE_AUTO_SLIDE then
			local smoothrate = 0.075;

			if xPos > 0 then
				self.m_fVelocity = math.pow(math.abs(self.m_fVelocity), 0.6);
			elseif xPos < -self.m_ScrollLimitX then
				self.m_fVelocity = -math.pow(math.abs(self.m_fVelocity), 0.6);
			else
				self.m_fVelocity = self.m_fVelocity * (1.0 - smoothrate);
			end

			local offset = (self.m_fVelocity*fElapsedTime);
			local nPos = xPos + offset;

			if math.abs(self.m_fVelocity) < 20 then
				if xPos > 0 then
					self.m_DesireScrollPos = 0;
					self.m_slide_state = TAB_STATE_STOPING;
					self.m_fDeltaTime = 0;
				elseif nPos < -self.m_ScrollLimitX then
					self.m_DesireScrollPos = -self.m_ScrollLimitX;
					self.m_slide_state = TAB_STATE_STOPING;
					self.m_fDeltaTime = 0;
				else
					self.m_fVelocity = 0;
					self.m_slide_state = TAB_STATE_STOPING;
					self.m_DesireScrollPos = nPos;
					self.m_fDeltaTime = 0;
				end
			end

			self.m_OldScrollPos = nPos;

			self.m_fMaxTime = (nPos - self.m_DesireScrollPos)/500;
			if self.m_fMaxTime < 0.4 then
				self.m_fMaxTime = 0.4;
			elseif self.m_fMaxTime > 0.8 then
				self.m_fMaxTime = 0.8;
			end

			self.m_object:SetScrollPos( nPos, 0 );
		elseif self.m_slide_state == TAB_STATE_STOPING then
			local delta = self.m_fDeltaTime/self.m_fMaxTime;
			if delta > 1 then
				delta = 1;
			end

			local delta = math.sin(delta * 3.14159*0.5);
			delta = delta * delta;

			nPos = self.m_OldScrollPos + (self.m_DesireScrollPos - self.m_OldScrollPos)*delta;

			self.m_object:SetScrollPos( nPos, 0 );
			self.m_fDeltaTime = self.m_fDeltaTime + fElapsedTime;
		else
			nPos = xPos + (self.m_DesireScrollPos - xPos) * fElapsedTime * 10;
			self.m_object:SetScrollPos( nPos, 0 );
		end
	else
		------
		if self.m_slide_state == TAB_STATE_AUTO_SLIDE then
			local smoothrate = 0.045;

			if yPos < 0 then
				self.m_fVelocity = -math.pow(math.abs(self.m_fVelocity), 0.6);
			elseif yPos > self.m_ScrollLimitY then
				self.m_fVelocity = math.pow(math.abs(self.m_fVelocity), 0.6);
			else
				self.m_fVelocity = self.m_fVelocity * (1.0 - smoothrate);
			end

			local offset = (self.m_fVelocity*fElapsedTime);
			local nPos = yPos + offset;

			--sGlobal:Print( "nPos"..nPos.."Velo"..self.m_fVelocity );

			if math.abs(self.m_fVelocity) < 10 then
				if yPos < 0 then
					self.m_DesireScrollPos = 0;
					self.m_slide_state = TAB_STATE_STOPING;
					self.m_fDeltaTime = 0;
				elseif yPos > self.m_ScrollLimitY then
					self.m_DesireScrollPos = self.m_ScrollLimitY;
					self.m_slide_state = TAB_STATE_STOPING;
					self.m_fDeltaTime = 0;
				else
					self.m_fVelocity = 0;
					self.m_slide_state = TAB_STATE_STOPING;
					self.m_DesireScrollPos = nPos;
					self.m_fDeltaTime = 0;
				end
			end

			self.m_OldScrollPos = nPos;

			self.m_fMaxTime = ( self.m_DesireScrollPos - nPos )/500;
			if self.m_fMaxTime < 0.4 then
				self.m_fMaxTime = 0.4;
			elseif self.m_fMaxTime > 0.8 then
				self.m_fMaxTime = 0.8;
			end

			self.m_object:SetScrollPos( 0, nPos );
		elseif self.m_slide_state == TAB_STATE_STOPING then
			local delta = self.m_fDeltaTime/self.m_fMaxTime;
			if delta > 1 then
				delta = 1;
			end

			local delta = math.sin(delta * 3.14159*0.5);
			delta = delta * delta;

			nPos = self.m_OldScrollPos + (self.m_DesireScrollPos - self.m_OldScrollPos)*delta;

			--sGlobal:Print("m_OldScrollPos"..self.m_OldScrollPos.."nPos"..nPos);

			self.m_object:SetScrollPos( 0, nPos );
			self.m_fDeltaTime = self.m_fDeltaTime + fElapsedTime;
		else
			--sGlobal:Print( "m_DesireScrollPos : "..self.m_DesireScrollPos );
			local nPos = yPos + (self.m_DesireScrollPos - yPos) * fElapsedTime * 10;

			--sGlobal:Print( "nPos : "..nPos );
			self.m_object:SetScrollPos( 0, nPos );
		end
	end
end

function ListGroupControl:ScrollToPos( desirePos, fMaxTime )
	self.m_fDeltaTime = 0.0;
	self.m_fMaxTime = fMaxTime;
	
	if desirePos > 0 then
		self.m_DesireScrollPos = 0;
		self.m_slide_state = TAB_STATE_STOPING;
		self.m_fDeltaTime = 0;
	elseif desirePos < -self.m_ScrollLimitX then
		self.m_DesireScrollPos = -self.m_ScrollLimitX;
	else
		self.m_DesireScrollPos = desirePos;
	end
	if fMaxTime == 0.0 then
		self.m_fVelocity = 0;
		if desirePos > 0 then
			desirePos = 0;
		elseif desirePos < -self.m_ScrollLimitX then
			desirePos = -self.m_ScrollLimitX;
		end
		self.m_OldScrollPos = desirePos;
		sGlobal:Print( "desirePos : "..desirePos );
		self.m_DesireScrollPos = desirePos;
		local xPos = self.m_object:GetScrollPosX();
		local yPos = self.m_object:GetScrollPosY();

		if self.Properties.HorzScroll == true then
			self.m_object:SetScrollPos( desirePos, yPos );
		else
			self.m_object:SetScrollPos( xPos, desirePos );
		end
		self.m_fDeltaTime = 0;
		self.m_slide_state = TAB_STATE_STOP;
	end
end

function ListGroupControl:GetScrollPos()
	if self.Properties.HorzScroll == true then
		return self.m_object:GetScrollPosX();
	else
		return self.m_object:GetScrollPosY();
	end
end

function ListGroupControl:Check( obj )
	local size = self.m_object:GetChildCount();
	
	local ctrl;
	local tbl;
	for i = 0, size - 1 do
		ctrl = self.m_object:GetControl(i);
		tbl = ctrl:GetScript();
		
		if obj ~= ctrl then
			tbl:SetCheck( false );
		end
	end
end
