require( "ui/impl/uisound.lua" )

banner = {
	m_object;
	m_uiMgr;

	m_gift_failed_callback = nil;


	m_gift_index = 0;
	m_gift_state = nil;
	m_gift_banner_timer = nil;

	m_iap_id = 0;
}

function	banner:Init( object )
	self.m_object = object;
end

function	banner:EventInit( object )
	self.m_uiMgr = sGlobal:GetUIManager();

	self.m_gift_banner_timer = self.m_object:FindChildControl( "banner_timer" );

	return 1;
end

function	banner:EventActive( object, param0, param1 )
	self.m_object:SelectAnimation( "ani_pause", false, true );
	return 1;
end 

function	banner:Update( duration )
	self:UpdateGiftBox();
end

function	banner:UpdateGiftBox()
	self.m_gift_index = datasave:GetLastGiftId();
	self.m_gift_state = datasave:GetLastGift();

	if self.m_gift_index == 1 then
		self.m_object:SetSymbol("gift_lv6");
	elseif self.m_gift_index == 2 then
		self.m_object:SetSymbol("gift_lv5");
	elseif self.m_gift_index == 3 then
		self.m_object:SetSymbol("gift_lv3");
	elseif self.m_gift_index == 4 then
		self.m_object:SetSymbol("gift_lv2");
	elseif self.m_gift_index == 5 then
		self.m_object:SetSymbol("gift_lv4");
	end

	if self.m_gift_state ~= nil then	
		self.m_gift_banner_timer:SetSymbolText(TimeToStringNoMs(self.m_gift_state.time));
	end

	if self.m_gift_index == 1 then
		self.m_gift_banner_timer:SetVisible(false);
	else
		self.m_gift_banner_timer:SetVisible(true);
	end
end

function	banner:Event_Buy( object, param0, param1 )
	Global:PlaySound(uisound.shop_btn_iap,0);

	sGlobal:Print("gift index"..self.m_gift_index);
	if self.m_gift_index == 1 then
		OnStartPurchase( PCS_GOLD_100000, self );
	elseif self.m_gift_index == 2 then
		OnStartPurchase( PCS_GOLD_9000000, self );
	elseif self.m_gift_index == 3 then
		OnStartPurchase( PCS_GOLD_3500000, self );
	elseif self.m_gift_index == 4 then
		OnStartPurchase( PCS_GOLD_3500000, self );
	elseif self.m_gift_index == 5 then
		OnStartPurchase( PCS_GOLD_8600000, self );
	end
	
	self.m_iap_id = self.m_gift_index;

	return 1;
end

function	banner:PurchaseSuccess( id )
	local dataMgr = Global:GetDataMgr();
	sGlobal:Print("PurchaseSuccess"..self.m_iap_id);
	if self.m_gift_index == 1 then
		dataMgr:AddItemNum( ITEM_MILLISE, 2 );
		dataMgr:AddItemNum( ITEM_SHIELD, 2 );
		dataMgr:AddItemNum( ITEM_NITROGEN, 2 );
		datasave.m_bThanksGiftPurchased = true;
		datasave:SetGiftDone(1);
	elseif self.m_gift_index == 2 then
		GiveGiftAircraftById(5);
		datasave:SetGiftDone(2);
	elseif self.m_gift_index == 3 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[2] );
		GiveGiftAircraftById(4);
		GiveGiftAircraftById(5);
		datasave:SetGiftDone(3);
	elseif self.m_gift_index == 4 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[2] );
		GiveGiftAircraftById(6);
		datasave:SetGiftDone(4);
	elseif self.m_gift_index == 5 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[3] );
		GiveGiftAircraftById(7);
		datasave:SetGiftDone(5);
	end
	EventNotice("pack_garage_buy",self.m_gift_index);
	self.m_object:SetVisible(false);

	return 1;
end

banner.ControlEvents = {
	Inputs = {
		btn_banner = {"Event_Buy"}
	}
}
