require( "scripts/ui.lua" )
require( "ui/impl/uisound.lua" )

carsale = {
	m_object;
	m_uiMgr;
	m_DataMgr;

	m_st_price_origin;
	m_st_price_new;

	m_pane1;
	m_pane2;
}

function	carsale:Init( object )
	self.m_object = object;
end

function	carsale:EventInit( object )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_st_price_origin = self.m_object:FindChildControl( "st_price_origin" );
	self.m_st_price_new = self.m_object:FindChildControl( "st_price_new" );
	self.m_pane1 = self.m_object:FindChildControl( "pane_testdrive1" );
	self.m_pane2 = self.m_object:FindChildControl( "pane_testdrive2" );
	return 1;
end
function	carsale:EventActive( object, param0, param1 )
	self.m_DataMgr = Global:GetDataMgr();

	local price_origin = levelinfo.m_testShip.price;
	local price_new = levelinfo.m_testShip.price_test;
	self.m_st_price_origin:SetSymbolText( ""..price_origin );
	self.m_st_price_new:SetSymbolText( ""..price_new );

	self.m_pane1:SetVisible( true );
	self.m_pane2:SetVisible( false );
	return 1;
end

function	carsale:Event_Buy( object, param0, param1 )
	local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
	local price = levelinfo.m_testShip.price_test;
	if gold >= price then
		self.m_DataMgr:BuyCar( levelinfo.m_testShip.name );
		self.m_DataMgr:AddItemNum( ITEM_GOLD, -price );
		Save();
				
		Global:PlaySound(uisound.shop_btn_buyItem,0);
				
		Global:EventNoticeEx( "purchase_car", levelinfo.m_testShip.name );

		self.m_uiMgr:CloseWindow( self.m_object );
	else
		local need = price - gold;

		if need < 1000000 then
			OnStartPurchase( PCS_GOLD_1000000, self );
		elseif need < 3500000 then
			OnStartPurchase( PCS_GOLD_3500000, self );
		else
			OnStartPurchase( PCS_GOLD_8600000, self );
		end
	end
	return 1;
end

function	carsale:PurchaseSuccess( id )
	local dataMgr = Global:GetDataMgr();

	local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
	local price = levelinfo.m_testShip.price_test;

	if gold >= price then
		self.m_DataMgr:BuyCar( levelinfo.m_testShip.name );
		self.m_DataMgr:AddItemNum( ITEM_GOLD, -price );

		Global:PlaySound(uisound.shop_btn_buyItem,0);
				
		Global:EventNoticeEx( "purchase_car", levelinfo.m_testShip.name );

		self.m_uiMgr:CloseWindow( self.m_object );
	end

	return 1;
end

function	carsale:Event_Cancel( object, param0, param1 )
	if self.m_pane1:IsVisible() then
		self.m_pane1:SetVisible( false );
		self.m_pane2:SetVisible( true );
	else
		self.m_uiMgr:CloseWindow( self.m_object );
	end
	return 1;
end

function 	carsale:EventKeyUp( key_code )
	if key_code == 27 then
		self:Event_Cancel( "BN_CLICK", 0, 0 );
	end
	return 1;
end

carsale.ControlEvents = {
	Inputs = {
		btn_buy_carsale = { "Event_Buy" };
		btn_cancel_carsale = { "Event_Cancel" };
	};
}