
checkin = {
	m_object;
	m_uiMgr;
	m_DataMgr;
	m_bInit = true;
	m_btn_GetCheckIn;
	m_ani_today;
	m_DayObj = {};
};

function	checkin:Init( object )
	self.m_object = object;
end

function 	checkin:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_btn_GetCheckIn = self.m_object:FindChildControl( "btn_check_in" );
	
	self.m_ani_today = self.m_object:FindChildControl( "ani_today" );
	self.m_ani_today:FindChildControl( "ani_today_child" ):SelectAnimation( "ani_qiandao", true, true );
	self.m_ani_today:FindChildControl( "ani_today_child" ):PauseAnim( true, true );
	
	local rewardObj;
	for i = 1, 8 do
		local dayItem = { day_obj = nil, checkSym_obj = nil };
		dayItem.day_obj = self.m_object:FindChildControl( "bg_day_"..tostring(i) );
		dayItem.checkSym_obj = self.m_object:FindChildControl( "get_check_in_day_"..tostring(i) );
		self.m_DayObj[i] = dayItem;
		
	
		rewardObj = self.m_object:FindChildControl( "rewar_day_"..tostring(i) );
		rewardObj:SetFontColor( 87/255, 1, 1 );
		
		if i < 8 then
			rewardObj:SetVisible( true );
			rewardObj:SetSymbolText( math.floor( 250000  + ( i-1 ) * 50000 ) );
		else
			rewardObj:SetVisible( false );
			--rewardObj:SetSymbolText( math.floor( 200000 ) );
		end
	end
	
	return 1;
end

function 	checkin:EventActive( object, param0, param1 )
	self.m_bInit = true;
	return 1;
end

 function	checkin:Update( duration )
	if self.m_bInit then
		self:Refreash();
		self.m_bInit = false;
	end
 end

function 	checkin:Event_Get_Reward( object, param0, param1 )
	local sustainDay = datasave:GetChickInSustain();
	if sustainDay + 1 > 8 then
		sustainDay = 8;
	end
	
	self:ChekeIn( sustainDay + 1 );
	self:OnCancel();
	return 1;
end


 function	checkin:ChekeIn( index )
	sGlobal:Print( "cheke in : "..index );
	self.m_DataMgr = Global:GetDataMgr();
	if index == 1 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,250000 );
	elseif index == 2 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,300000 );
	elseif index == 3 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,350000 );
	elseif index == 4 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,400000 );
	elseif index == 5 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,450000 );
	elseif index == 6 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,500000 );
	elseif index == 7 then
		self.m_DataMgr:AddItemNum( ITEM_GOLD,550000 );
	elseif index >= 8 then
		--self.m_DataMgr:AddItemNum( ITEM_GOLD,200000 );
		local itemType = math.floor( Global:RandFloat( 1.5, 3.5 ) );
		self.m_DataMgr:AddItemNum( itemType, 3 );
	end
	
	local curYear = GetCheckInYear();
	local curMonth = GetCheckInMoth();
	local curDay = GetCheckInDay();
	
	datasave:SetChickInYear( curYear );
	datasave:SetChickInMonth( curMonth );
	datasave:SetChickInDay( curDay );
	
	datasave:SetChickInSustain( datasave:GetChickInSustain() + 1 );
	
	self:Refreash();
	Global:PlaySound(uisound.choosecar_btn_continue, 0);
	Save();
	
	--EventNoticeEx( "checkin", GetSaveData( DS_CHEKEIN_SUSTAIN_DAY ) );
 end 
 
 
 function	checkin:Refreash()
	self.m_DataMgr = Global:GetDataMgr();
	local lastYear = datasave:GetChickInYear();
	local lastMonth = datasave:GetChickInMonth();
	local lastDay = datasave:GetChickInDay();
	
	local curYear = GetCheckInYear();
	local curMonth = GetCheckInMoth();
	local curDay = GetCheckInDay();
	local sustainDay = datasave:GetChickInSustain();
	
	sGlobal:Print( " checkin ---lst year : "..lastYear.."     lst month : "..lastMonth.."     lst day : "..lastDay );
	sGlobal:Print( " checkin ---cur year : "..curYear.."      cur month : "..curMonth.."      cur day : "..curDay );
	if lastYear == curYear and lastMonth == curMonth and lastDay == curDay then
		self.m_btn_GetCheckIn:GetScript():EnableButton( true );
		self.m_ani_today:SetVisible( false );
		for i = 1, #self.m_DayObj do
			if i <= sustainDay then
				--self.m_DayObj[i].day_obj:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
				self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
				self.m_DayObj[i].checkSym_obj:SetVisible( true );
			else
				--self.m_DayObj[i].day_obj:SetAmbient( 0.4, 0.4, 0.4, 1.0, true );
				self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
				self.m_DayObj[i].checkSym_obj:SetVisible( false );
			end
		end
	else
		self.m_btn_GetCheckIn:GetScript():EnableButton( true );
		if sustainDay < 8 then
			for i = 1, #self.m_DayObj do
				if i <= sustainDay then
					--self.m_DayObj[i].day_obj:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
					self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
					self.m_DayObj[i].checkSym_obj:SetVisible( true );
				elseif i == sustainDay + 1 then
					--self.m_DayObj[i].day_obj:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
					self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
					self.m_DayObj[i].checkSym_obj:SetVisible( false );
					self.m_ani_today:RemoveSelf();
					self.m_DayObj[i].day_obj:AddControl( self.m_ani_today );
					
					self.m_ani_today:SetVisible( true );
					self.m_ani_today:FindChildControl( "ani_today_child" ):PauseAnim( false, true );
				else
					--self.m_DayObj[i].day_obj:SetAmbient( 0.4, 0.4, 0.4, 1.0, true );
					self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
					self.m_DayObj[i].checkSym_obj:SetVisible( false );
				end
			end
		else
			for i = 1, #self.m_DayObj do
				if i ~= 8 then
					--self.m_DayObj[i].day_obj:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
					self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
					self.m_DayObj[i].checkSym_obj:SetVisible( true );
				else
					--self.m_DayObj[i].day_obj:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
					self.m_DayObj[i].day_obj:SetSymbol( "bglinecar" );
					self.m_DayObj[i].checkSym_obj:SetVisible( false );
					
					self.m_ani_today:RemoveSelf();
					self.m_DayObj[i].day_obj:AddControl( self.m_ani_today );
					
					self.m_ani_today:SetVisible( true );
					self.m_ani_today:FindChildControl( "ani_today_child" ):PauseAnim( false, true );
				end
			end
		end
	end
 end
 
 function	checkin:OnCancel()
	ClosePage( "reg" );
	Global:PlaySound(uisound.btn_return, 0);
 end
 
 function 	checkin:EventKeyUp( key_code )
	if key_code == 27 then
		self:OnCancel();
	elseif key_code == 13 then
		self.m_object:FindChildControl( "btn_check_in" ):SendMsg( "BN_CLICK", 0, 0 );
	end
	return 1;
 end
 
checkin.ControlEvents = {
	Inputs = {
		btn_check_in = { "Event_Get_Reward" };
	};
};