require("scripts/cardef.lua")
require("scripts/property_car.lua")
require( "ui/impl/uisound.lua" )
require("scripts/ui.lua");

choosecar = {
	m_object;
	m_uiMgr;
	m_carid = 1;
	m_st_name_car;
	m_text_acce_time;
	m_textMaxSpeedBar;
	m_text_control;
	m_text_chooseCar_gold;
	m_text_carprice;
	m_crash_symbol;
	m_effect_chooseCar;
	m_textCurName;
	m_carLock;
	m_symbol_gold_buy_car;
	m_btn_refitCar;
	m_text_continue;
	m_text_buy;
	m_carInfoBar = {};
	m_btn_chooseCar_ToLeft;
	m_btn_chooseCar_ToRight;
	m_btn_free_choosecar;
	m_free_value_bg;
	m_free_value;
	m_btn_vip;
	m_thanks_gift;
	
	m_DataMgr;

	m_gift_box = nil;
	m_gift_index = 0;
	m_gift_state = nil;
	m_gift_banner = nil;
	m_gift_banner_timer = nil;
	m_upgrade_gift = nil;
	m_rank_stars = {};
}
function	choosecar:Init( object )
	self.m_object = object;
end

function	choosecar:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();

	self.m_st_name_car = self.m_object:FindChildControl( "st_name_car" );
	self.m_effect_chooseCar = self.m_object:FindChildControl( "effect_chooseCar" );
	self.m_text_acce_time = self.m_object:FindChildControl( "text_acce_time" );
	self.m_textMaxSpeedBar = self.m_object:FindChildControl( "text_maxSpeed" );
	self.m_text_control = self.m_object:FindChildControl( "text_control" );
	self.m_text_chooseCar_gold = self.m_object:FindChildControl( "text_chooseCar_gold" );
	self.m_text_carprice = self.m_object:FindChildControl( "text_carprice" );
	self.m_crash_symbol = self.m_object:FindChildControl( "crash_symbol" );
	self.m_btn_free_choosecar = self.m_object:FindChildControl( "btn_free_choosecar" );
	self.m_carLock = self.m_object:FindChildControl( "car_lock" );
	self.m_symbol_gold_buy_car = self.m_object:FindChildControl( "symbol_gold_buy_car" );
	self.m_btn_refitCar = self.m_object:FindChildControl( "btn_refitCar" );
	self.m_btn_vip = self.m_object:FindChildControl("btn_vip");
	
	self.m_gift_banner = self.m_object:FindChildControl( "banner_small" );
	self.m_gift_banner_timer = self.m_object:FindChildControl( "banner_timer" );
	--self.m_text_continue = self.m_object:FindChildControl( "text_continue" );
	--self.m_text_buy = self.m_object:FindChildControl( "text_buy" );
	self.m_thanks_gift = self.m_object:FindChildControl("gift_lv6_2");
	self.m_btn_chooseCar_ToLeft = self.m_object:FindChildControl( "btn_chooseCar_ToLeft" );
	self.m_btn_chooseCar_ToRight = self.m_object:FindChildControl( "btn_chooseCar_ToRight" );
	self.m_free_value_bg = self.m_object:FindChildControl( "free_value_bg" );
	self.m_free_value = self.m_object:FindChildControl( "free_value" );
	self.m_carLock:SelectAnimation( "ani_lock", true, false );
	self.m_carLock:PauseAnim( true, false );
	for i=1,5 do
		self.m_rank_stars[i] = self.m_object:FindChildControl("car_star_"..i);
	end
	for i = 1, 3 do
		local name = "bg_infline1_"..( i + 2 );
		self.m_carInfoBar[i] = self.m_object:FindChildControl( name );
	end
	return 1;
end

function	choosecar:EventActive( object, param0, param1 )
	self.m_DataMgr = Global:GetDataMgr();
	self.m_carid = property_car:GetIndex( datasave:GetRacingSelectCar() );
	self:SelectCar( self.m_carid );
	if channel:IsVipEnabled() then
		self.m_btn_vip:SetVisible(true);
	else 
		self.m_btn_vip:SetVisible(false);
	end
	if channel.m_bEnableFreeDiamond then
		self.m_btn_free_choosecar:SetVisible( true );
	else
		self.m_btn_free_choosecar:SetVisible( false );
	end
	
	if channel.m_bEnableAd then
		--Global:SystemRequest( SystemEvent.SE_HIDE_AD );
		Global:SystemRequest( SystemEvent.SE_SHOW_AD );
	end
	self:UpdateCarInfoBar( true );

	self.m_upgrade_gift = nil;
	if channel.m_bThanksGift then 
		if datasave.m_bThanksGiftPurchased or datasave:GetLastGiftId() == 1 then
			self.m_thanks_gift:SetVisible(false);
		else
			self.m_thanks_gift:SetVisible(true);
		end
	else
		self.m_thanks_gift:SetVisible(false);
	end
	return 1;
end

function	choosecar:UpdateGiftBox()
	if not channel.m_bGiftPack then
		self.m_gift_banner:SetVisible(false);
		return;
	end
	self.m_gift_index = datasave:GetLastGiftId();
	self.m_gift_state = datasave:GetLastGift();

	if self.m_gift_index == 1 then
		self.m_gift_box = self.m_uiMgr:GetPage("ThanksgivingGift");
		self.m_gift_banner:SetVisible(true);
	elseif self.m_gift_index == 2 then
		self.m_gift_box = self.m_uiMgr:GetPage("CoolGift");
		self.m_gift_banner:SetVisible(true);
	elseif self.m_gift_index == 3 then
		self.m_gift_box = self.m_uiMgr:GetPage("cargift");
		self.m_gift_banner:SetVisible(true);
	elseif self.m_gift_index == 4 then
		self.m_gift_box = self.m_uiMgr:GetPage("cargift1");
		self.m_gift_banner:SetVisible(true);
	elseif self.m_gift_index == 5 then
		self.m_gift_box = self.m_uiMgr:GetPage("cargift2");
		self.m_gift_banner:SetVisible(true);
	else
		self.m_gift_box = nil;
		self.m_gift_banner:SetVisible(false);
	end
end

function	choosecar:GiftFailedCallback()
	if self.m_upgrade_gift then
		local carname = property_car:GetName(self.m_carid);
		if self.m_DataMgr:IsBuyCar( carname ) then -- has buy this car
			--ClosePage( "choosecar" );
			--ShowPage( "chosetrack" );
			
			local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
			shopTbl:ContinueGameToShop();
			ClosePage( "choosecar" );
			ShowPage( "shop" );
		end		
	elseif channel.m_EnableShowShop then
		local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
		shopTbl:ChooseCarContinueToShop();
		shopTbl:IsToIapFrm( true );
		ClosePage( "choosecar" );
		ShowPage( "shop" );
		Global:PlaySound(uisound.btn_To_Shop,0);
	end	
end

function	choosecar:Update( duration )
	local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
	self.m_text_chooseCar_gold:SetSymbolText( gold );
	
	local price = property_car:GetPrice( self.m_carid );
	self.m_text_carprice:SetSymbolText( price );

	self:UpdateBuyAndRefit();
	self:UpdateChooseCarBtn();
	self:UpdateGiftBox();

	if channel.m_bEnableFreeDiamond then
		local num = 0;
		if Global:SystemRequest( SystemEvent.SE_INTERNET ) then
			if not datasave:IsLikeFaceBook() then
				num = num + 1;
			end
			
			if not datasave:IsLikeTwitter() then
				num = num + 1;
			end
		end
		
		if Global:SystemRequest( SystemEvent.SE_VIDEO_AVAILABLE ) then
			num = num + 1;
		end
		
		self.m_free_value:SetSymbolText( num );
		if num > 0 then
			self.m_free_value_bg:SetVisible( true );
		else
			self.m_free_value_bg:SetVisible( false );
		end
	end
end

function	choosecar:UpdateCarInfoBar( bReset )
	local carname = property_car:GetName(self.m_carid);
	local refitTimes = self.m_DataMgr:GetRefitTimes( carname );
	local acce;
	local accetime;
	local maxSpeed;
	local controlAbl;
	
	if refitTimes >= 1 then
		accetime = property_car:GetAccelerate(self.m_carid) * 0.83; -- 0.83 == 10/12
		acce = 6 + 50 / accetime;
		maxSpeed = property_car:GetMaxSpeed(self.m_carid) * 1.05;
		controlAbl = property_car:GetControlAbility(self.m_carid) * 1.2;
	else
		accetime = property_car:GetAccelerate(self.m_carid);
		acce = 6 + 50 / accetime;
		maxSpeed = property_car:GetMaxSpeed(self.m_carid);
		controlAbl = property_car:GetControlAbility(self.m_carid);
	end
	
	local maxID = #( carorder );
	local endAcce = 30; -- property_car:GetAccelerate(maxID) * 1.3;
	local endSpeed = 520; -- property_car:GetMaxSpeed(maxID) * 1.08;
	local endControlAbl = 20 -- property_car:GetControlAbility(maxID) * 1.3;
	
	if bReset then
		for i = 1, #( self.m_carInfoBar ) do
			self.m_carInfoBar[i]:SelectAnimation( "mask_line"..i, false, false );
			--self.m_carInfoBar[i]:PauseAnim( false, false );
		end
	end
	self.m_carInfoBar[1]:PlayAndStop( acce/endAcce, true );
	self.m_carInfoBar[2]:PlayAndStop( maxSpeed/endSpeed, true );
	self.m_carInfoBar[3]:PlayAndStop( controlAbl/endControlAbl, true );
	
	self.m_text_acce_time:SetSymbolText( math.floor( accetime ) );
	self.m_textMaxSpeedBar:SetSymbolText( math.floor( maxSpeed ) );
	self.m_text_control:SetSymbolText( math.floor( controlAbl ) );
end

function	choosecar:Event_Return_Click( event, param0, param1 )
	ClosePage( "choosecar" );
	ShowPage( "racemain" );
	Global:PlaySound(uisound.btn_return,0);
	Global:SystemRequest( SystemEvent.SE_HIDE_AD );
	return 1;
end

function	choosecar:Event_RefitCar( event, param0, param1 )
	if self.m_DataMgr:IsBuyCar( property_car:GetName( self.m_carid ) ) then
		if channel.m_EnableRefixByIap then
			OnStartPurchase( PCS_CAR_REFIT, nil );
		else
			local upPrice = math.floor(property_car:GetUpgradePrice( self.m_carid ));
			if upPrice > 0 and self.m_DataMgr:GetItemNum( ITEM_GOLD ) >= upPrice then
				self:RefitCar();
				self.m_DataMgr:AddItemNum( ITEM_GOLD, -upPrice );
			else
				Global:PlaySound(uisound.nomoney,0);
				ShowDialog( "nomoneytip" );
			end
		end
		-- self.m_uiMgr:GetPage( "upgrade" ):GetScript():ChooseCarToRefix();
		-- ClosePage( "choosecar" );
		-- ShowDialog( "upgrade" );
	end
	return 1;
end

function	choosecar:RefitCar()
	local carname = property_car:GetName(self.m_carid);
	self.m_DataMgr:Refit(carname);
	self:UpdateCarInfoBar( false );
	Global:PlaySound(uisound.choosecar_btn_buycar,0);
	
	local NoticeName = carname;
	sGlobal:Print( "EventNoticeEx : "..NoticeName );
	Global:EventNoticeEx( "upgrade_car", NoticeName );
end

function	choosecar:Event_To_Shop( event, param0, param1 )
	if self.m_gift_box then
		self.m_gift_box:SetFailedCallback( this );
		self.m_gift_box:GetScript().m_pos = "shop";
		self.m_uiMgr:OpenDialog( self.m_gift_box );
	else
		if channel.m_EnableShowShop then
			local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
			shopTbl:ChooseCarContinueToShop();
			ClosePage( "choosecar" );
			ShowPage( "shop" );
			Global:PlaySound(uisound.btn_To_Shop,0);
		end
	end

	return 1;
end

function	choosecar:Event_To_Shop_1( event, param0, param1 )
	if self.m_gift_box then
		self.m_gift_box:GetScript().m_pos = "shop";
		self.m_uiMgr:OpenDialog( self.m_gift_box );
		self.m_gift_box:GetScript():SetFailedCallback( self );
	else
		if channel.m_EnableShowShop then
			local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
			shopTbl:ChooseCarContinueToShop();
			shopTbl:IsToIapFrm( true );
			ClosePage( "choosecar" );
			ShowPage( "shop" );
			Global:PlaySound(uisound.btn_To_Shop,0);
		end
	end
	return 1;
end

function	choosecar:Event_ChooseCar_To_Left( event, param0, param1 )
	Global:PlaySound(uisound.mainui_btn_start,0);
	if self.m_carid > 1 then
		self.m_carid = self.m_carid - 1;
		self:SelectCar( self.m_carid );
	end
	return 1;
end
function choosecar:SetStarRank(n)
	for i=1,5 do
		if i <= n then
			self.m_rank_stars[i]:SelectAnimation("ani_car_star_on",true,false);
		else
			self.m_rank_stars[i]:SelectAnimation("ani_car_star_off",true,false);
		end
	end
end
function	choosecar:Event_ChooseCar_To_Right( event, param0, param1 )
	Global:PlaySound(uisound.mainui_btn_start,0);
	local carMax = #( carorder ); 
	if self.m_carid < carMax then
		self.m_carid = self.m_carid + 1;
		self:SelectCar( self.m_carid );
	end
	return 1;
end

function	choosecar:UpdateChooseCarBtn()
	local carMax = #( carorder ); 
	if self.m_carid == 1 then
		self.m_btn_chooseCar_ToLeft:SetVisible( false );
	else
		self.m_btn_chooseCar_ToLeft:SetVisible( true );
	end
	if self.m_carid == carMax then
		self.m_btn_chooseCar_ToRight:SetVisible( false );
	else
		self.m_btn_chooseCar_ToRight:SetVisible( true );
	end
end

function	choosecar:SelectCar( id )
	local carname;
	carname = property_car:GetName(id);
	self.m_st_name_car:SetSymbol( property_car:GetNameSymbol( id ) );
	self.m_effect_chooseCar:SetSymbolEffect( property_car:GetEffect(id) );
	--self.m_object:FindChildControl( "effect_chooseCar" ):SetSymbolEffect( property_car:GetEffect(id) );
	--self.m_textCurName:SetSymbol( property_car:GetIcon(id) );
	self.m_DataMgr:SetCurCar( carname );
	datasave:SetRacingSelectCar( carname );
	self:UpdateCarInfoBar( true );
	self:SetStarRank(property_car:GetCarDataByLable(id,"star_rank"));
end

function	choosecar:GetCarFile( name )
	return property_car:GetModel( name );
end

function	choosecar:GetCarId()
	sGlobal:Print( "m_curid : "..self.m_carid );
	return self.m_carid;
end

function	choosecar:UpdateBuyAndRefit()
	local carname = property_car:GetName(self.m_carid);
	if self.m_DataMgr:IsBuyCar( carname ) then
		self.m_carLock:SetVisible( false );
		self.m_carLock:PauseAnim( true, false );
		self.m_symbol_gold_buy_car:SetVisible( false );
		
		
		self.m_object:FindChildControl( "btn_choosecar_buyOrcontinue" ):SetVisible(false);
		self.m_object:FindChildControl( "btn_tongyong1_1" ):SetVisible(true);

		if self.m_DataMgr:GetRefitTimes( carname ) >= 1 then
			self.m_btn_refitCar:SetVisible( false );
			self.m_object:FindChildControl( "fk_gold" ):SetVisible( false );
		else
			self.m_btn_refitCar:SetVisible( true );
			if channel.m_EnableRefixByIap then
				self.m_object:FindChildControl( "fk_gold" ):SetVisible( false );
				
				if channel.m_EnableShowRefixPrice then
					self.m_object:FindChildControl( "rmb2_4" ):SetVisible( true );
					self.m_object:FindChildControl( "rmb2_4" ):SetSymbol( "rmb2" );
				else
					self.m_object:FindChildControl( "rmb2_4" ):SetVisible( false );
				end
			else
				self.m_object:FindChildControl( "fk_gold" ):SetVisible( true );
				self.m_object:FindChildControl( "rmb2_4" ):SetSymbolText( math.floor(property_car:GetUpgradePrice( self.m_carid )) );
			end
		end
		if channel:GetCurChannel() == "android_msy" then
			self.m_object:FindChildControl( "rmb2_4" ):SetSymbol( "rmb1" );
		end
	else
		self.m_carLock:SetVisible( true );
		self.m_carLock:PauseAnim( false, false );
		self.m_symbol_gold_buy_car:SetVisible( true );
		self.m_btn_refitCar:SetVisible( false );
		self.m_object:FindChildControl( "fk_gold" ):SetVisible( false );
		self.m_object:FindChildControl( "btn_choosecar_buyOrcontinue" ):SetVisible(true);
		self.m_object:FindChildControl( "btn_tongyong1_1" ):SetVisible(false);
		
		--self.m_text_continue:SetVisible( false );
		--self.m_text_buy:SetVisible( true );
	end
end


function	choosecar:Event_Buy( event, param0, param1 )
	local carname = property_car:GetName(self.m_carid);
	Global:PlaySound(uisound.choosecar_btn_chooseitem,0);
	if not self.m_DataMgr:IsBuyCar( carname ) then -- has buy this car
		-- did not buy this car
		local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
		local price = property_car:GetPrice( self.m_carid );
		
		if price > 0 then
			if gold >= price then
				self.m_DataMgr:BuyCar( property_car:GetName( self.m_carid ) );
				self.m_DataMgr:AddItemNum( ITEM_GOLD, -price );
				Global:PlaySound(uisound.shop_btn_buyItem,0);
				Save();
				
				local NoticeName = carname;
				sGlobal:Print( "EventNoticeEx : "..NoticeName );
				Global:EventNoticeEx( "purchase_car", NoticeName );
			else
				if channel.m_EnableShowShop then
					ClosePage( "choosecar" );
					self.m_uiMgr:GetPage( "paycar" ):GetScript():SetMsgType( TIP_IAP );
					self.m_uiMgr:GetPage( "paycar" ):GetScript():SetIapPrice( price - gold )
					ShowDialog( "paycar" );
				else
					Global:PlaySound(uisound.nomoney, 0);
					ShowDialog( "nomoneytip" )
				end
			end
		end
	end
	return 1;
end

function	choosecar:Event_Continue( event, param0, param1 )
	local carname = property_car:GetName(self.m_carid);

	local refitTimes = self.m_DataMgr:GetRefitTimes( carname );
	if refitTimes <= 0 and channel.m_EnableRefixByIap and levelinfo:IsRefixLevel() then
		self.m_upgrade_gift = self.m_uiMgr:GetPage("upgradebox");
		self.m_uiMgr:OpenDialog( self.m_upgrade_gift );
		self.m_upgrade_gift:GetScript():SetGiftIndex(6);
		self.m_upgrade_gift:GetScript():SetFailedCallback( self );
	else 
		Global:PlaySound(uisound.choosecar_btn_chooseitem,0);
		if self.m_DataMgr:IsBuyCar( carname ) then -- has buy this car
			--ClosePage( "choosecar" );
			--ShowPage( "chosetrack" );
			
			local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
			shopTbl:ContinueGameToShop();
			ClosePage( "choosecar" );
			ShowPage( "shop" );
		end
	end

	return 1;
end

function	choosecar:GiftUpgradeSuccess()
	self.m_DataMgr:AddItemNum( ITEM_MILLISE, 15 );
	self.m_DataMgr:AddItemNum( ITEM_SHIELD, 15 );
	self.m_DataMgr:AddItemNum( ITEM_NITROGEN, 15 );

	local carname = property_car:GetName(self.m_carid);
	if self.m_DataMgr:IsBuyCar( carname ) then -- has buy this car
		local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
		shopTbl:ContinueGameToShop();
		ClosePage( "choosecar" );
		ShowPage( "shop" );
	end
end

function 	choosecar:Control_Event( object, param0, param1 )
	sGlobal:Print( "===================== iap id : "..param1 );
	if TIP_IAP == param0 then
		local iapID = param1;
		OnStartPurchase( iapID, nil );
	end
	ClosePage( "attion_box" );
	ClosePage( "pay" );
	return 1;
end

function	choosecar:EnableShowUiEffect( bShow )
	self.m_effect_chooseCar:SetVisible( bShow );
end

function	choosecar:Event_Free_Click( object, param0, param1 )
	self:EnableShowUiEffect( false );
	ShowDialog( "freebox" );
	return 1;
end

function	choosecar:IsCurCarUnLock()
	return self.m_DataMgr:IsBuyCar( property_car:GetName( self.m_carid ) );
end

function	choosecar:GetCarID()
	return self.m_carid;
end

function 	choosecar:EventKeyUp( key_code )
	if key_code == 27 then
		ClosePage( "choosecar" );
		ShowPage( "racemain" );
	elseif key_code == 13 then
		self.m_object:FindChildControl( "btn_choosecar_buyOrcontinue" ):SendMsg( "BN_CLICK", 0, 0 );
	end
	return 1;
end
function choosecar:Event_vip_clicked(object, param0, param1)
	ShowDialog("vipbox");
	return 1;
end
choosecar.ControlEvents = {
	Inputs = {
		btn_chooseCar_return = { "Event_Return_Click" };
		btn_chooseCar_To_Shop_1 = { "Event_To_Shop_1" };
		btn_chooseCar_To_Shop_2 = { "Event_To_Shop" };
		btn_chooseCar_ToLeft = { "Event_ChooseCar_To_Left" };
		btn_chooseCar_ToRight = { "Event_ChooseCar_To_Right" };
		btn_choosecar_buyOrcontinue = { "Event_Buy" };
		btn_tongyong1_1 = { "Event_Continue" };
		btn_refitCar = { "Event_RefitCar" };
		
		btn_free_choosecar = { "Event_Free_Click" };
		btn_vip = {"Event_vip_clicked"};
		--paycar = { "Control_Event" };
	}
}

