require("scripts/exl_level_data.lua")
require("scripts/exl_level_line_data.lua")
require("scripts/datasave.lua")
require( "ui/impl/diaframe.lua" )
require( "ui/impl/uisound.lua" )
require( "ui/impl/figure.lua" )
require("scripts/levelinfo.lua")

RACING = 0;
CHASE = 1;
ACCELERATE = 2;

choosetrack = {
	m_object;
	m_uiMgr;
	m_DataMgr;
	m_entitySys;
	m_trackBg;
	m_bg_tack_reward;
	m_bg_track_id;
	m_model_effect;
	m_track_text_reward_1;
	m_track_text_reward_2;
	m_track_text_reward_3;
	m_text_cond = {};
	m_sym_track;
	m_sym_track_bg;
	m_text_model_name;
	m_text_track_name;
	m_time_score;
	m_dis_score;
	m_disObj = {};
	
	m_btn_go;
	
	m_btn_free_choosetrack;
	m_free_value_bg_choosetrack;
	m_free_value_choosetrack;
	
	m_curModel = RACING;
	m_TrackID = 1;
	m_RacingTrackID = 1;
	m_tempTrackID = 1;
	m_text_choosetrack_gold;
	m_trackIDNum = nil;
	m_numSymbol = { "no0", "no1", "no2", "no3", "no4", "no5", "no6", "no7", "no8", "no9" };
	gradeSym = { "addtop1", "addtop2", "addtop3" };
}

function choosetrack:Init( object )
	self.m_object = object;
end


function choosetrack:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	
	self.m_trackBg = self.m_object:FindChildControl( "track_bg" );
	self.m_text_choosetrack_gold = self.m_object:FindChildControl( "text_choosetrack_gold" );
	self.m_bg_tack_reward = self.m_object:FindChildControl( "bg_tack_reward" );
	self.m_bg_track_id = self.m_object:FindChildControl( "text_track_id" );
	
	self.m_track_text_reward_1 = self.m_object:FindChildControl( "text_first_reward" );
	self.m_track_text_reward_2 = self.m_object:FindChildControl( "text_second_reward" );
	self.m_track_text_reward_3 = self.m_object:FindChildControl( "text_third_reward" );

	self.m_text_cond[1] = self.m_object:FindChildControl( "text_third_condition" );
	self.m_text_cond[2] = self.m_object:FindChildControl( "text_second_condition" );
	self.m_text_cond[3] = self.m_object:FindChildControl( "text_first_condition" );

	self.m_btn_free_choosetrack = self.m_object:FindChildControl( "btn_free_choosetrack" );
	self.m_free_value_bg_choosetrack = self.m_object:FindChildControl( "free_value_bg_choosetrack" );
	self.m_free_value_choosetrack = self.m_object:FindChildControl( "free_value_choosetrack" );
	
	self.m_time_score = self.m_object:FindChildControl( "text_time_record" );
	self.m_text_track_name = self.m_object:FindChildControl( "text_track_name" );
	--self.m_dis_score = self.m_object:FindChildControl( "dis_score" );
	
	self.m_sym_track = self.m_object:FindChildControl( "sym_track" );
	self.m_sym_track_bg = self.m_object:FindChildControl( "sym_track_bg" );
	--self.m_sym_chase_linear_bg = self.m_object:FindChildControl( "sym_chase_linear_bg" );
	self.m_text_model_name = self.m_object:FindChildControl( "text_model_name" );
	--self.m_model_effect = self.m_object:FindChildControl( "model_effect" );
	self.m_btn_go = self.m_object:FindChildControl( "btn_go" );
	self.m_btn_go:SelectAnimation( "ani_start", true, false );
	self.m_btn_go:PauseAnim( true, false );
	
	self.m_trackIDNum = self.m_object:FindChildControl( "text_track_id" );
	
	self:AddTrackItem();
	local size = self.m_trackBg:GetChildCount();
	local ctrl;
	for i = 0, size - 1 do
		ctrl = self.m_trackBg:GetControl(i);
		ctrl:GetScript():SetOwner( self.m_trackBg );
		ctrl:GetScript():SetListener( self.m_object );
	end
	
	return 1;
end

function choosetrack:EventActive( object, param0, param1 )
	self.m_DataMgr = Global:GetDataMgr();
	self.m_entitySys = sGlobal:GetEntitySys();
	local trackID = datasave:GetRacingSelectTrackID();
	self.m_trackBg:GetControl( trackID - 1 ):GetScript():SetCheck(true);
	self:ScrollTrack( trackID - 1 );
	self:RefreshModel();
	self:UpdateTrackItemRanking();
	self.m_btn_free_choosetrack:SetVisible( channel.m_bEnableFreeDiamond );
	
	--[[--
	if channel.m_EnableShowShop then
		self.m_object:FindChildControl( "btn_choosetrack_to_shop_2" ):SetVisible( true );
		self.m_object:FindChildControl( "fk_b" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_choosetrack_to_shop_2" ):SetVisible( false );
		self.m_object:FindChildControl( "fk_b" ):SetVisible( false );
	end
	--]]--
	
	--if channel.m_bEnableAd then
	--	Global:SystemRequest( SystemEvent.SE_HIDE_AD );
	--end
	return 1;
end

function choosetrack:Update( duration )
	if sGlobal:IsEditor() then
		return;
	end

	local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
	self.m_text_choosetrack_gold:SetSymbolText( gold );

	self:RefreshModel();
	self:UpdateTrackItem();
	
	if channel.m_bEnableFreeDiamond then
		local num = 0;
		if Global:SystemRequest( SystemEvent.SE_INTERNET ) then
			if not datasave:IsLikeFaceBook() then
				num = num + 1;
			end
			
			if not datasave:IsLikeTwitter() then
				num = num + 1;
			end
		end
		
		if Global:SystemRequest( SystemEvent.SE_VIDEO_AVAILABLE ) then
			num = num + 1;
		end
		
		self.m_free_value_choosetrack:SetSymbolText( num );
		if num > 0 then
			self.m_free_value_bg_choosetrack:SetVisible( true );
		else
			self.m_free_value_bg_choosetrack:SetVisible( false );
		end
	end
end

function choosetrack:ScrollTrack( index )
	local ctrl = self.m_trackBg:GetControl(index);
	local scalex = self.m_object:GetWidth() / self.m_object:GetClientWidth();
	self.m_trackBg:GetScript():ScrollToPos( -ctrl:GetClientPosX()* scalex, 1 );
end

function choosetrack:UpdateTrackItemRanking()
	local size = #( exl_level_data );
	local bestRank = 50;
	local rankObj = {};
	local ctrl;
	local gradeSym;

	for i = 0, size - 1 do
		ctrl = self.m_trackBg:GetControl(i);
		
		local levelInfo = record_level:GetRecord( i + 1 );
		bestRank = levelInfo.rank;
		--sGlobal:Print("rank"..levelInfo.rank);
		gradeSym = ctrl:FindChildControl( "sym_grade_track" );
		if bestRank <= 3 then
			gradeSym:SetVisible( true );
			gradeSym:SetSymbol( self.gradeSym[bestRank] );
		else
			gradeSym:SetVisible( false );
		end
	end
end

function choosetrack:AddTrackItem()
	local clone = self.m_object:FindChildControl( "btn_track_1" );
	local size = #( exl_level_data );
	local ctrl;
	for i = 1, size do
		ctrl = ControlUnit:new();
		clone:Clone( ctrl );
		ctrl:FindChildControl( "text_trackID" ):SetSymbolText(i);
		ctrl:FindChildControl( "mapbg_1" ):SetSymbol( exl_level_data[i].m_mapBg );
		ctrl:FindChildControl( "mapbg_1" ):SetAmbient( 0.4, 0.4, 0.4, 1.0 , false );
		ctrl:FindChildControl( "track_1" ):SetSymbol( exl_level_data[i].m_mapTrack );
		ctrl:FindChildControl( "text_level_mode_name" ):SetSymbol( Level_GetModeName(i) );
		self.m_trackBg:AddControl( ctrl );
	end
	
	clone:UnloadScript();
	clone:RemoveSelf();
	clone = nil;
end

function choosetrack:RefreshModel()
	self.m_text_model_name:SetSymbol( Level_GetModeName(self.m_tempTrackID) );
	self.m_text_track_name:SetSymbol( Level_GetMapName( self.m_tempTrackID ) );
	self.m_object:FindChildControl( "text_model_info" ):SetSymbol( Level_GetModeInfo(self.m_tempTrackID) );

	if datasave:IsTrackUnlock( self.m_tempTrackID ) then
		self.m_btn_go:SetVisible( true );
	else
		self.m_btn_go:SetVisible( false );
	end
--[[--
	if self.m_curModel == RACING then
		self.m_ShortCutBtn[1]:GetScript():SetCheck(true, false);
		self.m_text_model_name:SetSymbol( "text_mode111" );
		self.m_object:FindChildControl( "text_model_info" ):SetSymbol( "text_canGetScore" );
		self.m_sym_chase_linear_bg:SetVisible( false );
		self.m_sym_track_bg:SetVisible( true );
		self.m_bg_tack_reward:SetVisible( true );
		self.m_bg_track_id:SetVisible( true );
		self.m_time_score:SetVisible( true );
		self.m_dis_score:SetVisible( false );
		
		self.m_object:FindChildControl( "bgblack_2" ):SetVisible( true );
		self.m_model_effect:SetVisible( false );
		
		if datasave:IsTrackUnlock( self.m_tempTrackID ) then
			self.m_btn_go:SetVisible( true );
		else
			self.m_btn_go:SetVisible( false );
		end
	elseif self.m_curModel == CHASE then
		self.m_ShortCutBtn[2]:GetScript():SetCheck(true, false);
		self.m_text_model_name:SetSymbol( "text_mode133" );
		self.m_object:FindChildControl( "text_model_info" ):SetSymbol( "text_mode2" );
		self.m_sym_chase_linear_bg:SetVisible( true );
		self.m_sym_chase_linear_bg:SetSymbol( "mt1" );
		self.m_sym_track_bg:SetVisible( false );
		self.m_bg_tack_reward:SetVisible( false );
		self.m_bg_track_id:SetVisible( false );
		self.m_time_score:SetVisible( true );
		self.m_dis_score:SetVisible( false );
		
		self.m_object:FindChildControl( "bgblack_2" ):SetVisible( false );
		self.m_model_effect:SetVisible( true );
		
		self.m_btn_go:SetVisible( true );
	elseif self.m_curModel == ACCELERATE then
		self.m_ShortCutBtn[3]:GetScript():SetCheck(true, false);
		self.m_text_model_name:SetSymbol( "text_mode122" );
		self.m_object:FindChildControl( "text_model_info" ):SetSymbol( "text_mode3" );
		self.m_sym_chase_linear_bg:SetVisible( true );
		self.m_sym_chase_linear_bg:SetSymbol( "mt2" );
		self.m_sym_track_bg:SetVisible( false );
		self.m_bg_tack_reward:SetVisible( false );
		self.m_bg_track_id:SetVisible( false );
		self.m_time_score:SetVisible( false );
		self.m_dis_score:SetVisible( true );
		
		self.m_object:FindChildControl( "bgblack_2" ):SetVisible( false );
		self.m_model_effect:SetVisible( true );
		self.m_btn_go:SetVisible( true );
	end
--]]--
end

function choosetrack:UpdateTrackItem()
	local size = self.m_trackBg:GetChildCount();
	local lockCtrl;
	for i = 1, size do
		lockCtrl = self.m_trackBg:GetControl(i-1):FindChildControl( "track_lock" );
		
		if datasave:IsTrackUnlock( i ) then
			lockCtrl:SetVisible( false );
		else
			lockCtrl:SetVisible( true );
		end
	end
	
	lockCtrl = self.m_object:FindChildControl( "scenceLock" );
	if datasave:IsTrackUnlock( self.m_tempTrackID ) then
		lockCtrl:SetVisible( false );
	else
		lockCtrl:SetVisible( true );
	end
	
	local digital = 0;
	local count = 0;
	local trackID = self.m_tempTrackID;
	self.m_trackIDNum:SetSymbolText( trackID );
	
	local levelInfo = record_level:GetRecord( self.m_tempTrackID );
	-- minTime
	if exl_level_data[self.m_tempTrackID].m_Mode == 0 or exl_level_data[self.m_tempTrackID].m_Mode == 3 then
		self.m_text_cond[1]:SetSymbol( "mcname3" );
		self.m_text_cond[2]:SetSymbol( "mcname2" );
		self.m_text_cond[3]:SetSymbol( "mcname1" );
	elseif exl_level_data[self.m_tempTrackID].m_Mode == 1 then
		local maxDis = math.floor( levelInfo.dist + 0.5 );
		self.m_time_score:SetSymbolText( maxDis.."M" );

		for i = 1, 3 do
			local dist_cond = Level_GetRankCondition_dist(self.m_tempTrackID, i)

			self.m_text_cond[i]:SetSymbolText( dist_cond.."M" );
		end
	else 
		for i = 1, 3 do
			local time_cond = Level_GetRankCondition_time(self.m_tempTrackID, i)
	
			self.m_text_cond[i]:SetSymbolText(TimeToString(time_cond).."M");
		end
	end

	if exl_level_data[self.m_tempTrackID].m_Mode ~= 1 then
		count = 0;
		digital = 0;
		local minTime = levelInfo.time;--self.m_DataMgr:GetLevelMinTime( RACING, self.m_tempTrackID );
	
		if minTime == 0.0 then
			self.m_time_score:SetSymbolText("--:--:--");
		else
			self.m_time_score:SetSymbolText(TimeToString(minTime));
		end
	end
		
	-- minTime
	self.m_track_text_reward_1:SetSymbolText( levelinfo:GetLevelReward(self.m_tempTrackID, 3) );
	self.m_track_text_reward_2:SetSymbolText( levelinfo:GetLevelReward(self.m_tempTrackID, 2) );
	self.m_track_text_reward_3:SetSymbolText( levelinfo:GetLevelReward(self.m_tempTrackID, 1) );
end

function choosetrack:StartGame( bRestart )
	Global:StopMusic();
	self.m_DataMgr = Global:GetDataMgr();
	
	local curCar = self.m_DataMgr:GetCurCar();
	local player = self.m_entitySys:GetRegisterEntity( "Player" );
	local file = self.m_uiMgr:GetPage( "choosecar" ):GetScript():GetCarFile( curCar );
	
	player:LoadFromFile( file );
	--player:LoadFromFile( "obj/feixingqi01/ship1.zc" );
	player:InitCar();

	ClearMap();
	figure:Clear();
	self.m_uiMgr:GetPage( "Track" ):GetScript():ClearCar();
	local trackID = self:EnterTrack( bRestart );
	sGlobal:Print( "m_curModel : "..self.m_curModel );
	sGlobal:Print( "trackID : "..trackID );
	SetMapSymbol( self.m_curModel, trackID );
	ClosePage( "shop" );
	ClosePage( "choosecar" );
	ClosePage( "chosetrack" );
	
	local loading = self.m_uiMgr:GetPage("loading");
	self.m_uiMgr:OpenWindow(loading);
	
	local racingTbl = self.m_uiMgr:GetPage( "Track" ):GetScript();
	racingTbl:Reset();
	Global:Resume();
end

function choosetrack:ClickTrack( id )
	self.m_DataMgr = Global:GetDataMgr();
	local index = id + 1;
	self.m_tempTrackID = index;
	--sGlobal:Print( "ClickTrack ID: "..self.m_tempTrackID );
	if datasave:IsTrackUnlock( index ) then
		self.m_btn_go:SetVisible( true );
		self.m_btn_go:PauseAnim( false, false );
		
		self.m_TrackID = index;
		--sGlobal:Print( "choosetrack ID: "..self.m_TrackID );
		self.m_RacingTrackID = self.m_TrackID;
		self.m_DataMgr:SetLevel( self.m_TrackID );
		self.m_sym_track_bg:SetSymbol( exl_level_data[self.m_TrackID].m_mapBg );
		self.m_sym_track:SetSymbol( exl_level_data[self.m_TrackID].m_mapTrack );	
		
		Global:PlaySound(uisound.choosetrack_chooseitem,0);
	else
		if channel.m_EnableShowShop then
			self.m_sym_track_bg:SetSymbol( exl_level_data[index].m_mapBg );
			self.m_sym_track:SetSymbol( exl_level_data[index].m_mapTrack );	
			self.m_btn_go:PauseAnim( true, false );
			self.m_btn_go:SetVisible( false );
			--self.m_uiMgr:GetPage( "attion_box" ):GetScript():SetMsgType( TIP_UNLOCKTRACK );
			--ShowDialog( "attion_box" );
			
			ShowDialog( "the6" );
			Global:PlaySound(uisound.choosetrack_chooseitem,0);
		else
			self.m_sym_track_bg:SetSymbol( exl_level_data[index].m_mapBg );
			self.m_sym_track:SetSymbol( exl_level_data[index].m_mapTrack );	
			self.m_btn_go:SetVisible( false );
			Global:PlaySound(uisound.nomoney,0);
		end
	end
end

function choosetrack:OnListItemCheck( obj )
	local size = self.m_trackBg:GetChildCount();
	local ctrl;
	for i = 0, size - 1 do
		ctrl = self.m_trackBg:GetControl(i);
		if obj == ctrl then
			self:ClickTrack(i);
			return;
		end
	end
end

function choosetrack:EnterTrack( bRestart )
	sGlobal:Print( "cur model : ".. self.m_curModel );
	self.m_DataMgr = Global:GetDataMgr();
	self.m_DataMgr:SetDistanse( 0 );
	if self.m_curModel == RACING then
		self.m_RacingTrackID = self.m_TrackID;
		self.m_DataMgr:SetLevel( self.m_TrackID );
		Global:StartLoading( exl_level_data[self.m_TrackID].m_trackFile );
		datasave:SetRacingSelectTrackID( self.m_RacingTrackID );
		local NoticeName = "0_"..self.m_TrackID;
		Global:EventNoticeEx( "enter_level", NoticeName );
	elseif self.m_curModel == CHASE then
		local size = #(exl_level_data);
		local unlockID = {};
		for i = 1, size do
			if datasave:IsTrackUnlock( i ) then
				table.insert( unlockID, {id = i} );
			end
		end
		
		local randomsize = #(unlockID); 
		if not bRestart then
			self.m_TrackID = unlockID[math.floor( Global:RandFloat( 1.0, randomsize ) + 0.5 )].id;
		end
		
		sGlobal:Print( "m_TrackID ================ 1 "..self.m_TrackID );
		self.m_DataMgr:SetLevel( self.m_TrackID );
		Global:StartLoading( exl_level_data[self.m_TrackID].m_trackFile );
		
		local NoticeName = "1_"..self.m_TrackID;
		Global:EventNoticeEx( "enter_level", NoticeName );
	elseif self.m_curModel == ACCELERATE then
		-- self.m_TrackID = math.floor( Global:RandFloat( 1.0, 6.0 ) + 0.5 );
		-- self.m_DataMgr:SetLevel( self.m_TrackID );
		-- Global:StartLoading( exl_level_line_data:GetScene(self.m_TrackID) );
		
		local size = #(exl_level_data);
		local unlockID = {};
		for i = 1, size do
			if datasave:IsTrackUnlock( i ) then
				table.insert( unlockID, {id = i} );
			end
		end
		
		local randomsize = #(unlockID); 
		if not bRestart then
			self.m_TrackID = unlockID[math.floor( Global:RandFloat( 1.0, randomsize ) + 0.5 )].id;
		end
		
		sGlobal:Print( "m_TrackID ================ 2 "..self.m_TrackID );
		self.m_DataMgr:SetLevel( self.m_TrackID );
		Global:StartLoading( exl_level_data[self.m_TrackID].m_trackFile );
		
		local NoticeName = "2_"..self.m_TrackID;
		Global:EventNoticeEx( "enter_level", NoticeName );
	end

	return self.m_TrackID;
end

function 	choosetrack:ChooseModel( model )
	self.m_curModel = model;
	self.m_DataMgr = Global:GetDataMgr();
	self.m_DataMgr:SetModel( model );
	self:RefreshModel();
end

function choosetrack:NextLevel()
	self.m_DataMgr = Global:GetDataMgr();
	self.m_TrackID = self.m_TrackID + 1;
	self.m_RacingTrackID = self.m_TrackID;
	self.m_DataMgr:SetLevel( self.m_TrackID );
	self:StartGame( false );
end

function choosetrack:IsNextLevelEnable()
	if self.m_TrackID < #(exl_level_data) then
		return true;
	end
	return false;
end

function choosetrack:Control_Event( object, param0, param1 )
	ClosePage( "attion_box" );
	return 1;
end

function choosetrack:UnlockTrack_Event( object, param0, param1 )
	if object == "UNLOCK_TRACK" then
		OnStartPurchase( PCS_TRACK_UNLOCK, nil );
	end
	return 1;
end

function	choosetrack:Event_Go_Click( event, param0, param1 )
	local bCarUnlock = self.m_uiMgr:GetPage( "choosecar" ):GetScript():IsCurCarUnLock();
	if bCarUnlock then
		self:StartGame( false );
	else
		ClosePage( "chosetrack" );
		ShowPage( "choosecar" );
	end
	
	Global:PlaySound(uisound.choosetrack_btn_go,0);
	return 1;
end

function	choosetrack:Event_Return_Click( event, param0, param1 )
	ClosePage( "chosetrack" );
	ShowPage( "choosecar" );
	Global:PlaySound(uisound.btn_return,0);
	return 1;
end

function	choosetrack:Event_Track_To_Left( event, param0, param1 )
	self.m_trackBg:GetScript():ScrollToPos( self.m_trackBg:GetScript():GetScrollPos() + self.m_trackBg:GetControl(0):GetWidth() * 2.0, 0 );
	return 1;
end

function	choosetrack:Event_Track_To_Right( event, param0, param1 )
	
	self.m_trackBg:GetScript():ScrollToPos( self.m_trackBg:GetScript():GetScrollPos() - self.m_trackBg:GetControl(0):GetWidth() * 2.0, 0 );
	return 1;
end

function	choosetrack:Event_Shop_Click( event, param0, param1 )
	if channel.m_EnableShowShop then
		ClosePage( "chosetrack" );
		
		self.m_uiMgr:GetPage( "shop" ):GetScript():ChooseTrackToShop();
		ShowPage( "shop" );
		Global:PlaySound(uisound.btn_To_Shop,0);
	end
	return 1;
end

function	choosetrack:Event_Shop_Click_1( event, param0, param1 )
	if channel.m_EnableShowShop then
		ClosePage( "chosetrack" );
		
		local shopTbl = self.m_uiMgr:GetPage( "shop" ):GetScript();
		shopTbl:ChooseTrackToShop();
		shopTbl:IsToIapFrm( true );
		
		ShowPage( "shop" );
		Global:PlaySound(uisound.btn_To_Shop,0);
	end
	return 1;
end

function	choosetrack:Event_Free_Click( object, param0, param1 )
	--self:EnableShowUiEffect( false );
	ShowDialog( "freebox" );
	return 1;
end

function 	choosetrack:EventKeyUp( key_code )
	if key_code == 27 then
		self:Event_Return_Click( nil, 0, 0 );
	elseif key_code == 13 then
		if self.m_btn_go:IsVisible() then
			self.m_object:FindChildControl( "btn_go" ):SendMsg( "BN_CLICK", 0, 0 );
		end
	end
	return 1;
end

choosetrack.ControlEvents = {
	Inputs = {
		btn_go = { "Event_Go_Click" };
		btn_choosetrack_return = { "Event_Return_Click" };
		btn_choosetrack_to_left = { "Event_Track_To_Left" };
		btn_choosetrack_to_right = { "Event_Track_To_Right" };
		btn_choosetrack_to_shop_1 = { "Event_Shop_Click_1" };
		btn_choosetrack_to_shop_2 = { "Event_Shop_Click" };
		
		--btn_model_racing = { "Event_Racing_Click" };
		--btn_model_chase = { "Event_Chase_Click" };
		--btn_model_accelerate = { "Event_Accelerate_Click" };
		attion_box = { "Control_Event" };
		the6 = { "UnlockTrack_Event" };
		
		btn_free_choosetrack = { "Event_Free_Click" };
	}
}