require( "scripts/global.lua" )
require("scripts/datasave.lua")
TIP_UNLOCKTRACK = 0;
TIP_EXIT = 1;
TIP_IAP = 2;
TIP_BUY_ITEM = 3;

diaframe = {
	m_object;
	m_uiMgr;
	m_MsgType;
	
	m_UnlockTrack;
	m_Exit;
	
	m_frm_iap;
	m_frm_buyItem;
	m_st_double;
	
	m_Num = 1;
	m_iapID = 1;
	
	m_item_num;
	
	m_bPause = false;
	m_ItemPriceObj;
	m_ItemPrice = 1;
}

function	diaframe:Init( object )
	self.m_object = object;
end

function	diaframe:EventInit( event, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	
	self.m_UnlockTrack = self.m_object:FindChildControl( "unlock_1" );
	self.m_Exit = self.m_object:FindChildControl( "requit_1" );
	
	self.m_frm_iap = self.m_object:FindChildControl( "iap_frm" );
	self.m_frm_buyItem = self.m_object:FindChildControl( "buyitem" );
	self.m_item_num = self.m_object:FindChildControl( "item_num" );
	self.m_ItemPriceObj = self.m_object:FindChildControl( "item_price" );
	self.m_st_double = self.m_object:FindChildControl( "topchong1_7" );
	
	if channel.m_bUseJinBi then
		self.m_object:FindChildControl( "iap_JB" ):SetSymbol("JB");
	end
	return 1;
end

function	diaframe:EnablePause( bPause )
	self.m_bPause = bPause;
	if bPause then
		Global:Pause();
	end
end

function	diaframe:EventActive( event, param0, param1 )
	--pause
	self.m_object:SelectAnimation( "ani_attionbox", false, true );
	--self.m_object:PauseAnim( true, true );
	self.m_object:PauseAnim( false, true );
	--self.m_object:SetSymbol( "bgblack" );
	self.m_Num = 10;
	self.m_ItemPrice = 1;
	
	self.m_item_num:SetSymbolText( self.m_Num );
	self:UpdateItemPrice();
	
	if channel:GetCurChannel() == "wp8" then
		self.m_object:FindChildControl( "iap_price" ):SetSymbol( "" );
	elseif channel:GetCurChannel() == "android_msy" then
		self.m_object:FindChildControl( "iap_price" ):SetSymbol( "" );
	else
		self.m_object:FindChildControl( "iap_price" ):SetSymbol( "fh" );
	end
	if channel:IsVipEnabled() then
		if datasave:GetVipLevel() > 0 then
			self.m_object:FindChildControl("vip_title_quick_shop"):SetVisible(true);
		else
			self.m_object:FindChildControl("vip_title_quick_shop"):SetVisible(false);
		end
	else
		self.m_object:FindChildControl("vip_title_quick_shop"):SetVisible(false);
	end
	self.m_st_double:SetVisible( not datasave:IsIap() );
	return 1;
end

function	diaframe:SetItemPrice( price )
	self.m_ItemPrice = price;
	self:UpdateItemPrice();
end

function	diaframe:SetNum( num )
	self.m_Num = num;
	self.m_item_num:SetSymbolText( self.m_Num );
	self:UpdateItemPrice();
end

function	diaframe:EventDeactive( event, param0, param1 )
	if self.m_bPause then
		Global:Resume();
	end
	self.m_bPause = false;
	return 1;
end

function	diaframe:SetItemName( name )
	self.m_object:FindChildControl( "text_itemName" ):SetSymbol( name );
end

function	diaframe:SetIapPrice( price )
	local ctrl = self.m_object:FindChildControl( "text_price" );
	local iapGold = self.m_object:FindChildControl( "iap_gold" );
	ctrl:SetVisible( true );
		

	local count = 6;
	if channel.m_bEnableLargeAmounts then
		count = 6;
	else
		count = 3;
	end

	if channel.m_bUseIapSymbol then
		ctrl:SetSymbol( IapItemSymbol[count] );
	else
		if channel.m_bUseEvenIap then
			local value = math.floor((IapItemId[count] + 1) / 2) * 2;
			ctrl:SetSymbolText( value );
		else
			ctrl:SetSymbolText( IapItemId[count] );
		end
	end
	iapGold:SetSymbolText( ""..(IapItem[count] / 10000) );
	self.m_iapID = IapItemId[count];

	for i = 1, count do
		if price < IapItem[i] then
			if channel.m_bUseIapSymbol then
				ctrl:SetSymbol( IapItemSymbol[i] );
			else
				if channel.m_bUseEvenIap then
					local value = math.floor((IapItemId[i] + 1) / 2) * 2;
					ctrl:SetSymbolText( value );
				else
					ctrl:SetSymbolText( IapItemId[i] ); -- 5
				end
			end
			iapGold:SetSymbolText( ""..(IapItem[i] / 10000) );
			self.m_iapID = IapItemId[i];
			break;
		end
	end
end

function 	diaframe:SetMsgType( msgtype )
	self.m_MsgType = msgtype;
	if self.m_MsgType == TIP_UNLOCKTRACK then
		self.m_Exit:SetVisible( false );
		self.m_frm_iap:SetVisible( false );
		self.m_frm_buyItem:SetVisible( false );
		self.m_UnlockTrack:SetVisible( true );
	elseif self.m_MsgType == TIP_EXIT then
		self.m_Exit:SetVisible( true );
		self.m_frm_iap:SetVisible( false );
		self.m_frm_buyItem:SetVisible( false );
		self.m_UnlockTrack:SetVisible( false );
	elseif self.m_MsgType == TIP_IAP then
		self.m_Exit:SetVisible( false );
		self.m_frm_iap:SetVisible( true );
		self.m_frm_buyItem:SetVisible( false );
		self.m_UnlockTrack:SetVisible( false );
	elseif self.m_MsgType == TIP_BUY_ITEM then
		self.m_Exit:SetVisible( false );
		self.m_frm_iap:SetVisible( false );
		self.m_frm_buyItem:SetVisible( true );
		self.m_UnlockTrack:SetVisible( false );
		self.m_item_num:SetSymbolText( self.m_Num );
	end
end

function 	diaframe:EventClose( object, param0, param1 )
	self.m_uiMgr:CloseWindow(self.m_object);
	Global:PlaySound(uisound.btn_return,0);
	return 1;
end

function 	diaframe:EventConfirm( object, param0, param1 )
	if self.m_MsgType == TIP_BUY_ITEM then
		self.m_object:SendMsg( "WARNING_OK", self.m_MsgType, self.m_Num );
	elseif self.m_MsgType == TIP_IAP then
		self.m_object:SendMsg( "WARNING_OK", self.m_MsgType, self.m_iapID );
	else
		self.m_object:SendMsg( "WARNING_OK", self.m_MsgType, 0 );
	end
	--self.m_uiMgr:CloseWindow(self.m_object);
	return 0;
end

function 	diaframe:Event_Item_Left( object, param0, param1 )
	self.m_Num = self.m_Num - 1;
	if self.m_Num < 1 then
		self.m_Num = 1;
	end
	self.m_item_num:SetSymbolText( self.m_Num );
	self:UpdateItemPrice();
	return 1;
end
function diaframe:UpdateItemPrice()
	if channel:IsVipEnabled() then
		self.m_ItemPriceObj:SetSymbolText(math.floor(self.m_ItemPrice*self.m_Num*VipData[datasave:GetVipLevel()][3]));
	else
		self.m_ItemPriceObj:SetSymbolText(math.floor(self.m_ItemPrice*self.m_Num));
	end
end
function 	diaframe:Event_Item_Right( object, param0, param1 )
	self.m_Num = self.m_Num + 1;
	if self.m_Num > 50 then
		self.m_Num = 50;
	end
	self.m_item_num:SetSymbolText( self.m_Num );
	self:UpdateItemPrice();
	return 1;
end

function 	diaframe:EventKeyUp( key_code )
	if key_code == 27 then
		self.m_uiMgr:CloseWindow(self.m_object);
	elseif key_code == 13 then
		self.m_object:FindChildControl( "btn_confirm" ):SendMsg( "BN_CLICK", 0, 0 );
	end
	return 1;
end


diaframe.ControlEvents = {
	Inputs = {
		btn_close = { "EventClose" };
		btn_confirm = { "EventConfirm" };
		btn_item_left = { "Event_Item_Left" };
		btn_item_right = { "Event_Item_Right" };
	};
	
};
