require( "scripts/global.lua" )

diaframe_buycar = {
	m_object;
	m_uiMgr;
	m_MsgType;
	m_iapID = 1;
}

function	diaframe_buycar:Init( object )
	self.m_object = object;
end

function	diaframe_buycar:EventInit( event, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();

	if channel.m_bUseJinBi then
		self.m_object:FindChildControl( "iap_car_BJ" ):SetSymbol("JB");
	end
	
	return 1;
end

function	diaframe_buycar:EventDeactive( event, param0, param1 )
	ShowPage( "choosecar" );
	return 1;
end

function	diaframe_buycar:EventActive( event, param0, param1 )
	--pause
	self.m_object:SelectAnimation( "ani_attionbox", false, true );
	--self.m_object:PauseAnim( true, true );
	self.m_object:PauseAnim( false, true );
	
	if channel:GetCurChannel() == "wp8" then
		self.m_object:FindChildControl( "iap_price_1" ):SetSymbol( "" );
	elseif channel:GetCurChannel() == "android_msy" then
		self.m_object:FindChildControl( "iap_price_1" ):SetSymbol( "" );
	else
		self.m_object:FindChildControl( "iap_price_1" ):SetSymbol( "fh" );
	end
	return 1;
end

function	diaframe_buycar:SetIapPrice( price )
	sGlobal:Print( "price  =  "..price );
	local ctrl = self.m_object:FindChildControl( "text_price_1" );
	local iapGold = self.m_object:FindChildControl( "iap_gold_1" );
	ctrl:SetVisible( true );

	local count = 6;
	if channel.m_bEnableLargeAmounts then
		count = 6;
	else
		count = 3;
	end

	if channel.m_bUseIapSymbol then
		ctrl:SetSymbol( IapItemSymbol[count] );
	else
		if channel.m_bUseEvenIap then
			local value = math.floor((IapItemId[count] + 1) / 2) * 2;
			ctrl:SetSymbolText( value );
		else
			ctrl:SetSymbolText( IapItemId[count] );
		end
	end
	iapGold:SetSymbolText( ""..(IapItem[count] / 10000) );
	self.m_iapID = IapItemId[count];

	for i = 1, count do
		if price < IapItem[i] then
			if channel.m_bUseIapSymbol then
				ctrl:SetSymbol( IapItemSymbol[i] );
			else
				if channel.m_bUseEvenIap then
					local value = math.floor((IapItemId[i] + 1) / 2) * 2;
					ctrl:SetSymbolText( value );
				else
					ctrl:SetSymbolText( IapItemId[i] ); -- 5
				end
			end
			iapGold:SetSymbolText( ""..(IapItem[i] / 10000) );
			self.m_iapID = IapItemId[i];
			break;
		end
	end
end

function 	diaframe_buycar:SetMsgType( msgtype )
	sGlobal:Print( "SetMsgType : "..msgtype );
	self.m_MsgType = msgtype;
end

function 	diaframe_buycar:EventClose( object, param0, param1 )
	self.m_uiMgr:CloseWindow(self.m_object);
	Global:PlaySound(uisound.btn_return,0);
	return 1;
end

function 	diaframe_buycar:EventConfirm( object, param0, param1 )
	sGlobal:Print( "diaframe_buycar SetMsgType : "..self.m_MsgType );
	if self.m_MsgType == TIP_IAP then
		OnStartPurchase( self.m_iapID, nil );
	end
	return 0;
end

function 	diaframe_buycar:EventKeyUp( key_code )
	if key_code == 27 then
		self.m_uiMgr:CloseWindow(self.m_object);
	elseif key_code == 13 then
		self.m_object:FindChildControl( "btn_confirm_1" ):SendMsg( "BN_CLICK", 0, 0 );
	end
	return 1;
end

diaframe_buycar.ControlEvents = {
	Inputs = {
		btn_close_1 = { "EventClose" };
		btn_confirm_1 = { "EventConfirm" };
	};	
};
