figure = {
	m_object;
	m_numGroup;
	PickUpInfo = {
		--{ uiObj = nil, x = 0, y = 0, oldTime = 0, bVisible = false },
	},
	m_pickUpLifeTime = 0.5;
	m_MoveSpeed = 800;

	PickUpInfoFreeList = {
		--{ obj }
	},

	m_Pos = Vector3:new( 0, 0, 0 );
}

FIGURE_GOLD = 0;
FIGURE_BLOOD = 1;

----------------pick up freelist
function	figure:InsertPickUpFreelist( freeObj )
	table.insert( self.PickUpInfoFreeList, { obj = freeObj } );
end
function	figure:GetPickUpFreeListItem()
	local size = #self.PickUpInfoFreeList;
	local Obj = nil;
	if size > 0 then
		Obj = self.PickUpInfoFreeList[1].obj;
		table.remove( self.PickUpInfoFreeList, 1 );
	end
	return Obj;
end
----------------pick up freelist

function	figure:Init( object, group )
	self.m_object = object;
	self.m_numGroup = group;
	self.m_numGroup:SetVisible( false );
end

function	figure:AddPickUp( figureType, value, pos )
	Global:Cal2dPos( pos, self.m_Pos );
	local posX = self.m_Pos[1];
	local posY = self.m_Pos[2];
	local numGroup = self:GetPickUpFreeListItem();
	if numGroup == nil then
		numGroup = ControlUnit:new();
		self.m_numGroup:Clone( numGroup );
	end
	numGroup:SetVisible( false );

	local wid = self.m_object:GetWidth();
	local hei = self.m_object:GetHeight();
	posY = hei * 0.5 - posY;
	posX = posX - wid * 0.5;
	
	local scale = self.m_object:GetClientWidth() / self.m_object:GetWidth();
	
	posY = posY * scale;
	posX = posX * scale;

	numGroup:SetClientPos( posX*scale , posY*scale );
	self.m_object:AddControl( numGroup );

	if figureType == FIGURE_BLOOD then
		numGroup:SetSymbolText( "+"..math.floor( value ) );
		numGroup:SetFontGradient( "ff00ff00", "ff00ff00" );
	elseif figureType == FIGURE_GOLD then
		numGroup:SetSymbolText( "+"..math.floor( value ) );
		numGroup:SetFontGradient( "ffa0ffff", "ffa0ffff" );
	end
	table.insert( self.PickUpInfo, { uiObj = numGroup, x = posX, y = posY, oldTime = 0, bVisible = false } );
	
	self:UpdatePickUp( 0.033 );
end

function	figure:Update( duration )
	self:UpdatePickUp( duration );
end

function	figure:UpdatePickUp( duration )
	local size = #(self.PickUpInfo);
	--sGlobal:Print( "size : "..size );
	for i = 1, size do
		if i <= #(self.PickUpInfo) then
			self.PickUpInfo[i].oldTime = self.PickUpInfo[i].oldTime + duration;
			self.PickUpInfo[i].y = self.PickUpInfo[i].y + self.m_MoveSpeed * duration;
			self.PickUpInfo[i].uiObj:SetClientPos( self.PickUpInfo[i].x , self.PickUpInfo[i].y );
			self.PickUpInfo[i].uiObj:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
			if self.PickUpInfo[i].bVisible == true then
				self.PickUpInfo[i].uiObj:SetVisible( true );
			end
			self.PickUpInfo[i].bVisible = true;
			if self.PickUpInfo[i].oldTime > self.m_pickUpLifeTime then
				self.PickUpInfo[i].uiObj:SetVisible( false );
				self.PickUpInfo[i].oldTime = 0;
				self:InsertPickUpFreelist( self.PickUpInfo[i].uiObj );
				self.PickUpInfo[i].uiObj:RemoveSelf();
				table.remove( self.PickUpInfo, i );
			end	
		end
	end
end

function	figure:Clear()
	self:ClearPickUp();
end

function	figure:ClearPickUp()
	local size = #( self.PickUpInfo );
	local size2 = size;
	local count = 0;
	for i = 1, size, 1 do
		i = i - count;
		if i <= size2 then
			self.PickUpInfo[i].uiObj:SetVisible( false );
			self.PickUpInfo[i].oldTime = 0;
			self:InsertPickUpFreelist( self.PickUpInfo[i].uiObj );
			self.PickUpInfo[i].uiObj:RemoveSelf();
			table.remove( self.PickUpInfo, i );
			size2 = #( self.PickUpInfo );
			count = count + 1;
		end
	end
end


