require( "ui/impl/uisound.lua" )

giftbox = {
	m_object;
	m_uiMgr;

	m_gift_failed_callback = nil;

	m_gift_index = 0;
	m_gift_state = nil;
}

function	giftbox:Init( object )
	self.m_object = object;
end

function	giftbox:EventInit( object )
	self.m_uiMgr = sGlobal:GetUIManager();
	return 1;
end

function	giftbox:SetGiftIndex( id )
	self.m_gift_index = id;
end

function	giftbox:SetFailedCallback( callback )
	self.m_gift_failed_callback = callback;
end

function	giftbox:EventActive( object, param0, param1 )
	self.m_object:SelectAnimation( "ani_pause", false, true );

	self.m_gift_index = datasave:GetLastGiftId();
	self.m_gift_state = datasave:GetLastGift();
	if self.m_pos == "winlose" then
		EventNotice("pack_winlose_open",self.m_gift_index);
	elseif self.m_pos == "shop" then
		EventNotice("pack_iap_open",self.m_gift_index);
	end

	--[[--
	local price = self.m_object:FindChildControl( "999_1" );
	if channel.m_bUseEvenIap == true then
		if self.m_gift_index == 3 then
			price:SetSymbol( "rmb6" );
		elseif self.m_gift_index == 4 or self.m_gift_index == 5 then
			price:SetSymbol( "rmb16" );
		end
	end
	if self.m_gift_index == 6 and channel.m_curChannel == "android_yyc" then
		price:SetSymbol( "rmb20" );
	end
	--]]--
	return 1;
end 

function	giftbox:Event_Close( object, param0, param1 )
	self.m_uiMgr:CloseWindow( self.m_object );

	if self.m_gift_failed_callback ~= nil then
		self.m_gift_failed_callback:GiftFailedCallback();
		self.m_gift_failed_callback = nil;
	end

	return 1;
end

function	giftbox:Event_Buy( object, param0, param1 )
	Global:PlaySound(uisound.shop_btn_iap,0);

	if self.m_gift_index == 1 then
		OnStartPurchase( PCS_GOLD_100000, self );
	elseif self.m_gift_index == 2 then
		OnStartPurchase( PCS_GOLD_9000000, self );
	elseif self.m_gift_index == 3 then
		OnStartPurchase( PCS_GOLD_3500000, self );
	elseif self.m_gift_index == 4 then
		OnStartPurchase( PCS_GOLD_3500000, self );
	elseif self.m_gift_index == 5 then
		OnStartPurchase( PCS_GOLD_8600000, self );
	elseif self.m_gift_index == 6 then
		Global:Print("Refit 0");
		OnStartPurchase( PCS_CAR_REFIT, self );
	end
		
	return 1;
end

function	giftbox:PurchaseSuccess( id )
	local dataMgr = Global:GetDataMgr();

	if self.m_gift_index == 1 then
		local dataMgr = Global:GetDataMgr();
		dataMgr:AddItemNum( ITEM_MILLISE, 2 );
		dataMgr:AddItemNum( ITEM_SHIELD, 2 );
		dataMgr:AddItemNum( ITEM_NITROGEN, 2 );
		datasave.m_bThanksGiftPurchased = true;
		datasave:SetGiftDone(1);
	elseif self.m_gift_index == 2 then
		GiveGiftAircraftById(5);
		datasave:SetGiftDone(2);
	elseif self.m_gift_index == 3 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[2] );
		GiveGiftAircraftById(4);
		GiveGiftAircraftById(5);
		datasave:SetGiftDone(3);
	elseif self.m_gift_index == 4 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[2] );
		GiveGiftAircraftById(6);
		datasave:SetGiftDone(4);
	elseif self.m_gift_index == 5 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[3] );
		GiveGiftAircraftById(7);
		datasave:SetGiftDone(5);
	elseif self.m_gift_index == 6 then
		Global:Print("Refit 1");
		local chcar = self.m_uiMgr:GetPage("choosecar");
		chcar:GetScript():GiftUpgradeSuccess();
	end

	if self.m_pos == "winlose" then
		EventNotice("pack_winlose_buy",self.m_gift_index);
	elseif self.m_pos == "shop" then
		EventNotice("pack_iap_buy",self.m_gift_index);
	end
	self.m_uiMgr:CloseWindow( self.m_object );

	return 1;
end

function 	giftbox:EventKeyUp( key_code )
	if key_code == 27 then
		self:Event_Close( nil, 0, 0 );
	end

	return 1;
end

giftbox.ControlEvents = {
	Inputs = {
		btn_gift_box_close = { "Event_Close" };
		btn_gift1_box_close = { "Event_Close" };
		btn_gift2_box_close = { "Event_Close" };
		btn_gift3_box_close = { "Event_Close" };
		btn_gift_upgrade_close = { "Event_Close" };
		btn_thanks_gift_close = { "Event_Close" };
		btn_cool_gift_close = {"Event_Close" };
		btn_gift_box_buy = {"Event_Buy" };
		btn_gift1_box_buy = {"Event_Buy" };
		btn_gift2_box_buy = {"Event_Buy" };
		btn_gift3_box_buy = {"Event_Buy" };
		btn_gift_upgrade = {"Event_Buy" };
		btn_thanks_gift_buy = {"Event_Buy" };
		btn_cool_gift_buy = {"Event_Buy" };
	}
}
