require( "ui/impl/uisound.lua" )
loading = {
	m_object;
	m_uiMgr;
	m_textStep;
	m_elapsedTime = 0.0;
	m_bShowBlack = false;
	m_waitTime = 2;
	m_bt_clickToStart;
	m_st_welcomeInfo;
	m_welcomTime = 2;
	m_welcomTimer = 0;
	m_bLoadingOver = false;
}

function	loading:Init( object )
	self.m_object = object;
end

function	loading:EventActive( object, param0, param1 )
	self.m_elapsedTime = 0.0;
	self.m_bShowBlack = false;
	
	if channel.m_bEnableAd and self.m_bRequstAD and not datasave:IsBuyIapMoreThan30() then
		sGlobal:Print( "loading:EventActive === SE_REQUEST_AD" );
		Global:SystemRequest( SystemEvent.SE_REQUEST_AD );
		self.m_bRequstAD = false;
	end
	
	if channel.m_bEnableAd and not datasave:IsBuyIapMoreThan30() then
		sGlobal:Print( "loading:EventActive === SE_SHOW_AD" );
		Global:SystemRequest( SystemEvent.SE_SHOW_AD );
	end
	
	if not datasave:GetDataFromLabel("fist_level") and not datasave:IsTrackUnlock(2) then
		self.m_waitTime = 0.0;
	else
		self.m_waitTime = 4.0;
	end
	self.m_st_welcomeInfo:SetVisible(false);
	self.m_bt_clickToStart:SetVisible(false);
	self.m_bLoadingOver = false;
	self.m_welcomTimer = 0;
	return 1;
end

function	loading:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_textStep = self.m_object:FindChildControl( "text_step" );
	self.m_st_welcomeInfo = self.m_object:FindChildControl("st_welcome_info");
	self.m_bt_clickToStart = self.m_object:FindChildControl("st_click_to_start");
	return 1;
end

function	loading:Update( duration )
	if sGlobal:IsEditor() then
		return;
	end
	self.m_elapsedTime = self.m_elapsedTime + duration;

	local step = Global:GetLoadingStep();
	if step >= 100 and self.m_elapsedTime > self.m_waitTime and not self.m_bLoadingOver then
		self.m_textStep:SetSymbolText( "100%" );
		if datasave:GetDataFromLabel("fist_level") then
			Global:Print("not fist level");
			self:Event_Click_To_Start();
		else
			self.m_bLoadingOver = true;
			self.m_welcomTimer = 0;
			self.m_st_welcomeInfo:SetVisible(true);
		end
	elseif not self.m_bLoadingOver and self.m_welcomTimer == 0 then
		if step > 99 then
			step = 99;
		end
		self.m_textStep:SetSymbolText( step.."%" );
	end
	if self.m_bLoadingOver then
		self.m_welcomTimer = self.m_welcomTimer + duration;
		if self.m_welcomTimer > self.m_welcomTime then
			self.m_bt_clickToStart:SetVisible(true);
			self.m_bLoadingOver = false;
		end

	end
end
function loading:Event_Click_To_Start()
	local step = Global:GetLoadingStep();
	if step < 100 then
		return 1;
	end
	if not self.m_bShowBlack then
		ShowPage( "black" );
		local ctrl = self.m_uiMgr:GetPage( "black" );
		ctrl:SelectAnimation( "ani_blackin", false, false );
		ctrl:PauseAnim( false, false );
		self.m_bShowBlack = false;
	end
	Global:EndLoading();
	return 1;
end
loading.ControlEvents = {
	Inputs = {
		bt_click_to_start = {"Event_Click_To_Start"};
	};
}
