require( "scripts/ui.lua" )
require( "ui/impl/uisound.lua" )
require( "ui/impl/diaframe.lua" )

EVENT_GAME_START = 1001;
EVENT_GAME_GO = 1002;

mainui = {
	m_object;
	m_uiMgr;
	m_DataMgr;
	
	m_btn_start;
	m_btn_option;
	m_btn_rate;
	
	m_bShowCheckIn = true;
	m_bRequstAD = true;
	m_bFirstStartGame = true;
	
	m_btn_free_choosecar_main;
	m_free_value_bg_main;
	m_free_value_main;
	
	m_btn_rank_main;
		
	m_btn_twitter_freedia;
	m_btn_facebook_freedia;
	
	m_btn_fk;
	m_fk_ltd_info;

	m_st_suppport;

	m_time = 0.0;
}

function mainui:Init( object )
	self.m_object = object;
end

function mainui:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	
	self.m_btn_start = self.m_object:FindChildControl( "btn_start_game" );
	self.m_btn_option = self.m_object:FindChildControl( "btn_game_setting" );
	self.m_btn_rate = self.m_object:FindChildControl( "btn_comment" );
	self.m_btn_free_choosecar_main = self.m_object:FindChildControl( "btn_free_choosecar_main" );
	self.m_free_value_bg_main = self.m_object:FindChildControl( "free_value_bg_main" );
	self.m_free_value_main = self.m_object:FindChildControl( "free_value_main" );
	self.m_btn_rank_main = self.m_object:FindChildControl( "btn_rank_main" );
	self.m_btn_fk = self.m_object:FindChildControl( "btn_fk" );
	
	self.m_btn_twitter_freedia = self.m_object:FindChildControl( "btn_twitter_freedia" );
	self.m_btn_facebook_freedia = self.m_object:FindChildControl( "btn_facebook_freedia" );
	self.m_fk_ltd_info = self.m_object:FindChildControl( "fk_ltd_info" );

	self.m_st_suppport = self.m_object:FindChildControl( "st_supportphone" );
	
	self.m_free_value_bg_main:SetVisible( false );
	self.m_free_value_main:SetVisible( false );
	
	self.m_btn_start:SelectAnimation( "ani_menu", false, false );
	self.m_btn_option:SelectAnimation( "ani_menu", false, false );
	
	self.m_btn_start:PauseAnim( true, false );
	self.m_btn_option:PauseAnim( true, false );
	
	if not sGlobal:IsEditor() then
		InitCurChannel( Global:GetAppChannel() );
	end
	
	return 1;
end

function mainui:EventActive( object, param0, param1 )
	self.m_bShowCheckIn = false;
	self.m_time = 0.0;
	self.m_DataMgr = Global:GetDataMgr();
	self.m_btn_start:SetRelativeTime( 0.0, false );
	self.m_btn_option:SetRelativeTime( 0.0, false );
	
	self.m_btn_start:PauseAnim( false, false );
	self.m_btn_option:PauseAnim( false, false );
	if channel.m_bEnableAd then
		sGlobal:Print( "loading:EventActive === SE_HIDE_AD" );
		Global:SystemRequest( SystemEvent.SE_HIDE_AD );
	end

	self.m_btn_rate:SetVisible( channel.m_bShowCommentBtn );
	if channel.m_bShowHelpAndAboutBtn then
		self.m_object:FindChildControl( "btn_help" ):SetVisible( true );
		self.m_object:FindChildControl( "btn_about" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_help" ):SetVisible( false );
		self.m_object:FindChildControl( "btn_about" ):SetVisible( false );
	end
	
	if channel.m_bShowMoreGame then
		self.m_object:FindChildControl( "btn_moreGame" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_moreGame" ):SetVisible( false );
	end
	
	if channel.m_bShowExchangeCode then
		self.m_object:FindChildControl( "btn_exchange_num" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_exchange_num" ):SetVisible( false );
	end
	
	if channel.m_bEnableFreeDiamond then
		self.m_btn_free_choosecar_main:SetVisible( true );
	else
		self.m_btn_free_choosecar_main:SetVisible( false );
	end

	if channel.m_bNewGameButton then
		self.m_object:FindChildControl( "btn_newgame" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_newgame" ):SetVisible( false );
	end
	
	if channel.m_bEnableRank then
		self.m_btn_rank_main:SetVisible( true );
	else
		self.m_btn_rank_main:SetVisible( false );
	end
	
	if channel.m_EnableFbAndTwitter then
		self.m_btn_fk:SetVisible( true );
		self.m_btn_facebook_freedia:SetVisible( true );
		self.m_btn_twitter_freedia:SetVisible( true );
	else
		self.m_btn_fk:SetVisible( false );
		self.m_btn_facebook_freedia:SetVisible( false );
		self.m_btn_twitter_freedia:SetVisible( false );
	end
	
	if channel.m_bShowLtd_copyright then
		self.m_fk_ltd_info:SetVisible( true );
	else
		self.m_fk_ltd_info:SetVisible( false );
	end

	if channel.m_bLowSize then
		uisound.game_music_2 = uisound.game_music_1;
	end

	if channel.m_bSupportPhone then
		self.m_st_suppport:SetVisible( true );
	end
	
	Global:StopMusic();
	Global:PlayMusic( uisound.ui_music, -1 );

	--if Global:SystemRequest( SystemEvent.SE_HASCONNECTDEVICE ) or channel.m_curChannel == "android_gametv" then
	if Global:SystemRequest( SystemEvent.SE_HASCONNECTDEVICE ) then
		if self.m_bFirstStartGame then
			ShowPage( "hand" );
		end
	end
	return 1;
end

function mainui:Update( duration )
	if self.m_bFirstStartGame then
		Global:SystemRequest( SystemEvent.SE_GAME_START );
		self.m_bFirstStartGame = false;
	end
	if channel.m_curChannel == "android_gametv" then
		return;
	end
	self.m_time = self.m_time + duration;
	if self.m_bShowCheckIn and self.m_time > 2.0 then
		local lastYear = datasave:GetChickInYear();
		local lastMonth = datasave:GetChickInMonth();
		local lastDay = datasave:GetChickInDay();
		
		local curYear = GetCheckInYear();
		local curMonth = GetCheckInMoth();
		local curDay = GetCheckInDay();
		
		local bSustain = false;
		
		sGlobal:Print( " mainfrm ---lst year : "..lastYear.."     lst month : "..lastMonth.."     lst day : "..lastDay );
		sGlobal:Print( " mainfrm ---cur year : "..curYear.."      cur month : "..curMonth.."      cur day : "..curDay );
		if curYear == lastYear and curMonth == lastMonth and curDay == lastDay then
			
		elseif ( curYear + curMonth + curDay ) ~= 0 then
			if curYear == lastYear then
				if curMonth == lastMonth then
					if curDay <= 31 and curDay == lastDay + 1 then
						bSustain = true;
					end
				else
					if lastMonth == 12 then
						if IsMonthLastDay( lastYear, lastMonth, lastDay ) then
							if curMonth == 1 and curDay == 1 then
								bSustain = true;
							end
						end
					else
						if IsMonthLastDay( lastYear, lastMonth, lastDay ) then
							if curMonth == lastMonth + 1 and curDay == 1 then
								bSustain = true;
							end
						end
					end
				end
			else
				if curYear == lastYear + 1 and lastMonth == 12 and lastDay == 31 and curMonth == 1 and curDay == 1 then
					bSustain = true;
				end
			end
		
			--
			bSustain = true;
			--
			if not bSustain then
				datasave:SetChickInSustain( 0 );
			end
			ShowDialog( "reg" );
		end
		self.m_bShowCheckIn = false;
	end
	if channel.m_bEnableFreeDiamond then
		local  num = 0;
		if Global:SystemRequest( SystemEvent.SE_INTERNET ) then
			if not datasave:IsLikeFaceBook() then
				num = num + 1;
			end
			
			if not datasave:IsLikeTwitter() then
				num = num + 1;
			end
		end
		
		if Global:SystemRequest( SystemEvent.SE_VIDEO_AVAILABLE ) then
			num = num + 1;
		end
		
		self.m_free_value_main:SetSymbolText( num );
		if num > 0 then
			self.m_free_value_bg_main:SetVisible( true );
		else
			self.m_free_value_bg_main:SetVisible( false );
		end
		
		self.m_free_value_bg_main:SetVisible( false );
		self.m_free_value_main:SetVisible( false );
	end
end

function mainui:EventStartGame( object, param0, param1 )
	-- self.m_object:SendEntityMsg( EVENT_GAME_START, 1, 0, 0, 0 );

	-- self.m_uiMgr:CloseWindow(self.m_object);

	-- local loading = self.m_uiMgr:GetPage("loading");
	-- self.m_uiMgr:OpenWindow(loading);
	
	if not datasave:GetDataFromLabel("fist_level") and not datasave:IsTrackUnlock(2) then
		levelinfo:SetFistLevel(true);
		Global:StopMusic();
	
		local entitySys = sGlobal:GetEntitySys();
	
		local curCar = self.m_DataMgr:GetCurCar();
		local player = entitySys:GetRegisterEntity( "Player" );
		local file = self.m_uiMgr:GetPage( "choosecar" ):GetScript():GetCarFile( curCar );
		
		player:LoadFromFile( file );
		--player:LoadFromFile( "obj/feixingqi01/ship1.zc" );
		player:InitCar();

		ClearMap();
		figure:Clear();
		self.m_uiMgr:GetPage( "Track" ):GetScript():ClearCar();
		local trackID = 19;
		Global:StartLoading( exl_level_data[trackID].m_trackFile );
		sGlobal:Print( "trackID : "..trackID );
		SetMapSymbol( RACING, trackID );
		ClosePage( "shop" );
		ClosePage( "choosecar" );
		ClosePage( "chosetrack" );
		ClosePage( "racemain" );
		
		local loading = self.m_uiMgr:GetPage("loading");
		self.m_uiMgr:OpenWindow(loading);
		
		local racingTbl = self.m_uiMgr:GetPage( "Track" ):GetScript();
		racingTbl:Reset();
		Global:Resume();
	else
		Global:PlaySound(uisound.mainui_btn_start,0);
		ClosePage( "racemain" );
		ShowPage( "choosecar" );
	end
	--Global:EventNotice( "start" );
	return 1;
end

function mainui:Event_Option( object, param0, param1 )
	--ClosePage( "racemain" );
	ShowDialog( "option" );
	
	Global:PlaySound(uisound.mainui_btn_option,0);
	return 1;
end

-- function mainui:Event_Help_Click( object, param0, param1 )
	-- Global:PlaySound(uisound.mainui_btn_help,0);
	-- return 1;
-- end

function mainui:Event_Exit( object, param0, param1 )
	if channel:GetCurChannel() ~= "android_googleplay" then
		if channel.m_bShowMoreGameGetReward then
			if Global:GetMoreGameCount() > 0 then
				ShowDialog( "adgame" );
			else
				self.m_uiMgr:GetPage( "attion_box" ):GetScript():SetMsgType( TIP_EXIT );
				ShowDialog( "attion_box" );
			end
		else
			if channel.m_EnableShowExitTip then
				self.m_uiMgr:GetPage( "attion_box" ):GetScript():SetMsgType( TIP_EXIT );
				ShowDialog( "attion_box" );
			else
				Global:SystemRequest( SystemEvent.SE_EXIT );
			end
		end
	else
		Global:SystemRequest( SystemEvent.SE_EXIT );
	end
	return 1;
end

function mainui:Event_More_Game( object, param0, param1 )
	OnMoreGameClick();
	return 1;
end

function mainui:Control_Event( object, param0, param1 )
	if TIP_EXIT == param0 then
		Global:SystemRequest( SystemEvent.SE_EXIT );
	end
	ClosePage( "attion_box" );
	return 1;
end

function mainui:Event_Free_Click( object, param0, param1 )
	ShowDialog( "freebox" );
	return 1;
end

function mainui:Event_Rank_Click( object, param0, param1 )
	-- if channel:GetCurChannel() == "android_mozhang" then
		-- Global:SystemRequest( SystemEvent.SE_LEADERBOARD );
	-- else
		-- ShowDialog( "ranking" );
	-- end
	if channel.m_bEnableRank then
		ShowDialog( "ranking" );
	end
	return 1;
end

function mainui:Event_FaceBook_Login( object, param0, param1 )
	ShowDialog( "facebooklogin" );
	return 1;
end

function mainui:Event_FaceBook_Free_Dia( object, param0, param1 )
	ShowDialog( "freebox" );
	return 1;
end

function mainui:Event_Twitter_Free_Dia( object, param0, param1 )
	ShowDialog( "freebox" );
	return 1;
end

function mainui:EventKeyUp( key_code )
	if key_code == 27 then
		self:Event_Exit( "0", 0, 0 );
	elseif key_code == 13 then
		self.m_object:FindChildControl( "btn_start_game" ):SendMsg( "BN_CLICK", 0, 0 );
	end
	return 1;
end

function mainui:Event_GameHelp( object, param0, param1 )
	sGlobal:Print( "Event_GameHelp" );
	ShowDialog( "help" );
	return 1;
end

function mainui:Event_About( object, param0, param1 )
	ShowDialog( "about" );
	return 1;
end

function mainui:Event_Exchange_Num( object, param0, param1 )
	sGlobal:Print( "event_exchang" );
	Global:SystemRequest( SystemEvent.SE_CHARGE );
	return 1; 
end

function mainui:Event_NewGame( object, param0, param1 )
	Global:SystemRequest( SystemEvent.SE_NEWGAME );
	return 1;
end

function mainui:Event_Comment( object, param0, param1 )
	Global:SystemRequest( SystemEvent.SE_RATE );
	return 1;
end

mainui.ControlEvents = {
	Inputs = {
		btn_start_game = { "EventStartGame" };
		btn_game_setting = { "Event_Option" };
		--btn_game_help = { "Event_Help_Click" };
		btn_exit = { "Event_Exit" };
		btn_moreGame = { "Event_More_Game" };
		attion_box = { "Control_Event" };
		btn_help = { "Event_GameHelp" };
		btn_about = { "Event_About" };
		
		btn_exchange_num = { "Event_Exchange_Num" };
		
		btn_free_choosecar_main = { "Event_Free_Click" };
		btn_rank_main = { "Event_Rank_Click" };
		
		btn_fk = { "Event_FaceBook_Login" };
		
		btn_facebook_freedia = { "Event_FaceBook_Free_Dia" };
		btn_twitter_freedia = { "Event_Twitter_Free_Dia" };
		btn_newgame = { "Event_NewGame" };
		btn_comment = {"Event_Comment"};
	}
}