require( "scripts/base.lua" );
MAP_PLAYER = 1;
MAP_AI = 2;

map = {
	m_owner;
	m_mapBg;
	m_car_icon;
	
	m_mapBgWid = 0;
	m_mapBgHei = 0;
	
	m_uiScale = 1.0;
	
	m_entityMgr;
	m_playerObj;
	m_cameraForward;
	m_cameraRot = 0;
	m_Pos = Vector3:new( 0, 0, 0 );
	m_mapInfo = {
			--{ uiObj, actorObj, iconType , bInheritRot }, bInheritRot : is get parent rotation
		},

	m_IconType = { "icon_player", "icon_ai" },

	FreeList = {
		--{ obj };
	};
	
	m_bUpdate = false;
}

function map:Init( owner , mapBg, carIcon )
	self.m_owner = owner;
	self.m_mapBg = mapBg;
	self.m_car_icon = carIcon;
	
	self.m_mapBgWid = self.m_mapBg:GetWidth();
	self.m_mapBgHei = self.m_mapBg:GetHeight();
end

------------free list
function map:InsertFreeList( freeObj )
	table.insert( self.FreeList, { obj = freeObj } );
end

function map:GetFreeListItem()
	local obj = nil;
	local size = #(self.FreeList);
	if size > 0 then
		obj = self.FreeList[1].obj;
		table.remove( self.FreeList, 1 );
	end
	return obj;
end
--===========
function map:SetEntityMgr( entityMgr )
	self.m_entityMgr = entityMgr;
end

function map:Clear()
	--sGlobal:Print( "map clear-------------" );
	local size = #( self.m_mapInfo );
	local size2 = size;
	local count = 0;
	for i = 1, size, 1 do
		i = i - count;
		if i <= size2 then
			if self.m_mapInfo[i].iconType ~= MAP_PLAYER then
				self.m_mapInfo[i].uiObj:SetVisible( false );
				self:InsertFreeList( self.m_mapInfo[i].uiObj );
				self.m_mapInfo[i].uiObj:RemoveSelf();
				table.remove( self.m_mapInfo, i );
				size2 = #( self.m_mapInfo );
				count = count + 1;
			end
		end
	end
end

function map:AddIcon( actorObj, mapType )
	--Global:Print( "map AddIcon mapType is "..mapType );
	self.m_uiScale = self.m_owner:GetWidth() / self.m_owner:GetClientWidth();
	
	local uiObj = self:GetFreeListItem();
		
	--sGlobal:Print( "uiScale --- : "..self.m_uiScale );

	local bRot = true;
	--sGlobal:Print( "addIcon actorID : "..actorObj:GetID() );
	--sGlobal:Print( "addIcon iconType : "..mapType );
	if uiObj == nil then
		uiObj = ControlUnit:new();
		self.m_car_icon:Clone( uiObj );
	end
	
	if mapType == MAP_PLAYER then
		--uiObj:SetSize( self.m_actorWid, self.m_actorHei );
	elseif mapType == MAP_AI then
		--uiObj = self.m_portalIcon;
		--uiObj:SetSize( self.m_portalWid, self.m_portalHei );
	end
	uiObj:SetVisible( false );
	
	--sGlobal:Print( "Set Symbol : "..self.m_IconType[mapType] );
	uiObj:SetSymbol( self.m_IconType[mapType] );
	self.m_mapBg:AddControl( uiObj );

	table.insert( self.m_mapInfo, {uiObj = uiObj , actorObj = actorObj, iconType = mapType, bInheritRot = bRot } );
	
	local cameraRot = Global:CalCameraRotation();
	self.m_mapBg:SetRotate( 0, -cameraRot, 0 );
end

function map:SetMapSymbol( model, scencdID )
	sGlobal:Print( "map:SetMapSymbol=============== "..scencdID );

	local mapName = GetMapIcon( model, scencdID );
	--Global:Print( "mapinco name is "..mapName );
	self.m_mapBg:SetSymbol( mapName );
	
end

function map:RemoveIcon( actorObj )
	for k, value in pairs(self.m_mapInfo) do  
		--sGlobal:Print( "k : "..k );
		if actorObj == value.actorObj then
			value.uiObj:SetVisible( false );
			self:InsertFreeList( value.uiObj );
			value.uiObj:RemoveSelf();
			table.remove( self.m_mapInfo, k );
		end
	end
end

function map:Update( duration )
	if sGlobal:IsEditor() then
		return;
	end
	--Rotation map background by camera
	--local cameraRot = Global:CalCameraRotation();
	--self.m_mapBg:SetRotate( 0, -cameraRot, 0 );

	--if self.m_bUpdate then
		local count = #self.m_mapInfo;
		for i = 1, count do
			Global:CalSRelativePos( self.m_mapInfo[i].actorObj:GetPos(),self.m_mapBgWid, self.m_mapBgHei, "sencebox", self.m_Pos );
			self.m_mapInfo[i].uiObj:SetClientPos( self.m_Pos[1], self.m_Pos[2] );
			
			--sGlobal:Print( "pos x : "..self.m_Pos[1] );
			--sGlobal:Print( "pos y : "..self.m_Pos[2] );
			--self.m_mapInfo[i].uiObj:SetSize( self.m_mapInfo[i].uiObj:GetSymbolWidth()*self.m_uiScale, self.m_mapInfo[i].uiObj:GetSymbolHeight()*self.m_uiScale );
			-- if self.m_mapInfo[i].bInheritRot == false then
				-- self.m_mapInfo[i].uiObj:SetRotate( 0, cameraRot, 0 );
			-- end
			self.m_mapInfo[i].uiObj:SetVisible( true );
			
			-- local ranking = self.m_mapInfo[i].actorObj:GetRanking();
			-- sGlobal:Print( "ranking --  "..i.." ==== "..ranking );
		end
	--end
end
