
moregame = {
	m_object;
	m_uiMgr;
	m_DataMgr;
	m_icon1;
	m_icon2;
	m_name1;
	m_name2;
	
	load_text = {};
	btn_game = {};
};

function	 moregame:Init( object )
	self.m_object = object;
end

function	moregame:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_icon1 = self.m_object:FindChildControl( "icon1" );
	self.m_icon2 = self.m_object:FindChildControl( "icon2" );
	self.m_name1 = self.m_object:FindChildControl( "name1" );
	self.m_name2 = self.m_object:FindChildControl( "name2" );

	self.load_text[1] = self.m_object:FindChildControl( "load_text_1" );
	self.load_text[2] = self.m_object:FindChildControl( "load_text_2" );

	self.btn_game[1] = self.m_object:FindChildControl( "btn_game1" );
	self.btn_game[2] = self.m_object:FindChildControl( "btn_game2" );
	return 1;
end

function	moregame:EventActive( object, param0, param1 )
	self.m_DataMgr = Global:GetDataMgr();
	Global:CheckMoreGameData( "moregame.bin" );
	self:SetSymbols();
	
	Global:EventNotice( "show_moregame" );
	return 1;
end

function	moregame:Update( duration )
	if sGlobal:IsEditor() then
		return;
	end
	local name;
	for i = 0, 1 do
		name = self.m_DataMgr:GetMoreGameName(i);
		if IsInStallGame( name ) then
			if not self.m_DataMgr:IsInLoadingState( name ) then
				self.load_text[i+1]:SetSymbol( "mgfree" );
				self.btn_game[i+1]:GetScript():EnableButton( false );
			else
				self.load_text[i+1]:SetSymbol( "xzyl" );
				if not self.m_DataMgr:IsMoreGameReward( name ) then
					self.btn_game[i+1]:GetScript():EnableButton( true );
				else
					self.btn_game[i+1]:GetScript():EnableButton( false );
				end
			end	
		else	
			self.load_text[i+1]:SetSymbol( "mgfree" );
			self.btn_game[i+1]:GetScript():EnableButton( true );
		end
	end
end

function	moregame:Event_Exit_Game( object, param0, param1 )
	Global:SystemRequest( SystemEvent.SE_EXIT );
	ClosePage( "moregame" );
	return 1;
end

function	moregame:Event_More_Game( object, param0, param1 )
	OnMoreGameClick();
	Global:EventNotice( "click_moregame" );
	return 1;
end

function	moregame:Event_Close_Game( object, param0, param1 )
	ClosePage( "moregame" );
	Global:PlaySound(uisound.btn_return,0);
	return 1;
end

function	moregame:Event_Game1( object, param0, param1 )
	local name = self.m_DataMgr:GetMoreGameName(0);
	if not IsInStallGame( name ) then
		self.m_DataMgr:EnterLoadingState( name );
		Global:OpenGameInstall( 1 );
		Global:EventNotice( "click_game1" );
	else
		if self.m_DataMgr:IsInLoadingState( name ) and not self.m_DataMgr:IsMoreGameReward( name ) then
			self.m_DataMgr:AddItemNum( ITEM_GOLD, 500000 );
			self.m_DataMgr:GetMoreGameReward( name );
			
			Save();
			Global:PlaySound(uisound.buy_gold,0);
			Global:EventNotice( "install_game" );
			sGlobal:Print( "mainui : Get More Game Reward : "..name );
		end
	end
	return 1;
end
function	moregame:Event_Game2( object, param0, param1 )
	local name = self.m_DataMgr:GetMoreGameName(1);
	if not IsInStallGame( name ) then
		self.m_DataMgr:EnterLoadingState( name );
		Global:OpenGameInstall( 2 );
		Global:EventNotice( "click_game2" );
	else
		if self.m_DataMgr:IsInLoadingState( name ) and not self.m_DataMgr:IsMoreGameReward( name ) then
			self.m_DataMgr:AddItemNum( ITEM_GOLD, 500000 );
			self.m_DataMgr:GetMoreGameReward( name );
			
			Save();
			Global:PlaySound(uisound.buy_gold,0);
			Global:EventNotice( "install_game" );
			sGlobal:Print( "mainui : Get More Game Reward : "..name );
		end
	end
	
	return 1;
end

function	moregame:Event_Game_bg_1( object, param0, param1 )
	local name = self.m_DataMgr:GetMoreGameName(0);
	if not IsInStallGame( name ) then
		self.m_DataMgr:EnterLoadingState( name );
		Global:EventNotice( "click_game1" );
	end
		
	Global:OpenGameInstall( 1 );
	return 1;
end

function	moregame:Event_Game_bg_2( object, param0, param1 )
	local name = self.m_DataMgr:GetMoreGameName(1);
	if not IsInStallGame( name ) then
		self.m_DataMgr:EnterLoadingState( name );
		Global:EventNotice( "click_game2" );
	end
	
	Global:OpenGameInstall( 2 );
	return 1;
end

function moregame:SetSymbols()
	if self.m_uiMgr:IsSymbolExist( "_moregame_icon_1" ) and self.m_uiMgr:IsSymbolExist( "_moregame_name_1" ) then
		self.m_icon1:SetSymbol( "_moregame_icon_1" );
		self.m_name1:SetSymbol( "_moregame_name_1" );
	end
	if self.m_uiMgr:IsSymbolExist( "_moregame_icon_2" ) and self.m_uiMgr:IsSymbolExist( "_moregame_name_2" ) then
		self.m_icon2:SetSymbol( "_moregame_icon_2" );
		self.m_name2:SetSymbol( "_moregame_name_2" );
	end
end

function moregame:EventKeyUp( key_code )
	if key_code == 27 then
		self:Event_Close_Game( "0", 0, 0 );
	end
	return 1;
end

moregame.ControlEvents = {
	Inputs = {
		btn_exit_moregame = { "Event_Exit_Game" };
		btn_moregame = { "Event_More_Game" };
		btn_close_moregame = { "Event_Close_Game" };
		btn_game1 = { "Event_Game1" };
		btn_game2 = { "Event_Game2" };
		
		btn_game1_bg = { "Event_Game_bg_1" };
		btn_game2_bg = { "Event_Game_bg_2" };
	};
};
