
option = {
	m_object;
	m_uiMgr;
	m_Bg;
	
	m_DataMgr;
	m_textCameraView;
	
	m_text_music;
	m_text_volume;
	m_text_operate;
	m_text_vibration;
	m_player;
	
	m_cpdot_1;
}

function option:Init( object )
	self.m_object = object;
end

function option:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_Bg = self.m_object:FindChildControl( "bgblack_5" );
	self.m_textCameraView = self.m_object:FindChildControl( "text_view" );
	
	self.m_text_music = self.m_object:FindChildControl( "text_music" );
	self.m_text_volume = self.m_object:FindChildControl( "text_volume" );
	self.m_text_operate = self.m_object:FindChildControl( "text_operate" );
	self.m_text_vibration = self.m_object:FindChildControl( "text_vibration" );
	self.m_cpdot_1 = self.m_object:FindChildControl( "cpdot_1" );
	
	self.m_Bg:SelectAnimation( "option_ani", false, false );
	self.m_Bg:PauseAnim( true, false );
	return 1;
end

function option:EventActive( object, param0, param1 )
	self.m_Bg:SetRelativeTime( 0.0, false );
	self.m_Bg:PauseAnim( false, false );
	
	self.m_DataMgr = Global:GetDataMgr();
	
	self.m_entitySys = sGlobal:GetEntitySys();
	self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
	
	if channel.m_bShowMoreGame then
		self.m_object:FindChildControl( "btn_moreGame_opting" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_moreGame_opting" ):SetVisible( false );
	end
	return 1;
end

function option:EventKeyUp( key_code )
	if key_code == 27 then
		ClosePage( "option" );
		self.m_Bg:PauseAnim( true, false );
	end
	return 1;
end

function option:Event_Return( object, param0, param1 )
	sGlobal:Print( "event_return option " );
	ClosePage( "option" );
	--ShowPage( "racemain" );
	self.m_Bg:PauseAnim( true, false );
	Global:PlaySound(uisound.btn_return,0);
	Save();
	return 1;
end

function option:Update( duration )
	local cameraType = self.m_DataMgr:GetCameraType();
	if cameraType == 0 then -- first view
		self.m_textCameraView:SetSymbol( "sj1_text" );
	elseif cameraType == 1 then -- third view
		self.m_textCameraView:SetSymbol( "sj2_text" );
	end
	
	local operateType = self.m_DataMgr:GetOperateModel();
	if operateType == 0 then
		self.m_text_operate:SetSymbol( "gy" );
	else
		self.m_text_operate:SetSymbol( "cz" );
	end
	
	local IsEnableSound = self.m_DataMgr:IsEnableSound();
	if IsEnableSound then
		self.m_text_volume:SetSymbol( "kq_text" );
	else
		self.m_text_volume:SetSymbol( "gb_text" );
	end
	
	local IsEnableMusic = self.m_DataMgr:IsEnableMusic();
	if IsEnableMusic then
		self.m_text_music:SetSymbol( "kq_text" );
	else
		self.m_text_music:SetSymbol( "gb_text" );
	end
	
	local bEnableVibration = self.m_DataMgr:IsVibration();
	if bEnableVibration then
		self.m_text_vibration:SetSymbol( "kq_text" );
	else
		self.m_text_vibration:SetSymbol( "gb_text" );
	end
	
	if self.m_DataMgr:GetOperateModel() == 1 then
		self.m_cpdot_1:SetSymbol( "cpdot" );
	else
		self.m_cpdot_1:SetSymbol( "sym_ganying" );
	end
end

function option:Event_Camera_Click( object, param0, param1 )
	Global:PlaySound(uisound.btn_racing,0);
	local cameraType = self.m_DataMgr:GetCameraType();
	
	self.m_entitySys = sGlobal:GetEntitySys();
	self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
	
	if cameraType == 0 then
		self.m_DataMgr:SetCameraType(1);
		self.m_player:SetView(false);
	elseif cameraType == 1 then
		self.m_DataMgr:SetCameraType(0);
		self.m_player:SetView(true);
	end
	return 1;
end

function option:Event_Oprate_Click( object, param0, param1 )
	Global:PlaySound(uisound.btn_racing,0);
	local operateType = self.m_DataMgr:GetOperateModel();
	if operateType == 0 then
		self.m_DataMgr:SetOperateModel(1);
	elseif operateType == 1 then
		self.m_DataMgr:SetOperateModel(0);
	end
	return 1;
end

function option:Event_sound_Click( object, param0, param1 )
	local IsEnableSound = self.m_DataMgr:IsEnableSound();
	self.m_DataMgr:EnableSound( not IsEnableSound );
	if not IsEnableSound then
		Global:SetSoundVolume( 1.0 );
	else
		Global:SetSoundVolume( 0.0 );
	end
	Global:PlaySound(uisound.btn_racing,0);
	return 1;
end

function option:Event_Music_Click( object, param0, param1 )
	local IsEnableMusic = self.m_DataMgr:IsEnableMusic();
	self.m_DataMgr:EnableMusic( not IsEnableMusic );
	if not IsEnableMusic then
		Global:SetMusicVolume( 1.0 );
	else
		Global:SetMusicVolume( 0.0 );
	end
	Global:PlaySound(uisound.btn_racing,0);
	return 1;
end

function option:Event_MoreGame_Click( object, param0, param1 )
	Global:PlaySound(uisound.btn_racing,0);
	OnMoreGameClick();
	return 1;
end

function option:Event_Vibration_Click( object, param0, param1 )
	local bEnableVibration = self.m_DataMgr:IsVibration();
	self.m_DataMgr:EnableVibration( not bEnableVibration );
	Global:PlaySound(uisound.btn_racing,0);
	return 1;
end

option.ControlEvents = {
	Inputs = {
		btn_return_option = { "Event_Return" };
		btn_camera = { "Event_Camera_Click" };
		btn_operateModel = { "Event_Oprate_Click" };
		btn_sound = { "Event_sound_Click" };
		btn_music = { "Event_Music_Click" };
		btn_moreGame_opting = { "Event_MoreGame_Click" };
		btn_vibration = { "Event_Vibration_Click" };
	}
}

		