require( "ui/impl/uisound.lua" )

pause = {
	m_object;
	m_uiMgr;
	m_DataMgr;
	m_text_reward_1;
	m_text_reward_2;
	m_text_reward_3;
	
	m_text_reward_1_title;
	m_text_reward_2_title;
	m_text_reward_3_title;

	m_btn_pause_restart;
	
	m_btn_free_pause;
	m_free_value_bg_pause;
	m_free_value_pause;
	m_bkg_ads;
	m_st_price;
	m_gift_box_index;
}

function	pause:Init( object )
	self.m_object = object;
end

function	pause:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_object:SelectAnimation( "ani_pause" , false , true );
	self.m_text_reward_1 = self.m_object:FindChildControl( "text_reward_1" );
	self.m_text_reward_2 = self.m_object:FindChildControl( "text_reward_2" );
	self.m_text_reward_3 = self.m_object:FindChildControl( "text_reward_3" );

	self.m_text_reward_1_title = self.m_object:FindChildControl( "text_first_title" );
	self.m_text_reward_2_title = self.m_object:FindChildControl( "text_second_title" );
	self.m_text_reward_3_title = self.m_object:FindChildControl( "text_third_title" );

	self.m_btn_pause_restart = self.m_object:FindChildControl( "btn_pause_restart" );
	
	self.m_btn_free_pause = self.m_object:FindChildControl( "btn_free_pause" );
	self.m_free_value_bg_pause = self.m_object:FindChildControl( "free_value_bg_pause" );
	self.m_free_value_pause = self.m_object:FindChildControl( "free_value_pause" );
	self.bkg_ads = self.m_object:FindChildControl( "bkg_ads" );
	self.m_st_price = self.m_object:FindChildControl( "st_price_pause" );

	self.m_object:PauseAnim( true, true );

	return 1;
end

function	pause:EventActive( object, param0, param1 )
	if not sGlobal:IsEditor() then
		Global:Pause();
	end
	
	if channel.m_bEnableAd and not datasave:IsBuyIapMoreThan30() then
		Global:SystemRequest( SystemEvent.SE_GAME_PAUSE );
	end
	
	if channel.m_bEnableFreeDiamond then
		self.m_btn_free_pause:SetVisible( true );
	else
		self.m_btn_free_pause:SetVisible( false );
	end
	
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_object:SetRelativeTime( 0.0, true );
	self.m_object:PauseAnim( false, true );
	
	self.m_DataMgr = Global:GetDataMgr();
	local level = self.m_DataMgr:GetLevel();
	
	self.m_text_reward_1:SetSymbolText( levelinfo:GetLevelReward(level, 3) );
	self.m_text_reward_2:SetSymbolText( levelinfo:GetLevelReward(level, 2) );
	self.m_text_reward_3:SetSymbolText( levelinfo:GetLevelReward(level, 1) );

	self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
	
	if channel.m_bShowMoreGame then
		self.m_object:FindChildControl( "btn_moreGame_pause" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_moreGame_pause" ):SetVisible( false );
	end
	
	if levelinfo:IsFistLevel() then
		self.m_btn_pause_restart:GetScript():EnableButton( false );
	else
		self.m_btn_pause_restart:GetScript():EnableButton( true );
	end

	self.m_gift_box_index = datasave:GetLastGiftId();

	if self.m_gift_box_index == 1 then
		self.bkg_ads:SetSymbol("adcar51");
		self.bkg_ads:SetVisible(true);
		self.m_st_price:SetSymbol( "rmb01" );
		if channel.m_bUseEvenIap == true then
			self.m_st_price:SetSymbol( "rmb01" );
		end
		EventNotice("pack_pause_open",1);
	elseif self.m_gift_box_index == 2 then
		self.bkg_ads:SetSymbol("adcar41");
		self.bkg_ads:SetVisible(true);
		self.m_st_price:SetSymbol( "rmb28" );
		if channel.m_bUseEvenIap == true then
			self.m_st_price:SetSymbol( "rmb28" );
		end
		EventNotice("pack_pause_open",1);	
	elseif self.m_gift_box_index == 3 then
		self.bkg_ads:SetSymbol("adcar2");
		self.bkg_ads:SetVisible(true);
		self.m_st_price:SetSymbol( "rmb15" );
		if channel.m_bUseEvenIap == true then
			self.m_st_price:SetSymbol( "rmb16" );
		end
		EventNotice("pack_pause_open",3);
	elseif self.m_gift_box_index == 4 then
		self.bkg_ads:SetSymbol("adcar4");
		self.bkg_ads:SetVisible(true);
		self.m_st_price:SetSymbol( "rmb15" );
		if channel.m_bUseEvenIap == true then
			self.m_st_price:SetSymbol( "rmb16" );
		end
		EventNotice("pack_pause_open",4);
	elseif self.m_gift_box_index == 5 then
		self.bkg_ads:SetSymbol("adcar3");
		self.bkg_ads:SetVisible(true);
		self.m_st_price:SetSymbol( "rmb30" );
		if channel.m_curChannel == "android_yyc" then
			self.m_st_price:SetSymbol( "rmb20" );
		end
		EventNotice("pack_pause_open",5);
	else
		self.bkg_ads:SetVisible(false);
		self.m_gift_index = 0;
	end
	if not channel.m_bGiftPack then
		self.bkg_ads:SetVisible(false);
		self.m_gift_index = 0;
	end

	--sGlobal:Print("Pause Ads Index."..self.m_gift_box_index);

	if exl_level_data[level].m_Mode == 0 or exl_level_data[level].m_Mode == 3 then
		self.m_text_reward_1_title:SetSymbol( "mcname1" );
		self.m_text_reward_2_title:SetSymbol( "mcname2" );
		self.m_text_reward_3_title:SetSymbol( "mcname3" );
	elseif exl_level_data[level].m_Mode == 1 then
		local dist_cond = Level_GetRankCondition_dist(level, 1)
		self.m_text_reward_3_title:SetSymbolText( dist_cond.."M" );

		dist_cond = Level_GetRankCondition_dist(level, 2)
		self.m_text_reward_2_title:SetSymbolText( dist_cond.."M" );

		dist_cond = Level_GetRankCondition_dist(level, 3)
		self.m_text_reward_1_title:SetSymbolText( dist_cond.."M" );		
	end

	Global:SystemRequest( SystemEvent.SE_SHOW_AD );
	return 1;
end

function	pause:Update( duratoin )
	if channel.m_bEnableFreeDiamond then
		local num = 0;
		if Global:SystemRequest( SystemEvent.SE_INTERNET ) then
			if not datasave:IsLikeFaceBook() then
				num = num + 1;
			end
			
			if not datasave:IsLikeTwitter() then
				num = num + 1;
			end
		end
		
		if Global:SystemRequest( SystemEvent.SE_VIDEO_AVAILABLE ) then
			num = num + 1;
		end
		
		self.m_free_value_pause:SetSymbolText( num );
		if num > 0 then
			self.m_free_value_bg_pause:SetVisible( true );
		else
			self.m_free_value_bg_pause:SetVisible( false );
		end
	end
end

function	pause:Event_Return_Click( object, param0, param1 )
	if channel.m_bEnableAd and not datasave:IsBuyIapMoreThan30() then
		Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
	end

	ClosePage( "Pause" );
	Global:EndLevel();
	Global:Resume();
	self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
	
	ShowPage( "choosecar" );
	
	Global:PlaySound(uisound.btn_return,0);
	return 1;
end

function	pause:Event_Continue( object, param0, param1 )
	if channel.m_bEnableAd and not datasave:IsBuyIapMoreThan30() then
		Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
	end
	ClosePage( "Pause" );
	ClosePage( "Track" );
	ShowPage( "Track" );
	Global:Resume();
	
	Global:PlaySound(uisound.pause_btn_resume,0);
	return 1;
end

function	pause:Event_MoreGame_Click( object, param0, param1 )
	OnMoreGameClick();
	return 1;
end

function	pause:Event_Option_Click( object, param0, param1 )
	ShowDialog( "option" );
	return 1;
end

function	pause:Event_Restart_Click( object, param0, param1 )
	Global:EndLevel();
	self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
	ClosePage( "Pause" );
	self.m_uiMgr:GetPage( "chosetrack" ):GetScript():StartGame( true );
	Global:PlaySound(uisound.winlose_btn_restart,0);
	return 1;
end

function	pause:Event_Free_Click( object, param0, param1 )
	ShowDialog( "freebox" );
	return 1;
end

function	pause:Event_FilterGamePause( object, param0, param1 )
	return 1;
end

function 	pause:EventKeyUp( key_code )
	if key_code == 27 then
		ClosePage( "Pause" );
		ClosePage( "Track" );
		ShowPage( "Track" );
		Global:Resume();
		if channel.m_bEnableAd then
			Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
		end
	elseif key_code == 13 then
		self:Event_Return_Click( "BN_CLICK", 0, 0 );
	end
	return 1;
end

function	pause:Event_GetNow( object, param0, param1 )
	Global:PlaySound(uisound.shop_btn_iap,0);

	sGlobal:Print("Pause purchase start"..self.m_gift_box_index);

	if self.m_gift_box_index == 1 then
		OnStartPurchase( PCS_GOLD_100000, self );
	elseif self.m_gift_box_index == 2 then
		OnStartPurchase( PCS_GOLD_9000000, self );
	elseif self.m_gift_box_index == 3 then
		OnStartPurchase( PCS_GOLD_3500000, self );
	elseif self.m_gift_box_index == 4 then
		OnStartPurchase( PCS_GOLD_3500000, self );
	elseif self.m_gift_box_index == 5 then
		OnStartPurchase( PCS_GOLD_8600000, self );
	end
	
	return 1;
end

function	pause:PurchaseSuccess( id )
	local dataMgr = Global:GetDataMgr();
	
	sGlobal:Print("Pause purchase"..self.m_gift_box_index);

	if self.m_gift_box_index == 1 then
		local dataMgr = Global:GetDataMgr();
		dataMgr:AddItemNum( ITEM_MILLISE, 2 );
		dataMgr:AddItemNum( ITEM_SHIELD, 2 );
		dataMgr:AddItemNum( ITEM_NITROGEN, 2 );
		datasave.m_bThanksGiftPurchased = true;
		datasave:SetGiftDone(1);
		EventNotice("pack_pause_buy",1);
	elseif self.m_gift_box_index == 2 then
		GiveGiftAircraftById(5);
		datasave:SetGiftDone(2);
		EventNotice("pack_pause_buy",2);
	elseif self.m_gift_box_index == 3 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[2] );
		GiveGiftAircraftById(4);
		GiveGiftAircraftById(5);
		datasave:SetGiftDone(3);
		EventNotice("pack_pause_buy",3);
	elseif self.m_gift_box_index == 4 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[2] );
		GiveGiftAircraftById(6);
		datasave:SetGiftDone(4);
		EventNotice("pack_pause_buy",4);
	elseif self.m_gift_box_index == 5 then
		dataMgr:AddItemNum( ITEM_GOLD, -IapItem[3] );
		GiveGiftAircraftById(7);
		datasave:SetGiftDone(5);
		EventNotice("pack_pause_buy",5);
	end

	self.bkg_ads:SetVisible(false);
	self.m_gift_box_index = 0;

	return 1;
end

pause.ControlEvents = {
	Inputs = {
		btn_pause_return = { "Event_Return_Click" };
		btn_pause_continue = { "Event_Continue" };
		btn_moreGame_pause = { "Event_MoreGame_Click" };
		btn_pause_option = { "Event_Option_Click" };
		btn_pause_restart = { "Event_Restart_Click" };
		btn_free_pause = { "Event_Free_Click" };
		btn_pause = { "Event_FilterGamePause" };
		btn_pause_get_now = { "Event_GetNow" };
	}
}