require( "ui/impl/map.lua" );
require( "scripts/exl_level_data.lua" );
require( "ui/impl/uisound.lua" )
require( "ui/impl/figure.lua" )
require("scripts/channel.lua")

racing = {
	m_object;
	m_uiMgr;

	m_maxTurns;
	m_curTurns;
	m_ranking;
	m_totalRanking;

	m_speedObj = { nil, nil, nil };
	m_numSymbol = { "no0", "no1", "no2", "no3", "no4", "no5", "no6", "no7", "no8", "no9" };
	m_timeObj = { nil, nil, nil, nil, nil, nil };

	m_bStartCountTime = false;
	m_bStartLampTime = false;
	m_bStartStep = 1;
	m_fTime = 0.0;
	m_fLampTime = 0.0;
	m_DataMgr;
	m_entitySys;
	m_player = nil;

	lamp = {};

	m_bLampSound = { false, false, false };

	m_lapbox;
	m_cpdot_2;

	-- for chase model
	m_playerRound = 1;
	m_aiRound = 1;

	m_playerOldPos = 1;
	m_aiOldPos = 1;
	-- for chase model

	m_PlayerRankRound = 1;
	m_PlayerRankPos = 1;
	m_dis = 0.0;
	m_bPlayerPassHalf = false;
	m_bAiPassHalf = false;

	m_RankingBg;

	m_AiCar = {
		--obj, oldPos, round, passHalf, rank
	};
	
	m_hpObj = {};

	m_bGetLastCar = false;
	m_LastCar = nil;

	m_ItemNumText = {};
	m_textGold;
	m_Rank = 0;

	m_bPlayerReverse = false;
	m_bDirectBuy = false;
	--m_btn_reset;
	m_btn_pause;
	
	m_btn_left;
	m_btn_right;
	m_textOP;
	
	m_ChooseItemID = 1;
	m_ChooseItemNum = 1;
	m_ChooseItemText = "";
	m_text_distanse;

	m_btn_camera;
	m_ani_ganying_bg;
	m_resetCD = 3;
	
	m_leftBtn = {};
	
	m_btn_temp_item;
	m_tempItemTime = 60;
	m_tempItemType = 0;
	m_temp_item_symbol;
	m_temp_item_num;
	
	m_attack_power;
	
	m_fNegativeStart = 0.0;
	m_fNegativeEnd = 0.0;
	m_fPositiveStart = 0.0;
	m_CollideCount = 0;
	m_CollideInterval = 0.0;
	
	m_startAniWaitTime = 5.0;
	
	m_collideHP;
	m_bAccelerateOver = false;
	m_EnableShoot = false;
	m_bResponCallAni = false;
	
	m_inControlTuition = false;
	
	m_bRequstAD = true;
	
	m_ani_call_bg;
	m_ani_call;
	
	m_call_sym = { "add_jiashu", "add_jishu", "add_jiz", "add_cool", "add_guanjun", "add_lihai", "add_taiz", "add_jingc" };
}

function 	racing:EnableInTuition( bEnable )
	self.m_inControlTuition = bEnable;
	sGlobal:Print( "racing:EnableInTuition" );
end

function	racing:Init( object )
	self.m_object = object;
end

function	racing:EventInit( object, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();

	self.m_speedObj[1] = self.m_object:FindChildControl( "speed_1" );
	self.m_speedObj[2] = self.m_object:FindChildControl( "speed_2" );
	self.m_speedObj[3] = self.m_object:FindChildControl( "speed_3" );

	self.lamp[1] = self.m_object:FindChildControl( "lamp_1" );
	self.lamp[2] = self.m_object:FindChildControl( "lamp_2" );
	self.lamp[3] = self.m_object:FindChildControl( "lamp_3" );

	self.m_ItemNumText[1] = self.m_object:FindChildControl( "text_nitrogen_num" );
	self.m_ItemNumText[2] = self.m_object:FindChildControl( "text_missile_num" );
	self.m_ItemNumText[3] = self.m_object:FindChildControl( "text_shield_num" );
	--self.m_ItemNumText[4] = self.m_object:FindChildControl( "text_mine_num" );
	--self.m_btn_reset = self.m_object:FindChildControl( "btn_reset" );
	self.m_btn_pause = self.m_object:FindChildControl( "btn_pause" );
	self.m_btn_pause:GetScript():EnableButton( false );

	self.m_ani_call_bg = self.m_object:FindChildControl( "ani_call_bg" );
	self.m_ani_call = self.m_object:FindChildControl( "ani_call" );
	self.m_cpdot_2 = self.m_object:FindChildControl( "cpdot_2" );
	
	self.m_lapbox = self.m_object:FindChildControl( "lapbox" );
	self.m_RankingBg = self.m_object:FindChildControl( "placebox" );
	self.m_textGold = self.m_object:FindChildControl( "text_gold_racing" );

	self.m_btn_left = self.m_object:FindChildControl( "btn_left" );
	self.m_btn_right = self.m_object:FindChildControl( "btn_right" );
	self.m_textOP = self.m_object:FindChildControl( "text_OP" );
	self.m_text_distanse = self.m_object:FindChildControl( "text_distanse" );
	self.m_btn_camera = self.m_object:FindChildControl( "sj1_text_1" );
	self.m_attack_power = self.m_object:FindChildControl( "attack_power" );
	self.m_collideHP = self.m_object:FindChildControl( "collideHP" );
	
	self.m_leftBtn[1] = self.m_object:FindChildControl( "btn_nitrogen" );
	self.m_leftBtn[2] = self.m_object:FindChildControl( "btn_missile" );
	self.m_leftBtn[3] = self.m_object:FindChildControl( "btn_shield" );

	local name;
	for i = 1, 6 do
		name = "time_"..i;
		self.m_timeObj[i] = self.m_object:FindChildControl( name );
	end

	self.m_maxTurns = self.m_object:FindChildControl( "maxTurns" );
	self.m_curTurns = self.m_object:FindChildControl( "curTurns" );
	self.m_ranking = self.m_object:FindChildControl( "curRanking" );
	self.m_totalRanking = self.m_object:FindChildControl( "totalRanking" );
	self.m_btn_temp_item = self.m_object:FindChildControl( "btn_temp_item" );
	self.m_temp_item_symbol = self.m_object:FindChildControl( "temp_item_symbol" );
	self.m_temp_item_num = self.m_object:FindChildControl( "temp_item_num" );
	
	self.m_ani_ganying_bg = self.m_object:FindChildControl( "ani_ganying_bg" );
	self.m_ani_ganying_bg:SetVisible( false );

	--self.m_ranking:SelectAnimation( "ani_num", false, false );
	--self.m_ranking:PauseAnim( true, false );

	if not sGlobal:IsEditor() then
		local mapBg = self.m_object:FindChildControl( "map" );
		local carIcon = self.m_object:FindChildControl( "carIcon" );
		carIcon:SetVisible( false );
		map:Init( self.m_object , mapBg, carIcon );
		local pickUpObj = self.m_object:FindChildControl( "pick_gold" );
		figure:Init( self.m_object, pickUpObj );
		self:Reset();
	end
	
	for i = 1, 3 do
		local name = "hp_"..i;
		self.m_hpObj[i] = self.m_object:FindChildControl( name );
	end
	self.m_player = nil;
	levelinfo.m_racingBody = self
	return 1;
end

function	racing:EventActive( object, param0, param1 )
	if not sGlobal:IsEditor() then
		--self:Reset();
		--self.m_btn_pause:GetScript():EnableButton( false );
		self.m_DataMgr = Global:GetDataMgr();
		self.m_entitySys = sGlobal:GetEntitySys();
	end
	self.m_bDirectBuy = false;
	
	if channel.m_bEnableAd and self.m_bRequstAD and not datasave:IsBuyIapMoreThan30() then
		Global:SystemRequest( SystemEvent.SE_REQUEST_AD );
		self.m_bRequstAD = false;
	end
	
	if channel.m_bEnableAd and not datasave:IsBuyIapMoreThan30() then
		--Global:SystemRequest( SystemEvent.SE_SHOW_AD );
	end
	Global:SystemRequest( SystemEvent.SE_HIDE_AD );
	
	self.m_text_distanse:SetVisible( false );
	return 1;
end

function	racing:Reset()
	for i = 1, 3, 1 do
		self.m_speedObj[i]:SetSymbol( self.m_numSymbol[1] );
	end

	for i = 1, 6, 1 do
		self.m_timeObj[i]:SetSymbol( self.m_numSymbol[1] );
	end

	for i = 1, 3, 1 do
		self.lamp[i]:SetVisible( true );
		self.lamp[i]:SetSymbol( "red" );
	end

	for i = 1, 3, 1 do
		self.m_bLampSound[i] = false;
	end

	self.m_inControlTuition = false;
	self.m_ani_call:SetRelativeTime( 0.0, true );
	self.m_ani_call_bg:SetVisible( false );
	self.m_bResponCallAni = false;
	self.m_fTime = 0.0;
	self.m_fLampTime = 0.0;
	self.m_startAniWaitTime = 5.0;
	self.m_bStartCountTime = false;
	self.m_bStartLampTime = true;
	self.m_bStartStep = 1;
	self.m_bPlayerPassHalf = false;
	self.m_bAiPassHalf = false;
	self.m_bPlayerReverse = false;
	self.m_bAccelerateOver = false;
	self.m_EnableShoot = false;
	self.m_PlayerRankRound = 1;
	self.m_aiRound = 1;
	self.m_PlayerRankPos = 1;
	self.m_Rank = 6;
	self.m_playerOldPos = 1;
	self.m_aiOldPos = 1.1;
	self.m_resetCD = 3;
	self.m_tempItemType = 0;
	self.m_tempItemTime = 60;
	self.m_fNegativeStart = 0.0;
	self.m_fPositiveStart = 0.0;
	self.m_fNegativeEnd = 0.0;
	self.m_dis = 0.0;
	self.m_CollideCount = 0;
	self.m_btn_temp_item:SetVisible( false );
	self.m_ranking:SetRelativeTime( 1.0, true );
end

function	racing:Update( duration )
	if sGlobal:IsEditor() then
		return;
	end
	if Global:IsPause() then
		return;
	end
	
	if self.m_inControlTuition then
		return;
	end
	-- start lamp count
	if self.m_bStartLampTime then
		if self.m_DataMgr:GetModel() == RACING then
			self.m_object:FindChildControl( "top_3_fk" ):SetVisible( true );
		else
			self.m_object:FindChildControl( "top_3_fk" ):SetVisible( false );
		end		
		
		self.m_btn_pause:GetScript():EnableButton( false );
		self.m_fLampTime = self.m_fLampTime + duration;
		if self.m_fLampTime > 1.0 and self.m_bStartStep == 1 then
			self.m_bStartStep = self.m_bStartStep + 1;
			self.lamp[1]:SetSymbol( "green" );

			if not self.m_bLampSound[1] then
				Global:PlaySound(uisound.racing_lamp_light,0);
				self.m_bLampSound[1] = true;
			end
		elseif self.m_fLampTime > 2.0 and self.m_bStartStep == 2 then
			self.m_bStartStep = self.m_bStartStep + 1;
			self.lamp[2]:SetSymbol( "green" );

			if not self.m_bLampSound[2] then
				Global:PlaySound(uisound.racing_lamp_light,0);
				self.m_bLampSound[2] = true;
			end
		elseif self.m_fLampTime > 3.0 and self.m_bStartStep == 3 then
			self.m_bStartStep = self.m_bStartStep + 1;
			self.lamp[3]:SetSymbol( "green" );

			if not self.m_bLampSound[3] then
				Global:PlaySound(uisound.racing_lamp_light_over,0);
				self.m_bLampSound[3] = true;
			end
		elseif self.m_fLampTime > 3.2 and self.m_bStartStep == 4 then
			self.m_bStartStep = self.m_bStartStep + 1;
			self.m_bStartCountTime = true;
			self.m_btn_pause:GetScript():EnableButton( true );
			self.m_tempItemTime = 60;
			map.m_bUpdate = true;
			self.m_object:SendEntityMsg( EVENT_GAME_GO, 1, 0, 0, 0 );
			self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
			Global:StopMusic();
			local ration = Global:RandFloat( 0.0, 1.0 );
			if ration < 0.5 then
				Global:PlayMusic( uisound.game_music_1, -1 );
			else
				Global:PlayMusic( uisound.game_music_2, -1 );
			end
			
			for i = 1, 3, 1 do
				self.lamp[i]:SetVisible( false );
			end
		elseif self.m_fLampTime > 3.4 and self.m_bStartStep == 5 then 
			self.m_bStartLampTime = false;
			levelinfo.m_levelManager.m_bLevelStarted = true;
			self.m_btn_pause:GetScript():EnableButton( true );
			if channel.m_EnableTuition then
				Global:Print("start tuition  ")
				if not datasave:GetDataFromLabel("control_teach") then
					datasave:SetLabelDone("control_teach");
					if Global:GetDataMgr():GetOperateModel() == 1 then
						if not datasave:IsTrackUnlock(2) then
							local entitySys = sGlobal:GetEntitySys();
							entitySys:StartEventGraph("eventgraph/tuition_control.xml");
						end
					end
				end
			end
			--self.m_btn_pause:GetScript():EnableButton( true );
		end
	end
	-- render speed
	local speed = math.floor( Global:GetSpeed() + 0.5 );
	
	if speed >= 999 then
		speed = 999;
	end
	local digital = 0;
	local count = 0;
	while speed ~= 0 do
		count = count + 1;
		digital = math.fmod( speed, 10 );
		speed = math.floor( speed/10 );
		self.m_speedObj[count]:SetSymbol( self.m_numSymbol[digital+1] );
	end

	for i = count + 1, 3, 1 do
		self.m_speedObj[i]:SetSymbol( self.m_numSymbol[1] );
	end
	-- render cur turn
	local maxTurns = 2;
	local curTurns = 1;
	--1.5version 2014.8.28
	if self.m_bStartCountTime then
		self.m_RankingBg:SetVisible( true );
	else
		self.m_RankingBg:SetVisible( false );
	end
	self.m_lapbox:SetVisible( true );
	local curLv = self.m_DataMgr:GetLevel();
	curTurns = math.floor( Global:GetTurns() + 0.5 );
	maxTurns = exl_level_data[curLv].m_maxRound;
	-- for test
	--maxTurns = 0;
	self.m_curTurns:SetSymbol( self.m_numSymbol[curTurns+1] );
	self.m_maxTurns:SetSymbol( self.m_numSymbol[maxTurns +1] );

	if self.m_bStartStep == 5 then
		if levelinfo.m_Mode ~= 1 then
			self.m_text_distanse:SetVisible( false );
		else 
			self.m_text_distanse:SetVisible( true );
		end
	end
	--[[1.4version 2014.8.28 
	if self.m_DataMgr:GetModel() == RACING then
		self.m_text_distanse:SetVisible( false );
		if self.m_bStartCountTime then
			self.m_RankingBg:SetVisible( true );
		else
			self.m_RankingBg:SetVisible( false );
		end
		self.m_lapbox:SetVisible( true );
		local curLv = self.m_DataMgr:GetLevel();
		curTurns = math.floor( Global:GetTurns() + 0.5 );
		maxTurns = exl_level_data[curLv].m_maxRound;
		-- for test
		--maxTurns = 0;
		self.m_curTurns:SetSymbol( self.m_numSymbol[curTurns+1] );
		self.m_maxTurns:SetSymbol( self.m_numSymbol[maxTurns +1] );
	elseif self.m_DataMgr:GetModel() == CHASE then
		if self.m_bStartCountTime then
			self.m_text_distanse:SetVisible( true );
		else
			self.m_text_distanse:SetVisible( false );
		end
		self.m_RankingBg:SetVisible( false );
		self.m_lapbox:SetVisible( false );
	elseif self.m_DataMgr:GetModel() == ACCELERATE then
		--self.m_text_distanse:SetVisible( false );
		self.m_RankingBg:SetVisible( false );
		self.m_lapbox:SetVisible( false );
		
		if self.m_bStartCountTime then
			self.m_text_distanse:SetVisible( true );
		else
			self.m_text_distanse:SetVisible( false );
		end
	end
	--]]
	self:UpdateRanking( duration );

	-- render time
	if self.m_bStartCountTime then
		count = 0;
		--self.m_fTime = self.m_fTime + duration;
		local inte, tail = math.modf( self.m_fTime );
		local minu = math.floor( inte / 60.0 );
		local sec = math.fmod( inte, 60 );
		local mec = math.floor( tail * 100 );
		local talTime = math.floor( minu * 10000 + sec * 100 + mec );

		while talTime ~= 0 do
			count = count + 1;
			digital = math.fmod( talTime, 10 );
			talTime = math.floor( talTime/10 );
			self.m_timeObj[count]:SetSymbol( self.m_numSymbol[digital+1] );
		end

		for i = count + 1, 6, 1 do
			self.m_timeObj[i]:SetSymbol( self.m_numSymbol[1] );
		end
		
		self:CheckFinishLevel( curTurns, maxTurns+1 );
		
		figure:Update( duration );
		
		for i = 1, #(self.m_leftBtn) do
			self.m_leftBtn[i]:GetScript():EnableButton( true );
		end
		
		-- self.m_tempItemTime = self.m_tempItemTime - duration;
		
		-- if self.m_tempItemTime < 0  then
			-- self.m_tempItemTime = -1;
			-- if self.m_tempItemType <= 0 then
				-- self.m_tempItemType = math.floor( Global:RandFloat( 1.0, 3.0 ) + 0.5 );
			-- end
		-- end
		
		if self.m_tempItemType > 0 then
			self.m_btn_temp_item:SetVisible( true );
			if self.m_tempItemType == 1 then
				self.m_temp_item_symbol:SetSymbol( "item_n2o" );
			elseif self.m_tempItemType == 2 then
				self.m_temp_item_symbol:SetSymbol( "item_hj" );
			elseif self.m_tempItemType == 3 then
				self.m_temp_item_symbol:SetSymbol( "item_fy" );
			end
			self.m_temp_item_num:SetSymbolText( "1" );
		else
			self.m_temp_item_num:SetSymbolText( "0" );
			self.m_btn_temp_item:SetVisible( false );
		end
	else
		for i = 1, #(self.m_leftBtn) do
			self.m_leftBtn[i]:GetScript():EnableButton( false );
		end
	end

	self.m_ItemNumText[1]:SetSymbolText( self.m_DataMgr:GetItemNum( ITEM_NITROGEN ) );
	self.m_ItemNumText[2]:SetSymbolText( self.m_DataMgr:GetItemNum( ITEM_MILLISE ) );
	self.m_ItemNumText[3]:SetSymbolText( self.m_DataMgr:GetItemNum( ITEM_SHIELD ) );
	--self.m_ItemNumText[4]:SetSymbolText( self.m_DataMgr:GetItemNum( ITEM_MINE ) );

	map:Update( duration );

	self.m_textGold:SetSymbolText( self.m_DataMgr:GetItemNum( ITEM_GOLD ) );
	
	self.m_resetCD = self.m_resetCD - duration;
	
	if self.m_resetCD < 0 then
		self.m_resetCD = -1;
		--self.m_btn_reset:GetScript():EnableButton( true );
	else
		--self.m_btn_reset:GetScript():EnableButton( false );
	end
	
	--self.m_btn_reset:GetScript():EnableButton( false );

	if self.m_DataMgr:GetOperateModel() == 0 then -- gravity operate
		self.m_btn_left:SetVisible( false );
		self.m_btn_right:SetVisible( false );
		self.m_textOP:SetSymbol( "gy" );
	else
		self.m_btn_left:SetVisible( true );
		self.m_btn_right:SetVisible( true );
		self.m_textOP:SetSymbol( "cz" );
	end
	
	if self.m_DataMgr:GetCameraType() == 0 then
		self.m_btn_camera:SetSymbol( "sj1_text" );
	else
		self.m_btn_camera:SetSymbol( "sj2_text" );
	end
	
	local player = self.m_entitySys:GetRegisterEntity("Player");
	player:EnableShoot( self.m_EnableShoot );
	if self.m_EnableShoot then
		self.m_attack_power:SetSymbol( "attack_on" );
	else
		self.m_attack_power:SetSymbol( "attack_off" );
	end
	
	if self.m_DataMgr:GetItemNum( ITEM_GOLD ) < 100 then
		self.m_EnableShoot = false;
	end
	
	self:UpdateCollideHP( duration );
	
	if self.m_DataMgr:GetOperateModel() == 1 then
		self.m_cpdot_2:SetSymbol( "cpdot" );
	else
		self.m_cpdot_2:SetSymbol( "sym_ganying" );
	end
end

function	racing:UpdateCollideHP( duration )
	local model = self.m_DataMgr:GetModel();
	if model == RACING then
		self.m_collideHP:SetVisible( false );
	elseif model == CHASE then
		self.m_collideHP:SetVisible( false );
	elseif model == ACCELERATE then
		self.m_collideHP:SetVisible( true );
		for i = 1, 3 do
			self.m_hpObj[i]:SetVisible( true );
			if i <= self.m_CollideCount then
				self.m_hpObj[i]:SetVisible( false );
			end
		end
		self.m_CollideInterval = self.m_CollideInterval - duration;
		
		if self.m_CollideInterval <= 0.0 then
			self.m_CollideInterval = 0.0;
		end
	end
end

function	racing:Event_Pause_Click( object, param0, param1 )
	if not self.m_bStartLampTime then
		ClosePage( "Track" );
		ShowPage( "Pause" );

		Global:PlaySound(uisound.racing_btn_pause,0);
	end
	return 1;
end

function	racing:GetCurTime()
	return self.m_fTime;
end

function	racing:CheckFinishLevel( curTurns, maxTurns )
	if self.m_player then
		--1.5 version 2014.8.28
		if levelinfo.m_Mode == 1 then 
			local AiObj = self.m_entitySys:GetRegisterEntity( "ent_level" ):GetScript():GetSpeedModeAI();
			local pathLength = self.m_player:GetPathLength();
			local playerPro = self.m_player:GetRaceProgress();
			local aiPro = AiObj:GetRaceProgress();
			local dis = ( playerPro - aiPro ) * pathLength;
			levelinfo.m_finishDist = dis;
			--sGlobal:Print( "playerPro : "..playerPro.."       aiPro : "..aiPro.."     distanse : "..dis );
			self.m_text_distanse:SetSymbolText( math.floor( dis ).."M" );
		end
		if curTurns >= maxTurns then
			levelinfo.m_levelManager.m_bLevelStarted = false;
			ClosePage( "Track" );
			Global:Print("CheckFinishLevel GiveReward:rank:"..self.m_Rank);
			GiveReward(self:GetRanking());
			
			levelinfo.m_finishTime = self.m_fTime;
			self.m_uiMgr:GetPage( "winlosebox" ):GetScript():EnableShowGradeAni(true);
			ShowPage( "winlosebox" );
			--Global:Pause();
			Global:FlameOut();
			self.m_bStartCountTime = false;
			self.m_bGetLastCar = false;
		end
		--local curModel = self.m_DataMgr:GetModel();
		--[[1.4 version 2014.8.28
		if curModel == RACING then
			if curTurns >= maxTurns then
				self.m_DataMgr:SetRanking( self.m_Rank );
				if not levelinfo:IsFistLevel() then
					self.m_DataMgr:LevelFinish( self.m_fTime );
				end
				ClosePage( "Track" );
				GiveReward(self.m_Rank);
				
				self.m_uiMgr:GetPage( "winlosebox" ):GetScript():EnableShowGradeAni(true);
				ShowPage( "winlosebox" );
				--Global:Pause();
				Global:FlameOut();
				self.m_bStartCountTime = false;
				self.m_bGetLastCar = false;
			end
		elseif curModel == CHASE then
			local AiObj = self.m_entitySys:GetRegisterEntity( "ent_level" ):GetScript():GetSpeedModeAI();
			local pathLength = self.m_player:GetPathLength();
			local playerPro = self.m_player:GetRaceProgress();
			local aiPro = AiObj:GetRaceProgress();
			local dis = ( playerPro - aiPro ) * pathLength;
			
			--sGlobal:Print( "playerPro : "..playerPro.."       aiPro : "..aiPro.."     distanse : "..dis );
			self.m_text_distanse:SetSymbolText( math.floor( dis ).."M" );
			if math.abs( dis ) > 600 then
				self.m_DataMgr:SetRanking( self.m_Rank );
				if dis > 0 then
					self.m_DataMgr:LevelFinish( self.m_fTime );
					self.m_uiMgr:GetPage( "winlosebox" ):GetScript():EnableShowGradeAni(true);
					self.m_uiMgr:GetPage( "winlosebox" ):GetScript():ShowAs(SHOW_WIN);
					ClosePage( "Track" );
					GiveReward(self.m_Rank);
					ShowPage( "winlosebox" );
					--Global:Pause();
					Global:FlameOut();
					self.m_bStartCountTime = false;
					self.m_bGetLastCar = false;
					
					if channel.m_bEnableRank then
						local minTime = GetModelLevelTime( CHASE );
						sGlobal:Print( "   mintime : "..minTime.."    curtime : "..self.m_fTime );
						if self.m_fTime <= minTime + 0.001 then
							Global:ReportNewScore( "CgkI_sOLwsQaEAIQAg", self.m_fTime );
						end
					end
				else
					--self.m_DataMgr:LevelFinish( self.m_fTime );
					self.m_uiMgr:GetPage( "winlosebox" ):GetScript():ShowAs(SHOW_LOSE);
					ClosePage( "Track" );
					GiveReward(self.m_Rank);
					ShowPage( "winlosebox" );
					--Global:Pause();
					Global:FlameOut();
					self.m_bStartCountTime = false;
					self.m_bGetLastCar = false;
				end
			end
		elseif curModel == ACCELERATE then
			local pathLength = self.m_player:GetPathLength();
			local playerPro = self.m_player:GetRaceProgress();
			if playerPro < 0.0 and self.m_fNegativeStart == 0.0 then
				self.m_fNegativeStart = playerPro;
				self.m_fPositiveStart = -1.0;
			end
			
			if playerPro > 0.0 and self.m_fPositiveStart == 0.0 then
				self.m_fPositiveStart = playerPro;
				self.m_fNegativeStart = 1.0;
			end
			
			if playerPro < 0.0 then
				self.m_fNegativeEnd = playerPro;
			else
				self.m_fNegativeEnd = 0.0;
			end
			
			local positive = 0.0;
			if playerPro < 0.0 then
				positive = 0.0;
			else
				positive = playerPro;
			end
			
			if self.m_fNegativeStart < 0.0 then
				self.m_dis = math.floor( ( self.m_fNegativeEnd - self.m_fNegativeStart + positive ) * pathLength + 0.5 );
			end
			
			if self.m_fPositiveStart > 0.0 then
				self.m_dis = math.floor( ( positive - self.m_fPositiveStart ) * pathLength + 0.5 );
			end
			
			--sGlobal:Print( "start : "..self.m_fNegativeStart.."     end : "..self.m_fNegativeEnd.."   positive : "..positive );
			--sGlobal:Print( "playerPro : "..playerPro );
			--sGlobal:Print( "dis : "..self.m_dis );
			
			self.m_text_distanse:SetSymbolText( math.floor( self.m_dis ).."M" );
		end
		--]]
	end
end

function	racing:OnCollide( obj )
	Global:Print("OnCollide");
	local curModel = self.m_DataMgr:GetModel();
	if curModel == ACCELERATE and not self.m_bAccelerateOver and self.m_CollideInterval <= 0.0 then
		if obj == self.m_player then
			self.m_CollideCount = self.m_CollideCount + 1;
			self.m_CollideInterval = 3.0;
			sGlobal:Print( "collide count : "..self.m_CollideCount );
			
			if self.m_CollideCount >= 3 then
				local pathLength = self.m_player:GetPathLength();
				local playerPro = self.m_player:GetRaceProgress();
				
				self.m_DataMgr:SetDistanse( self.m_dis );
				self.m_DataMgr:SetRanking( self.m_Rank );
				
				self.m_DataMgr:LevelFinish( self.m_fTime );
				ClosePage( "Track" );
				GiveReward(self.m_Rank);
				Global:Print("OnCollide GiveReward:rank:"..self.m_Rank);
				ShowPage( "winlosebox" );
				Global:FlameOut();
				self.m_bStartCountTime = false;
				self.m_bGetLastCar = false;
				
				self.m_bAccelerateOver = true;
				
				if channel.m_bEnableRank then
					local maxDis = self.m_DataMgr:GetMaxDistanse();
					sGlobal:Print( "   maxDis : "..maxDis.."    m_dis : "..self.m_dis );
					if self.m_dis + 0.001 >= maxDis then
						Global:ReportNewScore( "CgkI_sOLwsQaEAIQAw", self.m_dis );
					end
				end
			end
		end
	end
end

function	racing:AddAiCar( objAi )
	table.insert( self.m_AiCar, { obj = objAi, oldPos = 1.0, round = 1, passHalf = false, rank = 1 } );
end

function	racing:RemoveCar( objAi );
	sGloba:Print("RemoveCar:".. objAi:GetID());
	for k, value in pairs(self.m_AiCar) do
		if objAi == value.obj then
			table.remove( self.m_AiCar, k );
		end
	end
end

function	racing:ClearCar()
	while #self.m_AiCar > 0 do
		table.remove( self.m_AiCar, 1 );
	end
end

function	racing:EndLevel()
	sGlobal:Print( "End level -------" );
	self.m_EnableShoot = false;
	record_level:Save();
end

function	racing:UpdateRanking( duration )
	local scriptObj;
	local curPos = 0.0;
	local curPlayerPos = 0.0;
	local oldRank = self.m_Rank;

	local CarSize = #( self.m_AiCar ) + 1;
	self.m_Rank = CarSize;
	
	self.m_startAniWaitTime = self.m_startAniWaitTime - duration;
	
	if self.m_startAniWaitTime <= 0 then
		self.m_startAniWaitTime = 0;
	end
	if self.m_player then
		self.m_Rank = self.m_player:GetRanking();
		if self.m_Rank < oldRank then
			self.m_ranking:SelectAnimation( "ani_num", false, false );
			self.m_ranking:PauseAnim( false, false );
			sGlobal:Print( "update ranking cur rank :  "..self.m_Rank );
			
			if self.m_startAniWaitTime <= 0 then
				self.m_startAniWaitTime = 0;
				if self.m_Rank == 1 then
					ShowCallAni( CALL_GUAN_JUN );
				else
					local ran = math.floor( Global:RandFloat( 1.0, 100.0 ) + 0.5 );
					ran = ( ran % 4 ) + 1;
					if ran == 1 then
						ShowCallAni( CALL_LI_HAI );
					elseif ran == 2 then
						ShowCallAni( CALL_KU );
					elseif ran == 3 then
						ShowCallAni( CALL_TAI_ZAN );
					elseif ran == 4 then
						ShowCallAni( CALL_JIN_CAI );
					end
				end
			end
		end
	end
	self.m_totalRanking:SetSymbol( self.m_numSymbol[CarSize + 1] );
	if self.m_Rank < 0 then
		self.m_Rank = 0;
	end
	self.m_ranking:SetSymbol( self.m_numSymbol[self.m_Rank + 1] );
end

function 	racing:GetRanking()
	local rank = 0;
	if levelinfo.m_Mode == 0 or levelinfo.m_Mode == 3 then 
		rank = self.m_Rank;
	elseif levelinfo.m_Mode == 1 then	
		local dis = levelinfo.m_finishDist;
		if dis > levelinfo.m_curLevel.dist3 then
			rank = 1;
		elseif dis > levelinfo.m_curLevel.dist2 then 
			rank = 2;
		elseif dis > levelinfo.m_curLevel.dist1 then
			rank = 3;
		else
			rank = 4;
		end
		--Global:Print("dis:"..dis);
		--Global:Print("dist3:"..levelinfo.m_curLevel.dist3 )
	elseif levelinfo.m_Mode == 2 then
		if self.m_fTime <= levelinfo.m_curLevel.time3 then
			rank = 1;
		elseif self.m_fTime <= levelinfo.m_curLevel.time2 then 
			rank = 2;
		elseif self.m_fTime <= levelinfo.m_curLevel.time1 then
			rank = 3; 
		else
			rank = 4;
		end
	end
	levelinfo.m_finishRank = rank;
	--Global:Print("racing:GetRanking:mode:"..levelinfo.m_Mode.."   rank:"..rank);
	return rank;
end

function	racing:GetLastCar()
	if not self.m_bGetLastCar then
		local t = 0.0;
		local tMin = 0.9;
		local tMax = 0.0;
		local bAll = true; -- all > 0.0 and all < 0.5 is true

		local minObj;
		local maxObj;

		for k, value in pairs( self.m_AiCar ) do
			t = value.obj:GetRelativeLap( self.m_player, false );

			sGlobal:Print( "t : "..t );

			if t < tMin then
				tMin = t;
				minObj = value.obj;
			end

			if t > tMax then
				tMax = t;
				maxObj = value.obj;
			end
			if t > 0.5 then
				bAll = false;
			end
		end

		if bAll then
			self.m_LastCar = minObj;
		else
			self.m_LastCar = maxObj;
		end
		self.m_bGetLastCar = true;
	end
end

function	racing:Event_Nitrogen_Click( event, param0, param1 )
	if self.m_tempItemType == 1 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		Global:PlaySound(uisound.racing_btn_nitrogen,0);
		self.m_player:UseItem( "nitrogen" );
		self.m_player:GetScript():Cheer();
		ShowCallAni( CALL_JI_SU );
		self.m_tempItemTime = 60;
		self.m_tempItemType = 0;
		return 1;
	end
	if self.m_DataMgr:GetItemNum( ITEM_NITROGEN ) > 0 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		self.m_DataMgr:AddItemNum( ITEM_NITROGEN, -1 );
		Global:PlaySound(uisound.racing_btn_nitrogen,0);
		self.m_player:UseItem( "nitrogen" );
		self.m_player:GetScript():Cheer();
		ShowCallAni( CALL_JI_SU );
	else
		local ctrlTbl = self.m_uiMgr:GetPage( "attion_box" ):GetScript();
		ctrlTbl:SetMsgType( TIP_BUY_ITEM );
		ctrlTbl:SetItemName( "dqjs" );
		self.m_ChooseItemText = "dqjs";
		ctrlTbl:EnablePause( true );
		ShowDialog( "attion_box" );
		self.m_ChooseItemID = 1;
		ctrlTbl:SetItemPrice( ItemPrice[self.m_ChooseItemID] );
	end
	return 1;
end

function	racing:Event_Missile_Click( event, param0, param1 )
	if self.m_tempItemType == 2 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		Global:PlaySound(uisound.racing_btn_missle,0);
		self.m_player:UseItem( "missile" );
		self.m_tempItemTime = 60;
		self.m_tempItemType = 0;
		return 1;
	end
	if self.m_DataMgr:GetItemNum( ITEM_MILLISE ) > 0 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		self.m_DataMgr:AddItemNum( ITEM_MILLISE, -1 );
		Global:PlaySound(uisound.racing_btn_missle,0);
		self.m_player:UseItem( "missile" );
	else
		local ctrlTbl = self.m_uiMgr:GetPage( "attion_box" ):GetScript();
		ctrlTbl:SetMsgType( TIP_BUY_ITEM );
		ctrlTbl:SetItemName( "yxfd" );
		self.m_ChooseItemText = "yxfd";
		ctrlTbl:EnablePause( true );
		ShowDialog( "attion_box" );
		self.m_ChooseItemID = 2;
		ctrlTbl:SetItemPrice( ItemPrice[self.m_ChooseItemID] );
	end
	return 1;
end

function	racing:Event_Shield_Click( event, param0, param1 )
	if self.m_tempItemType == 3 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		Global:PlaySound(uisound.racing_btn_shield,0);
		self.m_player:UseItem( "shield" );
		self.m_tempItemTime = 60;
		self.m_tempItemType = 0;
		return 1;
	end;
	if self.m_DataMgr:GetItemNum( ITEM_SHIELD ) > 0 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		self.m_DataMgr:AddItemNum( ITEM_SHIELD, -1 );
		Global:PlaySound(uisound.racing_btn_shield,0);
		self.m_player:UseItem( "shield" );
	else
		local ctrlTbl = self.m_uiMgr:GetPage( "attion_box" ):GetScript();
		ctrlTbl:SetMsgType( TIP_BUY_ITEM );
		ctrlTbl:SetItemName( "wdfh" );
		self.m_ChooseItemText = "wdfh";
		ctrlTbl:EnablePause( true );
		ShowDialog( "attion_box" );
		self.m_ChooseItemID = 3;
		ctrlTbl:SetItemPrice( ItemPrice[self.m_ChooseItemID] );
	end
	return 1;
end

function	racing:Event_Left_Click( event, param0, param1 )
	if self.m_player then
		if event == "BUTTON_DOWN" then
			self.m_player:OnControl( true, true );
		elseif event == "BUTTON_UP" then
			self.m_player:OnControl( true, false );
		end
	end
	return 1;
end

function	racing:Event_Right_Click( event, param0, param1 )
	if self.m_player then
		if event == "BUTTON_DOWN" then
			self.m_player:OnControl( false, true );
		elseif event == "BUTTON_UP" then
			self.m_player:OnControl( false, false );
		end
	end
	return 1;
end

-- function	racing:Event_Reset_Click( event, param0, param1 )
	-- if self.m_player and self.m_resetCD < 0 then
		-- self.m_player:Adjust();
		-- self.m_resetCD = 3;
	-- end
	-- return 1;
-- end

function	racing:Event_GanYing_Ani_Over( object, param0, param1 )
	if object == "Shake_ani_over" then
		self.m_ani_ganying_bg:SetVisible( false );
	end
	return 1;
end

function	racing:Event_Change_OP_Model( event, param0, param1 )
	local operateType = self.m_DataMgr:GetOperateModel();
	if operateType == 0 then
		self.m_DataMgr:SetOperateModel(1);
		if channel.m_EnableTuition then
			if not datasave:GetDataFromLabel("sensor_teach") then
				datasave:SetLabelDone("sensor_teach");
			end
		end
	elseif operateType == 1 then
		self.m_DataMgr:SetOperateModel(0);
		
		if channel.m_EnableTuition then
			if not datasave:GetDataFromLabel("sensor_teach") then
				datasave:SetLabelDone( "sensor_teach" );
				if not datasave:IsTrackUnlock(2) then
					local entitySys = sGlobal:GetEntitySys();
					entitySys:StartEventGraph("eventgraph/tutorial_zhongli.xml");
				end
			end
		end
	end
	return 1;
end

function	racing:Event_Camera_Click( object, param0, param1 )
	if self.m_player then
		local cameraType = self.m_DataMgr:GetCameraType();
		if cameraType == 0 then
			self.m_DataMgr:SetCameraType(1);
			self.m_player:SetView(false);
		elseif cameraType == 1 then
			self.m_DataMgr:SetCameraType(0);
			self.m_player:SetView(true);
		end
	end
	return 1;
end

function	racing:Event_Temp_Item_Click( object, param0, param1 )
	if self.m_tempItemType > 0 then
		self.m_player = self.m_entitySys:GetRegisterEntity( "Player" );
		if self.m_tempItemType == 1 then -- nitrogen
			Global:PlaySound(uisound.racing_btn_nitrogen,0);
			self.m_player:GetScript():Cheer();
			self.m_player:UseItem( "nitrogen" );
		elseif self.m_tempItemType == 2 then -- missile
			Global:PlaySound(uisound.racing_btn_missle,0);
			self.m_player:UseItem( "missile" );
		elseif self.m_tempItemType == 3 then -- shield
			Global:PlaySound(uisound.racing_btn_shield,0);
			self.m_player:UseItem( "shield" );
		end
		self.m_tempItemTime = 60;
		self.m_tempItemType = 0;
	end
	return 1;
end

function	racing:Event_Shoot_Click( object, param0, param1 )
	if self.m_EnableShoot then
		self.m_EnableShoot = false;
	else
		self.m_EnableShoot = true;
	end
	local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
	if gold < 100 then
		self.m_EnableShoot = false;
	end
	return 1;
end

function 	racing:Control_Event( object, param0, param1 )
	if TIP_BUY_ITEM == param0 then
		local itemNum = param1;
		self.m_ChooseItemNum = itemNum;
		local price = itemNum * ItemPrice[ self.m_ChooseItemID ];
		local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
		Global:Print("Control_Event!!!!")
		if channel:IsVipEnabled() then
			price = price * VipData[datasave:GetVipLevel()][3];
		end
		if price > 0 then
			if gold >= price then
				local NoticeName;
				self.m_DataMgr:AddItemNum( ITEM_GOLD, -price );
				if self.m_ChooseItemID == 1 then
					self.m_DataMgr:AddItemNum( ITEM_NITROGEN, itemNum );
					NoticeName = "nitrogen_"..itemNum;
				elseif self.m_ChooseItemID == 2 then
					self.m_DataMgr:AddItemNum( ITEM_MILLISE, itemNum );
					NoticeName = "missile_"..itemNum;
				elseif self.m_ChooseItemID == 3 then
					self.m_DataMgr:AddItemNum( ITEM_SHIELD, itemNum );
					NoticeName = "shield_"..itemNum;
				elseif self.m_ChooseItemID == 4 then
					self.m_DataMgr:AddItemNum( ITEM_MINE, itemNum );
					NoticeName = "mine_"..itemNum;
				end
				ClosePage( "attion_box" );
								
				Global:EventNoticeEx( "purchase_in_race", NoticeName );
			else
				if channel.m_EnableShowShop then
					local ctrlTbl = self.m_uiMgr:GetPage( "attion_box" ):GetScript();
					ctrlTbl:SetMsgType( TIP_IAP );
					ctrlTbl:SetIapPrice( price - gold );
					-- --ctrlTbl:SetItemName( "xqdl" );
					-- ctrlTbl:EnablePause( true );
					
					-- sGlobal:Print( "Show ATTION_BOX" );
					-- ShowDialog( "attion_box" );
					-- ShowPage( "attion_box" );
				else
					Global:PlaySound(uisound.nomoney, 0);
					ShowDialog( "nomoneytip" );
				end
			end
		end
	elseif TIP_IAP == param0 then
		local iapID = param1;
		--ClosePage( "attion_box" );
		self.m_bDirectBuy = true;
		OnStartPurchase( iapID, nil );
		
		-- local ctrlTbl = self.m_uiMgr:GetPage( "attion_box" ):GetScript();
		-- ctrlTbl:SetMsgType( TIP_BUY_ITEM );
		-- ctrlTbl:SetItemName( self.m_ChooseItemText );
		-- ctrlTbl:EnablePause( true );
		-- ShowDialog( "attion_box" );
		
		-- ctrlTbl:SetItemPrice( ItemPrice[self.m_ChooseItemID] );
		-- ctrlTbl:SetNum( self.m_ChooseItemNum );
	end
	return 1;
end

function	racing:Event_Call_Ani_Over( object, param0, param1 )
	if self.m_bResponCallAni and object == "Ani_Call_Over" then
		sGlobal:Print( "fk ani over" );
		self.m_ani_call_bg:SetVisible( false );
		self.m_bResponCallAni = false;
	end
	return 1;
end

function	racing:PcsIapSuccess( pcsID )
	ClosePage( "attion_box" );
	if self.m_bDirectBuy then
		local gold = self.m_DataMgr:GetItemNum(ITEM_GOLD);
		local price = self.m_ChooseItemNum * ItemPrice[self.m_ChooseItemID];
		if channel:IsVipEnabled() then
			price = price * VipData[datasave:GetVipLevel()][3];
		end
		if price > 0 then
			if gold >= price then
				local NoticeName;
				self.m_DataMgr:AddItemNum( ITEM_GOLD, -price );
				if self.m_ChooseItemID == 1 then
					self.m_DataMgr:AddItemNum( ITEM_NITROGEN, self.m_ChooseItemNum );
					NoticeName = "nitrogen_"..self.m_ChooseItemNum;
				elseif self.m_ChooseItemID == 2 then
					self.m_DataMgr:AddItemNum( ITEM_MILLISE, self.m_ChooseItemNum );
					NoticeName = "missile_"..self.m_ChooseItemNum;
				elseif self.m_ChooseItemID == 3 then
					self.m_DataMgr:AddItemNum( ITEM_SHIELD, self.m_ChooseItemNum );
					NoticeName = "shield_"..self.m_ChooseItemNum;
				elseif self.m_ChooseItemID == 4 then
					self.m_DataMgr:AddItemNum( ITEM_MINE, self.m_ChooseItemNum );
					NoticeName = "mine_"..self.m_ChooseItemNum;
				end
				
				Global:EventNoticeEx( "purchase_in_race", NoticeName );
			end
		end
	end
	
	self.m_bDirectBuy = false;
end

function	racing:GiveTempItem()
	if not datasave:GetDataFromLabel("randitem_teach") then
		self.m_tempItemType = 1;
		--Global:Print("racing:GiveTempItem:speed")
		return
	end
	self.m_tempItemType = math.floor( Global:RandFloat( 1.0, 3.0 ) + 0.5 );
	--Global:Print("racing:randItemType:"..self.m_tempItemType)
end

function	racing:ShowCallAni( index )
	self.m_bResponCallAni = true;
	self.m_ani_call_bg:SetVisible( true );
	self.m_ani_call:SetSymbol( self.m_call_sym[index] );
	self.m_ani_call:SelectAnimation( "ani_tipsinf", false, true );
	self.m_ani_call:PauseAnim( false, true );
	Global:PlaySound(uisound.ui_chaoche,0);
	if index == CALL_GUAN_JUN then
		self.m_player:GetScript():Cheer(true);
	end	
end

function 	racing:EventKeyUp( key_code )
	if key_code == 27 and not self.lamp[3]:IsVisible() then
		ClosePage( "Track" );
		ShowPage( "Pause" );
	end
	return 1;
end

racing.ControlEvents = {
	Inputs = {
		btn_pause = { "Event_Pause_Click" };

		btn_nitrogen = { "Event_Nitrogen_Click" };
		btn_missile = { "Event_Missile_Click" };
		btn_shield = { "Event_Shield_Click" };

		btn_left = { "Event_Left_Click" };
		btn_right = { "Event_Right_Click" };
		--btn_reset = { "Event_Reset_Click" };
		btn_changeOpModel = { "Event_Change_OP_Model" };
		attion_box = { "Control_Event" };
		btn_camera_fc = { "Event_Camera_Click" };
		btn_temp_item = { "Event_Temp_Item_Click" };
		
		btn_shoot_power = { "Event_Shoot_Click" };
		ani_call = { "Event_Call_Ani_Over" };
		ani_ganying = { "Event_GanYing_Ani_Over" };
	}
}
