
require( "scripts/global.lua" )

refixcar = {
	m_object;
	m_uiMgr;
	m_DataMgr;
	
	m_bChooseCarToRefix = false;
	m_bWinLoseToRefix = false;
	
	m_refixID = 1;
}

function	refixcar:SetRefixID( id )
	self.m_refixID = id;
end

function	refixcar:ChooseCarToRefix()
	self.m_bChooseCarToRefix = true;
end

function	refixcar:WinLoseToRefix()
	self.m_bWinLoseToRefix = true;
end

function	refixcar:Init( object )
	self.m_object = object;
end

function	refixcar:EventInit( event, param0, param1 )
	self.m_uiMgr = sGlobal:GetUIManager();
	return 1;
end

function	refixcar:EventActive( event, param0, param1 )
	self.m_DataMgr = Global:GetDataMgr();
	if channel.m_EnableRefixByIap then
		self.m_object:FindChildControl( "rmb2_7" ):SetVisible( false );
		self.m_object:FindChildControl( "rmb2_5" ):SetVisible( true );
		self.m_object:FindChildControl( "rmb2_5" ):SetSymbol( "rmb2" );
	else
		self.m_object:FindChildControl( "rmb2_7" ):SetVisible( true );
		self.m_object:FindChildControl( "rmb2_5" ):SetVisible( false );
		self.m_object:FindChildControl( "rmb2_7" ):SetSymbolText( math.floor(property_car:GetUpgradePrice( self.m_refixID )) );
	end
	return 1;
end

function	refixcar:EventClose( event, param0, param1 )
	ClosePage( "upgrade" );
	if self.m_bChooseCarToRefix then
		ShowPage( "choosecar" );
	end
	
	self.m_bChooseCarToRefix = false;
	self.m_bWinLoseToRefix = false;
	return 1;
end

function	refixcar:EventConfirm( event, param0, param1 )
	self.m_DataMgr = Global:GetDataMgr();
	if channel.m_EnableRefixByIap then
		ClosePage( "upgrade" );
		OnStartPurchase( PCS_CAR_REFIT, nil );
		if self.m_bChooseCarToRefix then
			ShowPage( "choosecar" );
		end
	else
		local upPrice = math.floor(property_car:GetUpgradePrice( self.m_refixID ));
		if upPrice > 0 and self.m_DataMgr:GetItemNum( ITEM_GOLD ) >= upPrice then
			ClosePage( "upgrade" );
			self.m_uiMgr:GetPage( "choosecar" ):GetScript():RefitCar();
			self.m_DataMgr:AddItemNum( ITEM_GOLD, -upPrice );
			if self.m_bChooseCarToRefix then
				ShowPage( "choosecar" );
			end
		else
			Global:PlaySound(uisound.nomoney,0);
			ShowDialog( "nomoneytip" );
		end
	end
	
	self.m_bChooseCarToRefix = false;
	self.m_bWinLoseToRefix = false;
	return 1;
end

function 	refixcar:EventKeyUp( key_code )
	if key_code == 27 then
		self:EventClose( "BN_CLICK", 0, 0 );

	elseif key_code == 13 then
		self.m_object:FindChildControl( "btn_refix_confirme" ):SendMsg( "BN_CLICK", 0, 0 );
	end
	return 1;
end

refixcar.ControlEvents = {
	Inputs = {
		btn_refix_close = { "EventClose" };
		btn_refix_confirme = { "EventConfirm" };
	};
};
