BUTTON_NORMAL = 0
BUTTON_PRESS = 1

tracebutton = {
	Properties = {
		normal = "";
		press = "";
		disable = "";
		sound = "";
	};

	m_object;
	m_state;
	m_laststate;
	m_bTouchBegin = false;
	m_bEnAble = true;
	m_Count = 0;

	m_ID = -1;
};

function tracebutton:EventInit( object, dump0, dump1 )
	self.m_object = sGlobal:GetUIManager():GetControl(object);
	self.m_object:SetSymbol( self.Properties.normal );
	self.m_state = BUTTON_NORMAL;
	self.m_laststate = BUTTON_PRESS;
	--self:PlayAnim();
	self.m_Count = 0;
	self.m_ID = self.m_object:GetID();
	return 1;
end

function tracebutton:SetID( ID )
	self.m_ID = ID;
end

function tracebutton:GetID()
	return self.m_ID;
end

function tracebutton:SetSymbol( normal, press )
	self.Properties.normal = normal;
	self.Properties.press = press;
	self.m_object:SetSymbol(normal);
end

function tracebutton:EnableButton( enable )
	self.m_bEnAble = enable;

	if enable == true then
		self.m_object:EnableControlEvent(true, true);
		self.m_object:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
	else
		self.m_object:EnableControlEvent(false, true);
		self.m_object:SetAmbient( 0.4, 0.4, 0.4, 1.0, true );
	end
end

function tracebutton:Enable( enable )
	self.m_bEnAble = enable;

	if enable == true then
		self.m_object:EnableControlEvent(true, true);
		self.m_object:SetSymbol(self.Properties.normal);
	else
		self.m_object:EnableControlEvent(false, true);
		if self.Properties.disable ~= "" then
			self.m_object:SetSymbol(self.Properties.disable);
		end
	end
end

function tracebutton:GetEnable()
	return self.m_bEnAble;
end

function tracebutton:GetDownX()
	return self.m_DownX;
end

function tracebutton:GetDownY()
	return self.m_DownY;
end

function tracebutton:EventTouchBegin( id, x, y )
	self.m_state = BUTTON_PRESS;
	self.m_object:SetSymbol( self.Properties.press );
	self.m_object:SetTouchCapture(id);

	self.m_Count = self.m_Count + 1;
	self.m_bTouchBegin = true;
	
	self.m_object:SendMsg( "BUTTON_DOWN", self.m_ID , 0 );
	--self:PlayAnim();
	return 1;
end

function tracebutton:EventTouchMove( id, x, y )
	if self.m_bTouchBegin then
		self.m_object:SendMsg( "BUTTON_DOWN", self.m_ID , 0 );
	end
	return 1;
end

function tracebutton:EventTouchEnd( id, x, y )
	if self.m_bTouchBegin == false then
		return 0;
	end

	self.m_bTouchBegin = false;

	self.m_object:ReleaseTouchCapture(id);

	--if self.m_object:HitTest( x, y ) then
		self.m_state = BUTTON_NORMAL;
		self.m_object:SetSymbol( self.Properties.normal );
		--self:PlayAnim();
		self.m_object:SendMsg( "BUTTON_UP", self.m_ID , 0 );

		if self.Properties.sound ~= "" then
			Global:PlaySound( self.Properties.sound, 0 );
		end
	--end

	return 1;
end

function	tracebutton:Update( duration )
	if sGlobal:IsEditor() then
		return;
	end
	if Global:IsPause() then
		return;
	end
	if self.m_bTouchBegin then
		self.m_object:SendMsg( "BUTTON_DOWN", self.m_ID , 0 );
	end
end

--[[--
function tracebutton:EventAnimOver( anim )
	if self.m_Count > 0 then
		if ( self.Properties.pressanim ~= "" ) then
			self.m_object:SelectAnimation( self.Properties.pressanim, true, true );
		end
		self.m_Count = self.m_Count - 1;
	else
		if ( self.Properties.normalanim ~= "" ) then
			self.m_object:SelectAnimation( self.Properties.normalanim, true, true );
		end
	end
	return 1;
end
--]]--
function tracebutton:PlayAnim()
	if self.m_state == BUTTON_PRESS then
		if self.m_object:IsAnimOver() == true then
			if ( self.Properties.pressanim ~= "" ) then
				self.m_object:SelectAnimation( self.Properties.pressanim, true, true );
			end
		end
	else
		if self.m_object:IsAnimOver() == true then
			if ( self.Properties.normalanim ~= "" ) then
				self.m_object:SelectAnimation( self.Properties.normalanim, true, true );
			end
		end
	end
end
