BUTTON_NORMAL = 0
BUTTON_PRESS = 1

tracepage = {
	Properties = {
		normal = "";
		press = "";
		disable = "";
		sound = "";
	};

	m_object;
	m_state;
	m_laststate;
	m_bTouchBegin = false;
	m_bEnAble = true;
	m_Count = 0;

	m_ID = -1;
	m_Owner = nil;
	
	m_DownX = 0;
	m_DownY = 0;
	
	m_bMoveLogic = false;
	m_bIgnoreMove = false;
};

function tracepage:EventInit( object, dump0, dump1 )
	self.m_object = sGlobal:GetUIManager():GetControl(object);
	self.m_object:SetSymbol( self.Properties.normal );
	self.m_state = BUTTON_NORMAL;
	self.m_laststate = BUTTON_PRESS;
	--self:PlayAnim();
	self.m_Count = 0;
	self.m_ID = self.m_object:GetID();
	return 1;
end

function tracepage:SetID( ID )
	self.m_ID = ID;
end

function tracepage:GetID()
	return self.m_ID;
end

function tracepage:SetOwner( owner )
	self.m_Owner = owner;
end

function tracepage:SetSymbol( normal, press )
	self.Properties.normal = normal;
	self.Properties.press = press;
	self.m_object:SetSymbol(normal);
end

function tracepage:EnableButton( enable )
	self.m_bEnAble = enable;

	if enable == true then
		self.m_object:EnableControlEvent(true, true);
		self.m_object:SetAmbient( 1.0, 1.0, 1.0, 1.0, true );
	else
		self.m_object:EnableControlEvent(false, true);
		self.m_object:SetAmbient( 0.4, 0.4, 0.4, 1.0, true );
	end
end

function tracepage:Enable( enable )
	self.m_bEnAble = enable;

	if enable == true then
		self.m_object:EnableControlEvent(true, true);
		self.m_object:SetSymbol(self.Properties.normal);
	else
		self.m_object:EnableControlEvent(false, true);
		if self.Properties.disable ~= "" then
			self.m_object:SetSymbol(self.Properties.disable);
		end
	end
end

function tracepage:GetEnable()
	return self.m_bEnAble;
end

function tracepage:GetDownX()
	return self.m_DownX;
end

function tracepage:GetDownY()
	return self.m_DownY;
end

function tracepage:EventTouchBegin( id, x, y )
	self.m_state = BUTTON_PRESS;
	self.m_object:SetSymbol( self.Properties.press );
	self.m_object:SetCapture();

	self.m_Count = self.m_Count + 1;
	--self:PlayAnim();
	self.m_DownX = x;
	self.m_DownY = y;

	self.m_bTouchBegin = true;
	self.m_bMoveLogic = false
	self.m_bIgnoreMove = false;
	return 1;
end

function tracepage:EventTouchMove( id, x, y )
	if self.m_bTouchBegin == false then
		return 1;
	end
	
	if math.abs( x - self.m_DownX ) > 5 or math.abs( y - self.m_DownY ) > 5 then
		if not self.m_bMoveLogic then
			self.m_bTouchBegin = false;
			self.m_object:ReleaseCapture();
			self.m_state = BUTTON_NORMAL;
			self.m_object:SetSymbol( self.Properties.normal );
			
			self.m_Owner:GetScript():EventTouchBegin( id, x, y );
			self.m_bMoveLogic = true;
			self.m_bIgnoreMove = true;
		end
	end
	
	if self.m_bIgnoreMove then
		self.m_Owner:GetScript():EventTouchMove( id, x, y );
	else
		if self.m_object:HitTest( x, y ) then
			self.m_state = BUTTON_PRESS;
			self.m_object:SetSymbol( self.Properties.press );
		else
			self.m_state = BUTTON_NORMAL;
			self.m_object:SetSymbol( self.Properties.normal );
		end
	end

	return 1;
end

function tracepage:EventTouchEnd( id, x, y )
	if self.m_bIgnoreMove then
		self.m_Owner:GetScript():EventTouchEnd( id, x, y );
	else
		if self.m_bTouchBegin == false then
			return 0;
		end
		
		self.m_bTouchBegin = false;

		self.m_object:ReleaseCapture();

		if self.m_object:HitTest( x, y ) then
			self.m_state = BUTTON_NORMAL;
			self.m_object:SetSymbol( self.Properties.normal );
			--self:PlayAnim();
			self.m_object:SendMsg( "BN_CLICK", self.m_ID , 0 );

			if self.Properties.sound ~= "" then
				Global:PlaySound( self.Properties.sound, 0 );
			end
		end
	end
	return 1;
end
--[[--
function tracepage:EventAnimOver( anim )
	if self.m_Count > 0 then
		if ( self.Properties.pressanim ~= "" ) then
			self.m_object:SelectAnimation( self.Properties.pressanim, true, true );
		end
		self.m_Count = self.m_Count - 1;
	else
		if ( self.Properties.normalanim ~= "" ) then
			self.m_object:SelectAnimation( self.Properties.normalanim, true, true );
		end
	end
	return 1;
end
--]]--
function tracepage:PlayAnim()
	if self.m_state == BUTTON_PRESS then
		if self.m_object:IsAnimOver() == true then
			if ( self.Properties.pressanim ~= "" ) then
				self.m_object:SelectAnimation( self.Properties.pressanim, true, true );
			end
		end
	else
		if self.m_object:IsAnimOver() == true then
			if ( self.Properties.normalanim ~= "" ) then
				self.m_object:SelectAnimation( self.Properties.normalanim, true, true );
			end
		end
	end
end
