
vipbox = {
	m_object;
	m_uiMgr;
	m_dt_current_viplv;
	m_dt_vip_money_left;
	m_dt_next_viplv;
	m_dt_authority_1;
	m_dt_authority_2;
	m_st_authority_1;
	m_st_authority_2;
	m_st_authority_3;
	m_dt_cur_vip_title;
	m_curVipShow = 1;
	m_moneyLeft = 0;
}
function vipbox:Init(obj)
	self.m_object = obj;
end

function vipbox:EventInit(obj)
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_dt_authority_2 = self.m_object:FindChildControl("dt_authority_2");
	self.m_dt_authority_1 = self.m_object:FindChildControl("dt_authority_1");
	self.m_dt_vip_money_left = self.m_object:FindChildControl("dt_vip_money_left");
	self.m_dt_next_viplv = self.m_object:FindChildControl("dt_next_viplv");
	self.m_dt_current_viplv = self.m_object:FindChildControl("dt_current_viplv");
	self.m_dt_cur_vip_title = self.m_object:FindChildControl("dt_cur_vip_title");
	self.m_st_authority_1 = self.m_object:FindChildControl("st_authority_1");
	self.m_st_authority_2 = self.m_object:FindChildControl("st_authority_2");
	self.m_st_authority_3 = self.m_object:FindChildControl("st_authority_3");
	return 1;
end

function vipbox:EventActive( object, param0, param1 )
	self.m_st_authority_3:SetSymbol("vip_authority_3");
	self.m_st_authority_2:SetSymbol("vip_authority_2");
	self.m_st_authority_1:SetSymbol("vip_authority_1");
	if datasave:GetVipLevel() < 5 then
		self.m_curVipShow = datasave:GetVipLevel() + 1;
		if self.m_curVipShow > 4 then
			self.m_curVipShow = 4;
		end
	elseif datasave:GetVipLevel() >= 4 then
		self.m_curVipShow = 4;
	end
	sGlobal:Print("datasave:curVipData:"..self.m_curVipShow);
	local curVipData = VipData[self.m_curVipShow];
	sGlobal:Print("curVipData:"..curVipData[4]);
	self.m_dt_authority_1:SetSymbolText((curVipData[2]*100).."%");
	self.m_dt_authority_2:SetSymbol(curVipData[5]);
	self.m_dt_cur_vip_title:SetSymbol(VipData[self.m_curVipShow][4]);
	self:RefreshCurVipInfo();
	return 1;
end
function vipbox:RefreshVipInfo(lv)
	self.m_curVipShow = lv;
	local curVipData = VipData[self.m_curVipShow];
	self.m_dt_authority_1:SetSymbolText((curVipData[2]*100).."%");
	self.m_dt_authority_2:SetSymbol(curVipData[5]);
	self.m_dt_cur_vip_title:SetSymbol(VipData[lv][4]);
end
function vipbox:RefreshCurVipInfo()
	self.m_moneyLeft = 0;
	local nextVipSymbol = nil;
	if datasave:GetVipLevel() < 4 then
		Global:Print("lang:"..sGlobal:GetUIManager():GetLanguage());
		if sGlobal:GetUIManager():GetLanguage() == "chs" then
			self.m_moneyLeft = VipData[datasave:GetVipLevel() + 1][1] - datasave.m_curChargeExp;
		else
			self.m_moneyLeft = VipData[datasave:GetVipLevel() + 1].en- datasave.m_curChargeExp_en;
		end
		nextVipSymbol = VipData[datasave:GetVipLevel() + 1][4];
	else
		self.m_moneyLeft = 0;
		nextVipSymbol = VipData[4][4];
	end
	--sGlobal:Print("m_curChargeExp:"..datasave.m_curChargeExp.."  left:"..self.m_moneyLeft);
	self.m_dt_vip_money_left:SetSymbolText(self.m_moneyLeft);
	self.m_dt_next_viplv:SetSymbol(nextVipSymbol);
	self.m_dt_current_viplv:SetSymbolText(datasave:GetVipLevel());
end
function vipbox:EventClose( object, param0, param1 )
	self.m_uiMgr:CloseWindow(self.m_object);
	return 1;
end
 function 	vipbox:EventKeyUp( key_code )
	if key_code == 27 then
		self:EventClose();
	end
	return 1;
 end
function vipbox:Event_vip1( object, param0, param1 )
	self:RefreshVipInfo(1);
	return 1;
end
function vipbox:Event_vip2( object, param0, param1 )
	self:RefreshVipInfo(2);
	return 1;
end
function vipbox:Event_vip3( object, param0, param1 )
	self:RefreshVipInfo(3);
	return 1;
end
function vipbox:Event_vip4( object, param0, param1 )
	self:RefreshVipInfo(4);
	return 1;
end
function vipbox:Event_Charge( object, param0, param1 )
	if sGlobal:GetUIManager():GetLanguage() == "chs" then
		if self.m_moneyLeft <= 5 then
			OnStartPurchase(PCS_GOLD_1000000,self);
		elseif self.m_moneyLeft <= 15 then
			OnStartPurchase(PCS_GOLD_3500000,self);
		else
			OnStartPurchase(PCS_GOLD_8600000,self);
		end
	else
		if self.m_moneyLeft <= 1 then
			OnStartPurchase(PCS_GOLD_3500000,self);
		elseif self.m_moneyLeft <= 3 then
			OnStartPurchase(PCS_GOLD_8600000,self);
		else
			OnStartPurchase(PCS_GOLD_9000000,self);
		end
	end
	return 1;
end
function vipbox:PurchaseSuccess(id)
	self:RefreshCurVipInfo();
end
vipbox.ControlEvents = {
	Inputs = {
		btn_close_vipbox = {"EventClose"};
		btn_vip1 = {"Event_vip1"};
		btn_vip2 = {"Event_vip2"};
		btn_vip3 = {"Event_vip3"};
		btn_vip4 = {"Event_vip4"};
		btn_vip_charge = {"Event_Charge"};
	};
}