require( "ui/impl/uisound.lua" )
require( "scripts/record_level.lua")
winandlose = {
	m_object;
	m_bg;
	m_uiMgr;
	
	m_text_title;
	m_DataMgr;
	m_numSymbol = { "no0", "no1", "no2", "no3", "no4", "no5", "no6", "no7", "no8", "no9" };
	m_titleName  ={ "level5_car", "level4_car", "level3_car", "level2_car", "level1_car" };
	m_timeObj;
	m_curTimeObj;
	
	m_textGold;
	m_textWinLose;
	m_rankingBg;
	m_btn_nextLevel;
	m_btn_restart;
	
	m_bestTimeBg;
	m_curTimeBg;
	
	m_bestDisBg;
	m_curDisBg;
	
	m_start = {};
	
	m_text_reward;
	
	m_btn_critical_diamond;
	m_btn_refix_winlose;
	m_btn_rank_winlose;
	
	m_sym_jiayou;
	m_ani_gradeBg_winlose;
	m_ani_grade_winlose;
	m_ani_gradeEffect_winlose;
	m_btn_free_winlose;
	m_free_value_winlose;
	m_free_value_bg_winlose;
	
	m_gradeEffectTime = 1.0;
	m_bResponGradeAniOver = true;
	m_bShowGradeAni = false;
	
	m_showType = SHOW_WIN;
	m_bShowFight = false;
	m_btn_video;
	gradeSym = { "addtop1", "addtop2", "addtop3" };
	m_bGiftAircraft = true;
	m_bFirstClickRestart = true;

	m_bFirstTestDriver = false;
	m_giftbox = nil;
}

SHOW_WIN = 0;
SHOW_LOSE = 1;

function	winandlose:Init( object )
	self.m_object = object;
end

function	winandlose:EventInit( object )
	self.m_uiMgr = sGlobal:GetUIManager();
	self.m_bg = self.m_object:FindChildControl( "bgblack_4" );
	self.m_text_title = self.m_object:FindChildControl( "text_title" );
	self.m_textGold = self.m_object:FindChildControl( "text_winlose_gold" );
	self.m_textWinLose = self.m_object:FindChildControl( "text_winlose" );
	self.m_rankingBg = self.m_object:FindChildControl( "rankingBg" );
	self.m_btn_nextLevel = self.m_object:FindChildControl( "btn_nextLevel" );
	self.m_btn_restart = self.m_object:FindChildControl( "btn_restart" );
	self.m_text_reward = self.m_object:FindChildControl( "text_reward" );
	self.m_btn_rank_winlose = self.m_object:FindChildControl( "btn_rank_winlose" );
	self.m_start[1] = self.m_object:FindChildControl( "star_car_1" );
	self.m_start[2] = self.m_object:FindChildControl( "star_car_2" );
	self.m_start[3] = self.m_object:FindChildControl( "star_car_3" );
	
	self.m_btn_refix_winlose = self.m_object:FindChildControl( "btn_refix_winlose" );
	self.m_btn_free_winlose = self.m_object:FindChildControl( "win_lose_free" );
	self.m_free_value_winlose = self.m_object:FindChildControl( "free_value_winlose" );
	self.m_free_value_bg_winlose = self.m_object:FindChildControl( "free_value_bg_winlose" );
	
	self.m_sym_jiayou = self.m_object:FindChildControl( "sym_jiayou" );
	self.m_ani_gradeBg_winlose = self.m_object:FindChildControl( "ani_gradeBg_winlose" );
	self.m_ani_grade_winlose = self.m_object:FindChildControl( "ani_grade_winlose" );
	self.m_ani_gradeEffect_winlose = self.m_object:FindChildControl( "ani_gradeEffect_winlose" );
	
	--self.m_bestDisBg = self.m_object:FindChildControl( "noname_4" );
	--self.m_curDisBg = self.m_object:FindChildControl( "noname_5" );
	self.m_btn_critical_diamond = self.m_object:FindChildControl( "btn_critical_diamond" );
	self.m_btn_critical_diamond:SetVisible( false );
	
	-- 2014.1.21 delete frame which named "star_carbox" ( i just hide it )
	self.m_object:FindChildControl( "star_carbox" ):SetVisible( false );
	--
	self.m_btn_video = self.m_object:FindChildControl( "btn_video2" );
	
	self.m_timeObj = self.m_object:FindChildControl( "text_high_score" );
	
	self.m_curTimeObj = self.m_object:FindChildControl( "text_current_score" );
	
	self.m_bg:SelectAnimation( "ani_cont", false, false );
	self.m_bg:PauseAnim( true, false );
	return 1;
end

function	winandlose:ShowTimeResult( bShow )
	local bShowDisObj = false;
	if bShow then
		bShowDisObj = false;
	else
		bShowDisObj = true;
	end

	--self.m_timeObj:SetVisible(bShow);
	--self.m_curTimeObj:SetVisible(bShow);
	--self.m_bestDisBg:SetVisible(bShowDisObj);
	--self.m_curDisBg:SetVisible(bShowDisObj);
end

function	winandlose:OnEaseInOver( object, name )
	local gift_index = datasave:GetLastGiftId();

	if gift_index == 1 then
		self.m_giftbox = self.m_uiMgr:GetPage("ThanksgivingGift");
		self.m_gift_index = 1;
	elseif gift_index == 2 then
		self.m_giftbox = self.m_uiMgr:GetPage("CoolGift");
		self.m_gift_index = 2;
	elseif gift_index == 3 then
		self.m_giftbox = self.m_uiMgr:GetPage("cargift");
		self.m_gift_index = 3;
	elseif gift_index == 4 then
		self.m_giftbox = self.m_uiMgr:GetPage("cargift1");
		self.m_gift_index = 4;
	elseif gift_index == 5 then
		self.m_giftbox = self.m_uiMgr:GetPage("cargift2");
		self.m_gift_index = 5;
	else
		self.m_giftbox = nil;
		self.m_gift_index = 0;
	end

	sGlobal:Print("OnEaseInOver id"..gift_index);

	-- test drive mode
	if levelinfo.m_Mode == 3 and self.m_bFirstTestDriver and levelinfo.m_testShip ~= nil and not self.m_DataMgr:IsBuyCar( levelinfo.m_testShip.name ) then
		local carsale = self.m_uiMgr:GetPage( "try_drive" );
		self.m_uiMgr:OpenDialog( carsale );
	elseif levelinfo.m_finishRank > 3 or levelinfo:IsFistLevel() then
		if self.m_giftbox ~= nil then
			self.m_giftbox:GetScript().m_pos = "winlose";
			self.m_uiMgr:OpenDialog(self.m_giftbox);
		else
			datasave:RefreshGift();

			gift_index = datasave:GetLastGiftId();
			
			if gift_index == 1 then
				self.m_giftbox = self.m_uiMgr:GetPage("ThanksgivingGift");
				datasave:SetGiftDone(1);
			elseif gift_index == 2 then
				self.m_giftbox = self.m_uiMgr:GetPage("CoolGift");
			elseif gift_index == 3 then
				self.m_giftbox = self.m_uiMgr:GetPage("cargift");
			elseif gift_index == 4 then
				self.m_giftbox = self.m_uiMgr:GetPage("cargift1");
			elseif gift_index == 5 then
				self.m_giftbox = self.m_uiMgr:GetPage("cargift2");
			else
				self.m_giftbox = nil;
				self.m_gift_index = 0;
			end

			if self.m_giftbox ~= nil then
				self.m_giftbox:GetScript().m_pos = "winlose";
				self.m_uiMgr:OpenDialog(self.m_giftbox);
			end
		end
	end
	self.m_bg:ClearAnimOverEvent();
end

function	winandlose:EventActive( object, param0, param1 )
	self:Reset();
	Global:StopMusic();

	if levelinfo.m_finishRank > 3 then
		Global:SystemRequest( SystemEvent.SE_GAME_LOSE );
		m_showType = SHOW_LOSE;
	else
		Global:SystemRequest( SystemEvent.SE_GAME_WIN );
		m_showType = SHOW_WIN;
	end

	self.m_bg:SelectAnimation( "ani_cont", false, false );
	self.m_bg:SetAnimOverEvent( self, self.OnEaseInOver );
	self.m_bg:PauseAnim( false, false );
	self.m_DataMgr = Global:GetDataMgr();
	self.m_bFirstClickRestart = true;
	
	self.m_giftbox = self.m_uiMgr:GetPage("giftbox");

	if channel.m_bEnableRank then
		self.m_btn_rank_winlose:SetVisible( true );
	else
		self.m_btn_rank_winlose:SetVisible( false );
	end
	if channel:IsVipEnabled() then
		self.m_object:FindChildControl("text_vipbonus"):SetVisible(true);
		self.m_object:FindChildControl("dot_nmoney_5"):SetVisible(true);
		self.m_object:FindChildControl("dt_vipbonus"):SetVisible(true);
	else
		self.m_object:FindChildControl("text_vipbonus"):SetVisible(false);
		self.m_object:FindChildControl("dot_nmoney_5"):SetVisible(false);
		self.m_object:FindChildControl("dt_vipbonus"):SetVisible(false);
	end
	if channel.m_bEnableFreeDiamond then
		self.m_btn_free_winlose:SetVisible( true );
	else
		self.m_btn_free_winlose:SetVisible( false );
	end
	
	if channel.m_EnableShowShop then
		self.m_object:FindChildControl( "btn_to_shop_3" ):SetVisible( true );
		--self.m_object:FindChildControl( "btn_to_shop_2" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_to_shop_3" ):SetVisible( false );
		--self.m_object:FindChildControl( "btn_to_shop_2" ):SetVisible( false );
	end
	
	if channel.m_bShowMoreGame then
		self.m_object:FindChildControl( "btn_win_lose" ):SetVisible( true );
	else
		self.m_object:FindChildControl( "btn_win_lose" ):SetVisible( false );
	end
	
	local rank = self.m_uiMgr:GetPage( "Track" ):GetScript():GetRanking();
	local model = self.m_DataMgr:GetModel();
	self.m_bShowFight = false;
	self.m_btn_video:SetVisible( false );
		
	self.m_textWinLose:SetVisible( false );
	self.m_text_title:SetVisible( true );
	if levelinfo.m_Mode ~= 1 then 
		self:ShowTimeResult( true );
		Global:Print("*******show ShowTimeResult")
		self.m_rankingBg:SetVisible(true);
	else
		Global:Print("*******not show ShowTimeResult")
		self:ShowTimeResult( false );
		self.m_rankingBg:SetVisible(false);
	end
	self.m_object:FindChildControl( "curRanking_1" ):SetSymbol( self.m_numSymbol[rank+1] );

	if rank <= 3 then
		if not levelinfo:IsFistLevel() then
			if channel.m_curChannel ~= "android_yyc" then
				datasave:UnlockTrack( self.m_DataMgr:GetLevel() + 1 );
			end
			Save();
		end
		
		self.m_btn_critical_diamond:SetVisible( false );
		if channel.m_bShowCommentBtn and not datasave:IsComment() then
			--self.m_btn_critical_diamond:SetVisible( true );
			self.m_btn_critical_diamond:SelectAnimation( "ani_pl", true, true );
		end
	end
	
	if rank <= 3 then
		self.m_btn_nextLevel:SetVisible( true );
		self.m_btn_restart:SetVisible( false );
		
		local bNextLevelEnable = self.m_uiMgr:GetPage( "chosetrack" ):GetScript():IsNextLevelEnable();
		self.m_btn_nextLevel:GetScript():EnableButton( bNextLevelEnable );
		
		-------
		self.m_sym_jiayou:SetVisible( false );
		self.m_ani_gradeBg_winlose:SetVisible( true );
		self.m_ani_grade_winlose:SetSymbol( self.gradeSym[rank] );
		if self.m_bShowGradeAni then
			if rank == 1 then
				self.m_ani_gradeEffect_winlose:SetVisible( true );
			else
				self.m_ani_gradeEffect_winlose:SetVisible( false );
			end
			
			self.m_ani_grade_winlose:SelectAnimation( "ani_toplv", false, true );
			self.m_ani_grade_winlose:PauseAnim( false, true );
			self.m_bShowGradeAni = false;
			Global:PlaySound( uisound.ui_top3, 0 );
		end
		----------
	else
		if levelinfo:IsFistLevel() then
			self.m_btn_nextLevel:SetVisible( true );
			self.m_btn_restart:SetVisible( false );
		else
			self.m_btn_nextLevel:SetVisible( false );
			self.m_btn_restart:SetVisible( true );
		end
		self.m_sym_jiayou:SetVisible( true );
		self.m_bShowFight = true;
		self.m_ani_gradeBg_winlose:SetVisible( false );
		
		Global:PlaySound( uisound.ui_late3, 0 );
	end
	
	local title = rank;
	if title > 5 then
		title = 5;
	end
	
	self.m_text_title:SetSymbol( self.m_titleName[title] );
	
	self.m_start[1]:SetVisible( true );
	self.m_start[2]:SetVisible( true );
	self.m_start[3]:SetVisible( true );
	local baseReward = levelinfo:GetLevelReward(self.m_DataMgr:GetLevel(), 4-rank);--45000 + self.m_DataMgr:GetLevel() * 5000;
	if title == 1 then

	elseif title == 2 then
		self.m_start[3]:SetVisible( false );
	elseif title == 3 then
		self.m_start[2]:SetVisible( false );
		self.m_start[3]:SetVisible( false );
	else
		self.m_start[1]:SetVisible( false );
		self.m_start[2]:SetVisible( false );
		self.m_start[3]:SetVisible( false );
	end
	Global:Print("WinLose:Show resusout:baseReward:"..baseReward.."  bonus:"..VipData[datasave:GetVipLevel()][2]);
	if channel:IsVipEnabled() then
		local vipbonus = math.floor(baseReward*VipData[datasave:GetVipLevel()][2]);
		self.m_object:FindChildControl("dt_vipbonus"):SetSymbolText(vipbonus);
	end
	self.m_text_reward:SetSymbolText( math.floor( baseReward ) );

	if exl_level_data[levelinfo.m_curLevelID].m_Mode ~= 1 then
		-- minTime
		local minTime = record_level.levels[levelinfo.m_curLevelID].time;
		
		sGlobal:Print("WinLose level"..levelinfo.m_curLevelID);
		self.m_bFirstTestDriver = false;
	
		if minTime ~= 0.0 then
			self.m_timeObj:SetSymbolText( TimeToString(minTime) );
		else
			self.m_bFirstTestDriver = true;
			self.m_timeObj:SetSymbolText( "--:--:--" );
		end
	
		-- curtime
		local curTime = levelinfo.m_finishTime;
		self.m_curTimeObj:SetSymbolText( TimeToString(curTime) );

		if not levelinfo:IsFistLevel() then
			if minTime > curTime or minTime == 0 then
				record_level.levels[levelinfo.m_curLevelID].time = curTime;
				Global:Print("Time new Record!!!:"..record_level.levels[levelinfo.m_curLevelID].time)
			end
			if rank < record_level.levels[levelinfo.m_curLevelID].rank then
				record_level.levels[levelinfo.m_curLevelID].rank = rank;
			end
		end
	else
		-- best dis
		local maxDis = record_level.levels[levelinfo.m_curLevelID].dist;
		Global:Print("maxDis:"..record_level.levels[levelinfo.m_curLevelID].dist);

		maxDis = math.floor(maxDis);
		if maxDis ~= 0.0 then
			self.m_timeObj:SetSymbolText(""..maxDis);
		else
			self.m_timeObj:SetSymbolText("--");
		end
		-- best dis
		
		-- cur dis
		local curDis = math.floor(levelinfo.m_finishDist);
		sGlobal:Print( "cur dis : "..curDis );
		if curDis < 0 then
			curDis = 0;
		end
		self.m_curTimeObj:SetSymbolText(""..curDis);

		-- cur dis
		if not levelinfo:IsFistLevel() then
			if maxDis < curDis or maxDis == 0 then
				record_level.levels[levelinfo.m_curLevelID].dist = curDis;
				Global:Print("Dist new Record!!!:"..record_level.levels[levelinfo.m_curLevelID].dist);
			end
			if rank < record_level.levels[levelinfo.m_curLevelID].rank then
				record_level.levels[levelinfo.m_curLevelID].rank = rank;
			end
		end
	end

	record_level:Save();
	self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
	return 1;
end 

function	winandlose:EnableShowGradeAni( bEnable )
	self.m_bShowGradeAni = bEnable;
end

function	winandlose:Update( duration )
	local dataMgr = Global:GetDataMgr();
	local gold = dataMgr:GetItemNum(ITEM_GOLD);
	self.m_textGold:SetSymbolText( gold );
	local model = self.m_DataMgr:GetModel();
	if model ~= RACING then
		if self.m_showType == SHOW_WIN then
			self.m_btn_refix_winlose:SetVisible( false );
		else
			if self.m_DataMgr:GetRefitTimes( self.m_DataMgr:GetCurCar() ) >= 1 then
				self.m_btn_refix_winlose:SetVisible( false );
			else
				self.m_btn_refix_winlose:SetVisible( true );
			end
		end
	else
		local rank = self.m_uiMgr:GetPage( "Track" ):GetScript():GetRanking();
		
		if levelinfo:IsFistLevel() then
			self.m_btn_refix_winlose:SetVisible( false );
		else
			if rank <= 3 or levelinfo.m_Mode == 3 then
				self.m_btn_refix_winlose:SetVisible( false );
			else
				if self.m_DataMgr:GetRefitTimes( self.m_DataMgr:GetCurCar() ) >= 1 then
					self.m_btn_refix_winlose:SetVisible( false );
				else
					self.m_btn_refix_winlose:SetVisible( true );
				end
			end
		end
	end
	
	if self.m_btn_refix_winlose:IsVisible() then
		if channel.m_EnableRefixByIap then
			self.m_object:FindChildControl( "fk_gold_winlose" ):SetVisible( false );
			
			if channel.m_EnableShowRefixPrice then
				self.m_object:FindChildControl( "rmb2_4_1" ):SetVisible( true );
				self.m_object:FindChildControl( "rmb2_4_1" ):SetSymbol( "rmb2" );
			else
				self.m_object:FindChildControl( "rmb2_4_1" ):SetVisible( false );
			end
		else
			self.m_object:FindChildControl( "fk_gold_winlose" ):SetVisible( true );
			local curID = self.m_uiMgr:GetPage( "choosecar" ):GetScript():GetCarID();
			self.m_object:FindChildControl( "rmb2_4_1" ):SetSymbolText( math.floor(property_car:GetUpgradePrice( curID )) );
		end
	end
	
	-- if self.m_ani_gradeEffect_winlose:IsVisible() then
		-- self.m_gradeEffectTime = self.m_gradeEffectTime - duration;
		-- if self.m_gradeEffectTime <= 0.0 then
			-- self.m_ani_gradeEffect_winlose:SetVisible( false );
		-- end
	-- end
	
	if channel.m_bEnableFreeDiamond then
		if self.m_bShowFight then
			if Global:SystemRequest( SystemEvent.SE_VIDEO_AVAILABLE ) then
				self.m_sym_jiayou:SetVisible( false );
				self.m_btn_video:SetVisible( true );
			else
				self.m_sym_jiayou:SetVisible( true );
				self.m_btn_video:SetVisible( false );
			end
		end
		local num = 0;
		if Global:SystemRequest( SystemEvent.SE_INTERNET ) then
			if not datasave:IsLikeFaceBook() then
				num = num + 1;
			end
			
			if not datasave:IsLikeTwitter() then
				num = num + 1;
			end
		end
		
		if Global:SystemRequest( SystemEvent.SE_VIDEO_AVAILABLE ) then
			num = num + 1;
		end
		
		self.m_free_value_winlose:SetSymbolText( num );
		if num > 0 then
			self.m_free_value_bg_winlose:SetVisible( true );
		else
			self.m_free_value_bg_winlose:SetVisible( false );
		end
	end
end

function	winandlose:Event_To_Shop_Click( object, param0, param1 )
	sGlobal:Print( "Event_To_Shop_Click" );
	if channel.m_EnableShowShop then
		if channel.m_bEnableAd then
			--sGlobal:Print( "loading:EventActive === SE_HIDE_AD" );
			Global:SystemRequest( SystemEvent.SE_HIDE_AD );
			Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
		end
		self.m_uiMgr:GetPage( "shop" ):GetScript():WinLoseToShop();
		ClosePage( "winlosebox" );
		ShowPage( "shop" );
		
		Global:PlaySound(uisound.btn_To_Shop,0);
	end
	return 1;
end

function	winandlose:Event_Return_Click( object, param0, param1 )
	if channel.m_bEnableAd and not datasave:IsBuyIapMoreThan30() then
		--sGlobal:Print( "loading:EventActive === SE_HIDE_AD" );
		Global:SystemRequest( SystemEvent.SE_HIDE_AD );
		Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
	end
	ClosePage( "winlosebox" );
	ShowPage( "choosecar" );
	Global:EndLevel();
	self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
	Global:PlaySound(uisound.btn_return,0);
	
	Global:StopMusic();
	Global:PlayMusic( uisound.ui_music, -1 );
	return 1;
end

function	winandlose:IsNeedGiftAircraft()
	local need = channel.m_bGiftAircraft and self.m_DataMgr:GetLevel() > 1 and not datasave:IsIap();
	return need;
end

function	winandlose:Event_Retart_Click( object, param0, param1 )
	--if self:IsNeedGiftAircraft() and self.m_bFirstClickRestart then
	--	self.m_bFirstClickRestart = false;
	--	ShowDialog( "sendfly" );
	--	return 1;
	--end
	if channel.m_bEnableAd then
		--sGlobal:Print( "loading:EventActive === SE_HIDE_AD" );
		Global:SystemRequest( SystemEvent.SE_HIDE_AD );
		Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
	end

	Global:EndLevel();
	self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
	ClosePage( "winlosebox" );
	self.m_uiMgr:GetPage( "chosetrack" ):GetScript():StartGame( true );
	Global:PlaySound(uisound.winlose_btn_restart,0);
	return 1;
end

function	winandlose:Event_NextLevel_Click( object, param0, param1 )
	Global:PlaySound(uisound.winlose_btn_nextlevel,0);

	--if not self.m_DataMgr:IsBuyCar( property_car:GetName( 2 ) ) and self.m_gift_index == 1 then
	--	self.m_bGiftAircraft = false;
	--	ShowDialog( "giftbox" );
	--	return 1;
	--end

	if channel.m_bEnableAd then
		--sGlobal:Print( "loading:EventActive === SE_HIDE_AD" );
		Global:SystemRequest( SystemEvent.SE_HIDE_AD );
		Global:SystemRequest( SystemEvent.SE_GAME_RESUME );
	end
	
	if levelinfo:IsFistLevel() then
		Global:EndLevel();
		ClosePage( "winlosebox" );
		ClosePage( "Track" );
		ShowPage( "choosecar" );
	else
		local nextLv = self.m_DataMgr:GetLevel() + 1;
		self.m_uiMgr:GetPage( "Track" ):GetScript():EndLevel();
		if datasave:IsTrackUnlock( nextLv ) then
			Global:EndLevel();
			ClosePage( "winlosebox" );
			-- change by vincent
			ClosePage( "Track" );
			datasave:SetRacingSelectTrackID( nextLv );
			self.m_DataMgr:SetLevel( nextLv );
			ShowPage( "choosecar" );

			--self.m_uiMgr:GetPage( "chosetrack" ):GetScript():NextLevel();
		else
			ShowDialog( "the6" );
		end
	end
	return 1;
end

function	winandlose:Reset()
	self.m_bResponGradeAniOver = true;
	self.m_sym_jiayou:SetVisible( false );
	self.m_ani_gradeBg_winlose:SetVisible( false );
	self.m_ani_gradeEffect_winlose:SetVisible( false );
end


function 	winandlose:Control_Event( object, param0, param1 )
	ClosePage( "attion_box" );
	return 1;
end

function winandlose:UnlockTrack_Event( object, param0, param1 )
	if object == "UNLOCK_TRACK" then
		OnStartPurchase( PCS_TRACK_UNLOCK, nil );
	end
	return 1;
end

function	winandlose:Event_More_Game( object, param0, param1 )
	OnMoreGameClick();
	return 1;
end

function	winandlose:Event_Comment_Click( object, param0, param1 )
	if not datasave:IsComment() then
		local dataMgr = Global:GetDataMgr();
		dataMgr:AddItemNum( ITEM_GOLD, 888888 );
		Global:PlaySound(uisound.buy_gold,0);
		datasave:Comment();
		Save();
		self.m_btn_critical_diamond:SetVisible( false );
	end
	return 1;
end

function	winandlose:Event_Refix_Car( object, param0, param1 )
	if self.m_DataMgr:IsBuyCar( self.m_DataMgr:GetCurCar() ) then
		if channel.m_EnableRefixByIap then
			OnStartPurchase( PCS_CAR_REFIT, nil );
		else
			local curID = self.m_uiMgr:GetPage( "choosecar" ):GetScript():GetCarID()
			local upPrice = math.floor(property_car:GetUpgradePrice( curID ));
			if upPrice > 0 and self.m_DataMgr:GetItemNum( ITEM_GOLD ) >= upPrice then
				self.m_uiMgr:GetPage( "choosecar" ):GetScript():RefitCar();
				self.m_DataMgr:AddItemNum( ITEM_GOLD, -upPrice );
			else
				Global:PlaySound(uisound.nomoney,0);
				ShowDialog( "nomoneytip" );
			end
		end
		--self.m_uiMgr:GetPage( "upgrade" ):GetScript():WinLoseToRefix();
		--ShowDialog( "upgrade" );
	end
	return 1;
end

function	winandlose:Event_Grade_Ani_Over( object, param0, param1 )
	if self.m_bResponGradeAniOver and object == "ani_winlose_grade" then
		sGlobal:Print( "ani_winlose_grade" );
		self.m_gradeEffectTime = 1.0;
		local rank = self.m_uiMgr:GetPage( "Track" ):GetScript():GetRanking();
		if rank == 1 then
			self.m_ani_gradeEffect_winlose:SetVisible( true );
		else
			self.m_ani_gradeEffect_winlose:SetVisible( false );
		end
		
		self.m_ani_gradeEffect_winlose:SetSymbolEffect( "ui/dds/hit_phy.zdx" );
		self.m_bResponGradeAniOver = false;
		
		Global:PlaySound(uisound.ui_zhajinhua,0);
	end
	return 1;
end

function 	winandlose:Event_Rank_Click( object, param0, param1 )
	if channel.m_bEnableRank then
		ShowDialog( "ranking" );
	end
	return 1;
end

function	winandlose:Event_Free_Click( object, param0, param1 )
	ShowDialog( "freebox" );
	return 1;
end

function	winandlose:Event_Video_Click( object, param0, param1 )
	Global:SystemRequest( SystemEvent.SE_AD_WALL );
	return 1;
end

function 	winandlose:EventKeyUp( key_code )
	if key_code == 27 then
		self:Event_Return_Click( nil, 0, 0 );
	elseif key_code == 13 then
		if self.m_btn_restart:IsVisible() then
			self.m_object:FindChildControl( "btn_restart" ):SendMsg( "BN_CLICK", 0, 0 );
		elseif self.m_btn_nextLevel:IsVisible() then
			self.m_object:FindChildControl( "btn_nextLevel" ):SendMsg( "BN_CLICK", 0, 0 );
		end
	end
	return 1;
end

winandlose.ControlEvents = {
	Inputs = {
		btn_to_shop_1 = { "Event_To_Shop_Click" };
		--btn_to_shop_2 = { "Event_To_Shop_Click" };
		btn_to_shop_3 = { "Event_To_Shop_Click" };
		btn_winlose_return = { "Event_Return_Click" };
		btn_restart = { "Event_Retart_Click" };
		btn_nextLevel = { "Event_NextLevel_Click" };
		attion_box = { "Control_Event" };
		btn_win_lose = { "Event_More_Game" };
		btn_critical_diamond = { "Event_Comment_Click" };
		the6 = { "UnlockTrack_Event" };
		
		btn_refix_winlose = { "Event_Refix_Car" };
		btn_rank_winlose = { "Event_Rank_Click" };
		
		ani_grade_winlose = { "Event_Grade_Ani_Over" };
		
		win_lose_free = { "Event_Free_Click" };
		btn_video2 = { "Event_Video_Click" };
	}
}
